// 定位（获取位置的坐标gps）
function getLocationOfWechatOrApp(successCallback, errorCallback) {
    if (isWechatClient()) {
        if(!J.Cache.get('openId')){
            setTimeout(function(){
                getLocationOfWechat(successCallback, errorCallback);
            },1000);
            return;
        }
        getLocationOfWechat(successCallback, errorCallback);
    } else if(isAndroidIosApp()){
		getLocationOfApp(successCallback, errorCallback);
    } else {
        var lnglat = "118.86451721191406,32.04042434692383";
        // successCallback(lnglat);
        getLocationOfbrowser(successCallback, errorCallback);
    }
}

//  App获取地理位置
function getLocationOfApp(successCallback, errorCallback) {
	console.log('app定位');
	if(isIOS()) {
		console.log('app定位2');
		baidumap_location.getCurrentPosition(function(result) {}, function(error) {})
	}

////	 成功回调
//  var onSuccess = function(result) {
//  	console.log(JSON.stringify(position, null, 4));
//  	var positionMsg = JSON.stringify(result, null, 4);
//      var latitude = positionMsg.latitude;
//      var longitude = positionMsg.longitude;
//      var address = longitude + ',' + latitude;
//      console.log('app获取地理位置');
//      getCommunityByGPS_service(address, successCallback);
//  };
//
//  // 失败回调
//  var onError = function(err) {
//      var data = {
//          id: 1,
//          name: '奥体',
//          type: 0
//      };
//      J.Cache.save('community', data);
//      successCallback();
//  };
//
//	baidumap_location.getCurrentPosition(onSuccess, onError);

    // 成功回调
    var onSuccess = function(position) {
        console.log('app获取定位成功');
        // J.Cache.save('position',true);
        console.log(position);
        var longitude = position.coords.longitude;
        var latitude = position.coords.latitude;
        var address = longitude + ',' + latitude;
        console.log('app获取地理位置');
        console.log(address);
        successCallback(address);
    };
    // 失败回调
    var onError = function(err) {
        console.log('获取定位失败');
    	console.warn('ERROR(' + err.code + '): ' + err.message);
    	errorCallback();
    };
    var options = { 
        maximumAge: 3000, 
        timeout: 30000, 
        enableHighAccuracy: true 
    };
    setTimeout(function() {
        console.log('获取定位的插件');
	    navigator.geolocation.getCurrentPosition(onSuccess, onError, options);
    }, 500);
}

// Wechat获取地理位置
function getLocationOfWechat(successCallback, errorCallback) {
    console.log('微信定位');
    // 获取jssdk配置信息
    getJSSDKConfigParams_service();
    wx.ready(function() {
        wx.getLocation({
            type: 'wgs84', // 默认为wgs84的gps坐标，如果要返回直接给openLocation用的火星坐标，可传入'gcj02'
            success: function(res) {
                console.log(res);
                var longitude = res.longitude; // 经度，浮点数，范围为180 ~ -180。
                var latitude = res.latitude; // 纬度，浮点数，范围为90 ~ -90
                var address = longitude + ',' + latitude;
                console.log(address);
                successCallback(address);
            },
            fail: function(err) {
                console.log(err);
                console.log(new Date().getMinutes() + '-' + new Date().getSeconds());
                errorCallback(err);
                if(!J.Cache.get('isLocation')) {
                    J.Cache.save('isLocation',1);
                    firstRelocation();
                } else {
                    if(J.Cache.get('isLocation').data >= 5) return;
                    var num = J.Cache.get('isLocation').data + 1;
                    J.Cache.save('isLocation', num);
                    firstRelocation();
                }
            }
        });
    });
}

// 浏览器定位
function getLocationOfbrowser(successCallback, errorCallback) {
    console.log('浏览器定位');
    AMap.plugin('AMap.Geolocation', function() {
        var geolocation = new AMap.Geolocation({
            enableHighAccuracy: true,//是否使用高精度定位，默认:true
            // timeout: 10000,          //超过10秒后停止定位，默认：5s
            // buttonPosition:'RB',    //定位按钮的停靠位置
            // buttonOffset: new AMap.Pixel(10, 20),//定位按钮与设置的停靠位置的偏移量，默认：Pixel(10, 20)
            // zoomToAccuracy: true,   //定位成功后是否自动调整地图视野到定位点

        });
        geolocation.getCurrentPosition(function(status,result){
            console.log(result)
            if(status=='complete'){
                onComplete(result)
            }else{
                onError(result)
            }
        });
    });
    //解析定位结果
    function onComplete(data) {
        console.log(data);
        var address = data.position.lng + ',' + data.position.lat;
        successCallback(address)
    }
    //解析定位错误信息
    function onError(data) {
        errorCallback(data)
    }
}

// gps坐标转高德
function gpsConvertFrom(lnglat, successCallback, errorCallback) {
    AMap.convertFrom(lnglat,'gps', function (status, result) {
        if (result.info === 'ok') {
            var resLnglat = [result.locations[0].lng, result.locations[0].lat];
            J.Cache.save("presentLnglat", resLnglat);
            successCallback(resLnglat);
        }else{
            errorCallback(result);
        }
    });
}

// 获取当前位置所属片区
function getServiceZone() {
    $('#nearestAddress').text('正在定位 . . .');
    if( J.Cache.get('address') && J.Cache.get('address').data){
        var addressTxt = J.Cache.get('address').data.address;
        $('#selectedAddress').text(addressTxt);
    }else{
        $('#selectedAddress').text('正在定位 . . .');
    }
    $('#nearestAddress').parent().attr('onclick','');
    $('#nearAddressPoint').html('');
    getLocationOfWechatOrApp(function(address) {
        convertFromAddress(address);
    }, function(err) {
        if(window.location.href.indexOf('#index_section') >= 0 || !window.location.href.split('index.html')[1]){
            $('.search_bar span.address-i').text('定位失败，手动切换');
            $('#shoppingCart_article header .shop-name').text('定位失败');
        }
        if(window.location.href.indexOf('#selectAddress_section') >= 0) {
            $('#nearestAddress').text('定位失败，请手动切换地址');
            $('#selectedAddress').text('定位失败，请手动切换地址');
        }
    })
}
//定位成功转高德坐标
function convertFromAddress(lnglat){
    // if(window.location.href.indexOf('#parking_section') < 0){
    //     if(!J.Cache.get('communities')){
    //         getCommunityList_service(1);//获取所有门店信息
    //     }
    // }
    AMap.convertFrom(lnglat,'gps', function (status, result) {
        if (result.info === 'ok') {
            var resLnglat = [result.locations[0].lng,result.locations[0].lat];
            J.Cache.save("presentLnglat", resLnglat);
            if(window.location.href.indexOf('#parking_section') < 0){
                // getDistance(resLnglat,function(){
                //     getAddressName(resLnglat)
                // });//找出最近门店
                getNewDistance(2,resLnglat,function(res){
                    getAddressName(res,resLnglat)
                })
            }
        }else{
            if(window.location.href.indexOf('#index_section') >= 0){
                $('.search_bar span.address-i').text('定位失败，手动切换');
                $('#shoppingCart_article header .shop-name').text('定位失败');
            }
        }
    });
}
var geocoder;
//正向地理编码
function getAddressLnglat(name,callback) {
    console.log("地理编码", name);
    if(!geocoder){
        geocoder = new AMap.Geocoder({
            // city: "025", //城市设为北京，默认：“全国”
            radius: 1000 //范围，默认：500
        });
    }
    geocoder.getLocation(name, function(status, result) {
        console.log(status);
        console.log(result);
        if (status === 'complete' && result.info === 'OK') {
            // result中对应详细地理坐标信息
            callback(result.geocodes[0].location);
        }else {
            J.showToast('抱歉，地址异常，请重新选择地址');
        }
    });
}

function getAddressName(nearestCommunity,lnglat) {
    console.log("逆地理编码", lnglat);
    // if(window.location.href.indexOf('#parking_section') < 0){
    //     getDistance(lnglat);//找出最近门店
    // }
    if(!geocoder){
        geocoder = new AMap.Geocoder({
            // city: "025", //城市设为北京，默认：“全国”
            radius: 1000, //范围，默认：500
            province: '江苏省,安徽省'
        });
    }
    geocoder.getAddress(lnglat, function(status, result) {
        if (status === 'complete'&&result.regeocode) {
            console.log(result);
            var address = result.regeocode.formattedAddress;
            var city = result.regeocode.addressComponent.city
            var data = {
                position: lnglat,
                address : address,
                city: city
            };
            J.Cache.save('formattedAddress',data);
            J.Cache.save('needRefresh',false);
            if(window.location.href.indexOf('#selectAddress_section') >= 0){
                if( !J.Cache.get('address')){
                    $('#selectedAddress').text(address);
                }
                $('#nearestAddress').text(address);
                $('#nearestAddress').parent().attr('onclick','saveAddress(this);');
                locationNear(lnglat);
            }
            if(!J.Cache.get('address') && window.location.href.indexOf('#selectAddress_section') < 0){
                if(J.Cache.get('community').data.id == nearestCommunity.id){
                    // 首页定位 当前片区和定位片区一致时 判断是否超距
                    if(window.location.href.indexOf('#index_section') >= 0 || (!window.location.href.split('index.html')[1] && isWechatClient())){
                        myCurrentPosition(data);
                    }
                }else{
                     // 当前片区和定位片区不一致时 提示用户
                    J.Popup.confirm4('提示', '根据您的定位信息，门店将切换至' + nearestCommunity.name + ',购物车将发生变化，是否继续？' , '取消', '继续', function () {
                        // 继续
                        J.Cache.save('needRefresh',true);
                        J.Cache.save('community', nearestCommunity);//保存片区
                        //切换地址、片区需要刷新“我的”页面用户的账户信息（例如优惠券<优惠券按片区加载>）
                        $('#userInfo_div').attr('data-refresh','true');
                        var addressInfo = {
                            address:address,
                            contact:'',
                            name:'',
                            id:'',
                            position:lnglat,
                            community: nearestCommunity.name,
                            communityId: nearestCommunity.id,
                            communityType: nearestCommunity.type,
                            city: nearestCommunity.city
                        };
                        J.Cache.save('address',addressInfo);//保存为收货地址
                        cartNum_service();
                        if(window.location.href.indexOf('#index_section') >= 0 || (!window.location.href.split('index.html')[1] && isWechatClient())){
                            if($($('#index_footer').children()[0]).hasClass('active') == false){
                                // 如果当前页面不在首页（分类、购物车）切换片区需刷新页面商品 每个页面都刷的话请求接口比较多 定为切换到首页刷新
                                // 切换到首页会触发articleshow的代码 不需要再调用myCurrentPosition方法
                                $($('#index_footer').children()[0]).trigger('click');
                            }else{
                                // 在首页
                                myCurrentPosition(data);
                            }
                        }else{
                            // 如果不在index_section页面（eg:商品详情等页面）直接跳转到首页
                            goIndexPage();
                        }
                    },function(){
                        // 取消
                        alreadyLocation = true;
                        $('.search_bar span.address-i').text('点击更改');
                    })
                }
            }
        }else{
            if(window.location.href.indexOf('#index_section') >= 0){
                console.log("逆地理编码失败");
                $('.search_bar span.address-i').text('定位失败，手动切换');
                $('#shoppingCart_article header .shop-name').text('定位失败');
            }
        }
    });
}

// 首页
function myCurrentPosition(address) {
    var currentCommunityName = J.Cache.get('community').data.name + '店';
    $('#currentCommunityName').text(currentCommunityName);
    $('.search_bar .communityDesc').text(J.Cache.get('community').data.communityDesc);
    if (J.Cache.get('address') && J.Cache.get('address').data) {
        console.log("有address");
        if(J.Cache.get('needRefresh') && J.Cache.get('needRefresh').data){
            homeRefresh = true;
            getHome_service();
            $('.search_bar span.address-i').text('送至：'+J.Cache.get("address").data.address);
            $('#shoppingCart_article header .shop-name').text(J.Cache.get("address").data.address);
        }
    } else {
        $('#shoppingCart_article header .shop-name').text(address.address);
        console.log("没有address");
        setTimeout(function(){
            //没有默认地址计算当前地址是否可配送
            var riding = new AMap.Riding({});
            var place = [Number(J.Cache.get('temporaryCommunity').data.place.split(',')[0]),Number(J.Cache.get('temporaryCommunity').data.place.split(',')[1])];
            riding.search(place,address.position,function(status,result){
                if(status == 'complete'){
                    if(result.routes[0].distance > J.Cache.get('community').data.radius){
                        //超距
                        J.showToast('当前位置超出' + J.Cache.get('temporaryCommunity').data.name.replace('附近','门店')  + '配送范围');
                        J.Cache.save('temporaryCommunity','');
                        $('.search_bar span.address-i').text('该位置不可配送，点击更改地址');
                    }else{
                        J.Cache.save('community', J.Cache.get('temporaryCommunity').data);//保存片区
                        //切换地址、片区需要刷新“我的”页面用户的账户信息（例如优惠券<优惠券按片区加载>）
                        $('#userInfo_div').attr('data-refresh','true');
                        var addressInfo = {
                            address:address.address,
                            contact:'',
                            name:'',
                            id:'',
                            position:address.position,
                            community:J.Cache.get('temporaryCommunity').data.name,
                            communityId:J.Cache.get('temporaryCommunity').data.id,
                            communityType:J.Cache.get('temporaryCommunity').data.type,
                            city: J.Cache.get('temporaryCommunity').data.city
                        };
                        J.Cache.save('address',addressInfo);//保存为收货地址
                        $('.search_bar span.address-i').text('送至：'+address.address);
                        getHome_service();
                    }
                }else {
                    //计算出错，默认不可配送
                    J.showToast('距离计算异常，请重新定位后重试');
                }
            });
        },800);
    }
}
//初始化关闭欢迎页面
function hideWelcome(){
    Jingle.Welcome.hide();
    firstRelocation();
}

// 实例化地图new
var map;
function newInstantiationMap() {
    console.log(map);
    if(map) return;
    var lnglat;
    var parameter = {
        zoom:14
    }
    if(J.Cache.get("presentLnglat")) {
        // 设置地图中心坐标
        parameter.center = J.Cache.get("presentLnglat").data;
    }
    console.log(parameter);
    AMapUI.loadUI(['misc/PositionPicker'], function(PositionPicker) {
        console.log(PositionPicker)
        if(!PositionPicker){
            console.log('调用UI库')
            initAMapUI(); //这里调用initAMapUI初始化
            map = undefined;
            newInstantiationMap();
            return;
        }
        map = new AMap.Map('container',parameter);
        map.plugin(["AMap.ToolBar"],function(){   //在地图中添加ToolBar插件
            toolBar = new AMap.ToolBar();
            map.addControl(toolBar);
        });
        addMarker();
        var positionPicker = new PositionPicker({
            mode: 'dragMap',
            map: map,
            iconStyle: { //自定义外观
                // url: 'http://webapi.amap.com/ui/1.0/assets/position-picker2.png',
                url: 'https://webapi.amap.com/theme/v1.3/markers/n/mark_r.png',
                ancher: [13,38],
                size: [25, 40]
            }
        });
        positionPicker.on('success', function(positionResult) {
            document.getElementById('positionResult').innerHTML = '';
            var data = {
                name:positionResult.nearestPOI,
                position:positionResult.position
            };
            J.Cache.save('positionResult',data);//拾取点坐标
            J.Cache.save('mapPoints',positionResult.regeocode.pois);//拾取点周围地标
            // J.showMask();
            // getDistance();//拾取点最近门店
            var nearPoints = [];
            var nearPoint = {};
            document.getElementById('positionResult').innerHTML =  '<p id="mapPoints00" onclick="saveAddress(this);">' + '<span style="color: #ff4d40;">[当前位置]</span><span class="searchAddressName">' + positionResult.nearestPOI + '</span><br><a>' + positionResult.address  + '</a></p>';
            nearPoint.point = [positionResult.position.lng,positionResult.position.lat];
            nearPoint.name = positionResult.nearestPOI;
            nearPoints.push(nearPoint);
            nearPoint = {};
            if(positionResult.regeocode.pois.length > 0){
                var length;
                if(positionResult.regeocode.pois.length >20){
                    length = 20;
                }else{
                    length = positionResult.regeocode.pois.length;
                }
                for(var i=0;i<length;i++){
                    document.getElementById('positionResult').innerHTML += '<p id="mapPoints' + i + '" onclick="saveAddress(this);"><span class="searchAddressName">' + positionResult.regeocode.pois[i].name + '</span><br><a>' + positionResult.regeocode.pois[i].address + '</a></p>';
                    nearPoint.point = [positionResult.regeocode.pois[i].location.lng,positionResult.regeocode.pois[i].location.lat];
                    nearPoint.name = positionResult.regeocode.pois[i].name;
                    nearPoints.push(nearPoint);
                    nearPoint = {};
                }
            }
        });
        positionPicker.on('fail', function(positionResult) {
            J.showToast('地点拾取失败');
        });
        positionPicker.start();


    });
}

//没有默认地址调用定位
function firstRelocation(){
    // 调用定位的方法
    if (J.Cache.get('address') && J.Cache.get('address').data != null) {
        $('.search_bar span.address-i').text('送至：'+J.Cache.get("address").data.address);
        $('#shoppingCart_article header .shop-name').text(J.Cache.get("address").data.address);
    }else{
        console.log('没有默认地址调用定位')
        getServiceZone();
    }
}
//搜索附近
function locationNear(point,keyword){
    AMap.service(["AMap.PlaceSearch"], function() {
        var placeSearch = new AMap.PlaceSearch({
            pageSize: 4,    // 每页4条
            pageIndex: 1,    // 获取第一页
            // city: '025' ,      // 指定城市名(如果你获取不到城市名称，这个参数也可以不传，注释掉)
            citylimit: true,  //是否强制限制在设置的城市内搜索
        });
        // 第一个参数是关键字，这里传入的空表示不需要根据关键字过滤　第二个参数是经纬度，数组类型
        // 第三个参数是半径，周边的范围　　第四个参数为回调函数
        if(!keyword || keyword == undefined){
            keyword = '';
        }
        placeSearch.searchNearBy(keyword, point, 5000, function(status, result) {
            J.Cache.save('fourPoints',result.poiList.pois);
            J.hideMask();
            if(result.info === 'OK') {
                var locationList = result.poiList.pois; // 周边地标建筑列表
                // 生成地址列表html
                if(locationList.length > 0){
                    var data = [];
                    for(var i=0;i<locationList.length;i++){
                        data.push(locationList[i].name);
                    }
                    J.Template.render("#nearAddressPoint", "nearAddressPoint_template", data, "replace");
                }
            } else {
                J.showToast('获取周边地标失败!');
            }
        });
    });
}
//画圆
function addCircle(center,radius){
    var circle = new AMap.Circle({
        center: center,// 圆心位置
        radius: radius, //半径
        strokeColor: "#1397fb", //线颜色
        strokeOpacity: 0.5, //线透明度
        strokeWeight: 1, //线粗细度
        fillColor: "#1397fb", //填充颜色
        fillOpacity: 0.1//填充透明度
    });
    circle.setMap(map);
}
// 实例化点标记
function addMarker() {
    var addresss = J.Cache.get('communitiesArry').data;
    for(var i=0;i<addresss.length;i++){
        var center = [addresss[i].split(',')[0],addresss[i].split(',')[1]]
        var marker = new AMap.Marker({
            map: map
        });
        marker.setPosition(center);//标记门店地址
        marker.setLabel({//label默认蓝框白底左上角显示，样式className为：amap-marker-label
            offset: new AMap.Pixel(20, 20),//修改label相对于maker的位置
            content: J.Cache.get('communities').data[i].name
        });
        // addCircle(center,J.Cache.get('communities').data[i].radius);
    }
}
//找出最近门店
function getDistance(address,callback){
    var riding = new AMap.Riding({});
    var countN = 0;
    var obj = {
        distance: 10000000000,
        address: ''
    };
    var nearestObj = {
        distance: 10000000000,
        address: ''
    };
    if(address){
        console.log(address);
        var par = {
            lon: address[0],
            lat: address[1]
        }
        getCommunityListByLonAndLat_control(par,address,callback);
    }else{
        var positionLng = J.Cache.get('positionResult').data.position.lng;
        var positionLat = J.Cache.get('positionResult').data.position.lat;
        $.each(addresss, function(i,item) {
            var lngLat = [Number(item.place.split(',')[0]),Number(item.place.split(',')[1])];//各门店经纬度
            riding.search([positionLng,positionLat],lngLat,function(status,result){
                countN += 1;
                if(status == 'complete'){
                    if(nearestObj.distance > result.routes[0].distance) {
                        //地图选址最近门店
                        nearestObj.distance = result.routes[0].distance;
                        nearestObj.address = item;
                    }
                    if(obj.distance > result.routes[0].distance) {
                        //地图选址不闭店片区的最近门店
                        if(!item.closeTimeSlot){
                            obj.distance = result.routes[0].distance;
                            obj.address = item;
                        }
                    }
                }
                if(countN == J.Cache.get('communities').data.length){
                    J.hideMask();
                    J.Cache.save('temporaryCommunity', obj.address);//保存临时片区
                    closeShopTip(obj,nearestObj);
                    if(callback){
                        callback();
                    }
                }
            });
        })
    }
}

// type: 1 手动选择门店 2.自动获取最近门店 address：地址信息
function getNewDistance(type,address,callback){
    if(address){
        console.log(address);
        var par = {
            lon: address[0],
            lat: address[1]
        }
        getCommunityListByLonAndLat_control(type,par,address,callback);
    }
}

function getCommunityListByLonAndLat_control(type,par,address,callback){
    var riding = new AMap.Riding({});
    var countN = 0;
    var length = 0;
    var communityLength = 0;  //可用的门店数量
    getCommunityListByLonAndLat(par,function(res){
        if(res && !isEmptyObject(res)){
            for(var i in res){
                var list = res[i];
                length += list.length;
                if(list.length > 0){
                    list.map(function(item){
                        var lngLat = [Number(item.place.split(',')[0]),Number(item.place.split(',')[1])];//各门店经纬度
                        item.picture = picNetworkPrefix(item.picture);
                        riding.search(address,lngLat,function(status,result){
                            countN += 1;
                            if(status == 'complete'){
                                item.distance = result.routes[0].distance;
                            }
                            if(countN == length){ //查询距离结束
                                J.hideMask();
                                // var nearestObj = {}; // 可用门店合集
                                var nearestArry = []; // 可用门店合集
                                var arr1 = [];
                                var arr2 = [];
                                var community = {}; // 最近门店
                                for(var j in res){
                                    var arry = res[j];
                                    // nearestObj[j] = [];
                                    if(arry.length > 0){
                                        arry.map(function(item,i){
                                            if(item.distance <= item.radius){
                                                communityLength += 1;
                                                // nearestObj[j].push(item);
                                                if(i <= 4){
                                                    arr1.push(item);
                                                }else{
                                                    arr2.push(item);
                                                }
                                            }
                                        })
                                    }
                                }
                                nearestArry = arr1.concat(arr2);
                                console.log(nearestArry);
                                if(communityLength > 0){
                                    if(type == 1){ // 手动选择门店 弹框
                                        toggleCommunityModal(nearestArry,callback);
                                    }else{ // 自动获取最近门店
                                        var minDis = nearestArry[0].distance;
                                        community = nearestArry[0];
                                        nearestArry.map(function(item){
                                            if(item.distance <= minDis){
                                                minDis = item.distance;
                                                community = item;
                                            }
                                        })
                                        if(callback){
                                            J.Cache.save('temporaryCommunity','community');
                                            callback(community);
                                            
                                        }
                                    }
                                    
                                }else{
                                    J.showToast('当前地址附近暂未开通可线上配送的门店');
                                    return;
                                }
                            }
                        });
                    })
                }
            }
            if(length == 0){
                J.hideMask();
                J.showToast('当前地址附近暂未开通可线上配送的门店');
                return;
            };
        }else {
            J.hideMask();
            J.showToast('当前地址附近暂未开通可线上配送的门店');
            return;
        }
    },function(err){
        J.hideMask();
        J.showToast('当前地址附近暂未开通可线上配送的门店');
        return;
    })
}

function toggleCommunityModal(data,callback){
    console.log('CommunityModal',data);
    J.Template.render("#toggleCommunity_div", "toggleCommunity_template", data, "replace");

    $('.toggleCommunityBox').addClass('active');
    $('.toggleCommunity-item').unbind('click').click(function() {
        var id = this.dataset.id;
        console.log(id);
        var temporaryCommunity = {};
        data.map(function(item){
            if(item.id == id){
                J.Cache.save('temporaryCommunity', item);//保存临时片区
                $('.toggleCommunityBox').removeClass('active');
                temporaryCommunity = item;
            };
        })
        if(callback){
            callback(temporaryCommunity);
        }
    })

};

function communityModalCallback(res,position){
    console.log(res,position);

    var addressInfo = {};
    //切换地址、片区需要刷新“我的”页面用户的账户信息（例如优惠券<优惠券按片区加载>）
    $('#userInfo_div').attr('data-refresh','true');

    J.Cache.save('community', res);//保存片区
    addressInfo = {
        address:position.addressPosition,
        contact:'',
        name:'',
        id:'',
        position:position.lngLat,
        community:J.Cache.get('community').data.name,
        communityId:J.Cache.get('community').data.id,
        communityType:J.Cache.get('community').data.type,
        city: J.Cache.get('community').data.city
    };
    J.Cache.save('address', addressInfo);

    if(window.location.href.indexOf('#selectAddress_section') >= 0) {
        $('#selectedAddress').text(J.Cache.get('address').data.address);
    }
    history.go(-1);
    setTimeout(function() {
        if(window.location.href.indexOf('#newAddress_section')>=0){
            $('#receiverAddress').val(position.addressPosition);
            $('#receiverAddress_form').attr('data-change', 'isChange');
            return;
        } else if (window.location.href.indexOf('#index_section')>=0){
            cartNum_service();
            $($('#index_footer').children()[0]).addClass('active').siblings().removeClass('active');
            $('#home_article').addClass('active').siblings().removeClass('active');
        } else{
            cartNum_service();
            J.Router.goTo('#index_section');
            $($('#index_footer').children()[0]).addClass('active').siblings().removeClass('active');
            $('#home_article').addClass('active').siblings().removeClass('active');
        }
    },100)
}

//片区选择弹框---搜索片区
function getCommunityModal_control(val){
    console.log(val);
    $('.toggleCommunity-item').each(function(){
        var text = $(this).children('p').text();
        if(text.indexOf(val)>=0){
            $(this).removeClass('none');
        }else{
            $(this).addClass('none');
        }
    })
}

// 地图选址时闭店提示
function closeShopTip(obj,nearestObj){
    var communities = J.Cache.get('communities').data;
    communities.map(function(item){
        if(item.id == obj.address.id){
            if(obj.distance > item.radius){
                if(nearestObj.address.id == obj.address.id){
                    var tips = '当前位置超出' + item.name.replace('附近','门店') + '配送范围';
                }else{
                    // var tips = nearestObj.address.name.replace('附近','门店') + nearestObj.address.closeTimeSlot + '期间'+
                    // nearestObj.address.closeShopRemark + '闭店，且当前位置超出' + item.name.replace('附近','门店') + '配送范围';
                    var tips = nearestObj.address.name.replace('附近','门店') +
                    nearestObj.address.closeShopRemark + '且当前位置超出' + item.name.replace('附近','门店') + '配送范围';
                }
                J.showToast(tips);
            }else{
                // if(item.closeTimeSlot){
                //     J.showToast(item.name.replace('附近','门店') + item.closeTimeSlot + '期间' + item.closeShopRemark);
                //     $('#positionResult p').css('color','#aaa').attr('onclick','J.showToast("' + item.name.replace('附近','门店') + '盘点，无法选择")');
                // }
            }
        }
    });
}
//选择地址
function goSelectAddress(){
    submitChange = false;
    J.Router.goTo('#selectAddress_section');
}
// 选择地址页面点击展开历史地址
function moreAddressOwn() {
    $('#moreAddressIcon i').toggleClass('active');
    if($('#moreAddressIcon i').hasClass('active')){
        $('#addressOwn li.hide').show();
        // $('#moreAddressIcon span').addClass('none')
    }else{
        $('#addressOwn li.hide').hide();
        // $('#moreAddressIcon span').removeClass('none');
    }
}
//地理编码   判断骑行
function geocoding(position,ele){
    var point = position.lngLat;
    var riding = new AMap.Riding({});
    var place = [Number(J.Cache.get('temporaryCommunity').data.place.split(',')[0]),Number(J.Cache.get('temporaryCommunity').data.place.split(',')[1])];
    if(point == ''){
        riding.search([
            {keyword: J.Cache.get('temporaryCommunity').data.communityRealAddress,city:'南京'},
            {keyword: position.addressPosition,city:'南京'}
        ],function(status,result){
            ridingCallBack(status,result,ele,position);
        });
    }else {
        riding.search(place,point,function(status,result){
            ridingCallBack(status,result,ele,position);
        });
    }
}
//骑行回调
function ridingCallBack(status,result,ele,position){
    J.hideMask();
    if(status == 'complete'){
        console.log(result.routes[0].distance)
        if(result.routes[0].distance > J.Cache.get('temporaryCommunity').data.radius){
            J.showToast('超出'+J.Cache.get('temporaryCommunity').data.name.replace('附近','门店') + '配送范围');
            $(ele).find('span.searchAddressName').css('color','#aaa');
            return;
        }else{
            if(J.Cache.get('temporaryCommunity').data.id != J.Cache.get('community').data.id){
                // J.Popup.confirm4('提示', '将切换至' + J.Cache.get('temporaryCommunity').data.name + '，是否继续？' , '取消', '继续', function () {
                //     // 继续
                    J.Cache.save('selectPosition',position);    //手动选定的位置
                    J.Cache.save('community', J.Cache.get('temporaryCommunity').data);//保存片区
                    //切换地址、片区需要刷新“我的”页面用户的账户信息（例如优惠券<优惠券按片区加载>）
                    $('#userInfo_div').attr('data-refresh','true');
                    var addressInfo = {
                        address:position.addressPosition,
                        contact:'',
                        name:'',
                        id:'',
                        position:position.lngLat,
                        community:J.Cache.get('community').data.name,
                        communityId:J.Cache.get('community').data.id,
                        communityType:J.Cache.get('community').data.type,
                        city: J.Cache.get('community').data.city
                    };
                    J.Cache.save('address', addressInfo);
                    if(window.location.href.indexOf('#selectAddress_section') >= 0) {
                        cartNum_service();
                        $('#selectedAddress').text(J.Cache.get('address').data.address);
                    }
                    // 更多地址 ---> 地图页面选址时切换片区 跳首页 需要更新购物车数量
                    if(J.Cache.get('select') && J.Cache.get('select').data == 'true'){
                        cartNum_service();
                        J.Router.goTo('#index_section');
                        $($('#index_footer').children()[0]).addClass('active').siblings().removeClass('active');
                        $('#home_article').addClass('active').siblings().removeClass('active');
                        J.Cache.save('select','false');
                        return;
                    }
                    history.go(-1);
                    setTimeout(function(){
                        // if(J.Cache.get('labelId') && J.Cache.get('labelId').data != null){
                        //     $('#newAddress_section form div:last-child').css('display','none');
                        // }
                        if(window.location.href.indexOf('#newAddress_section')>=0){
                            $('#receiverAddress').val(position.addressPosition);
                            $('#receiverAddress_form').attr('data-change', 'isChange');
                        }else if(window.location.href.indexOf('#index_section')>=0){
                            return;
                        }else {
                            J.Router.goTo('#index_section');
                            $($('#index_footer').children()[0]).addClass('active').siblings().removeClass('active');
                            $('#home_article').addClass('active').siblings().removeClass('active');
                        }
                    },1000);
                // }, function () {
                //     // 取消
                //     return;
                // });
            }else {
                J.Cache.save('selectPosition',position);    //手动选定的位置
                var addressInfo = {
                    address:position.addressPosition,
                    contact:'',
                    name:'',
                    id:'',
                    position:position.lngLat,
                    community:J.Cache.get('community').data.name,
                    communityId:J.Cache.get('community').data.id,
                    communityType:J.Cache.get('community').data.type,
                    city: J.Cache.get('community').data.city
                };
                J.Cache.save('address', addressInfo);
                if(J.Cache.get('select') && J.Cache.get('select').data == 'true'){
                    J.Router.goTo('#index_section');
                    $($('#index_footer').children()[0]).addClass('active').siblings().removeClass('active');
                    $('#home_article').addClass('active').siblings().removeClass('active');
                    J.Cache.save('select','false');
                    return;
                }
                history.go(-1);
                setTimeout(function(){
                    // if(J.Cache.get('labelId') && J.Cache.get('labelId').data != null){
                    //     $('#newAddress_section form div:last-child').css('display','none');
                    // }
                    if(window.location.href.indexOf('#newAddress_section')>=0){
                        $('#receiverAddress').val(position.addressPosition);
                        $('#receiverAddress_form').attr('data-change', 'isChange');
                    }else {
                        J.Router.goTo('#index_section');
                        $($('#index_footer').children()[0]).addClass('active').siblings().removeClass('active');
                        $('#home_article').addClass('active').siblings().removeClass('active');
                    }
                },1000);
            }
        }
        return ;
    }else {
        //默认不可配送
        J.showToast('距离计算异常，请重新选择后重试');
    }
}
//返回顶部
function goToTop(id){
    document.getElementById(id).scrollTop = 0;
    document.getElementById(id).style.transform = 'translate(0px, 0px) scale(1) translateZ(0px)';
}
// 首页、自定义返回顶部处理竖横幅的scrollTop
function verticalToTop(id){
    // if(J.Cache.get('verticalEnd')){
    //     $('#' +id + ' .verticalBannerList.active').scrollTop(0); 
    // }
    // if(J.Cache.get('verticalListData')){
    //     $('#' +id + ' .verticalBannerList.active').scrollTop(0); 
    // }
    document.getElementById(id).scrollTop = 0;
}

var scrollImg = '';
var scrollSearch = '';
var topBgImgShow = true;
var firstTopBg = true;
// 获取主页
function getHome_control(data) {
    var communityId;
    //首页背景色自定义;
    if(!isNullString(data.bgColor)){
        $('#home_article article').css('background',data.bgColor);
        $('#home_article article').css('background-size', '100%');
        $('#home_article article').css('background-repeat', 'no-repeat');
    }
    if(!isNullString(data.topBgImg)){
        if (firstTopBg) {
            $('#home_article>header').css('background',data.topBgImg);
            $('#home_article>header').css('background-size', '100%');
            $('#home_article>header').css('background-repeat', 'no-repeat');
        }
    }
    var topBg = {
        topBgColor: data.topBgColor,
        topBgImg: data.topBgImg
    }
    J.Cache.save('topBg', topBg);
    //领券更省自定义
    if (firstTopBg) {
        var src = picNetworkPrefix(data.couponPic) || './img/couponLogo.gif'
        var toCouponHtml = '<img src='+src+' alt="">'
        $('#toCouponList').html(toCouponHtml)
        firstTopBg = false;
    }
    // 刷新首页
    if(homeRefresh) {
        $('#home_div').empty();
        $('#home_div').addClass('homeFoldUp');
        window.clearInterval(secKillGoodsInterval);
        $("#classification_article").children('header').attr('value', true); //分类是否刷新显示
    }else {
        return;
    }
    // 下雪特效
    if(data.snowflake_effects_switch == 1){
        getsnow();
        setTimeout(function() {
            $('.snow').remove();
            clearInterval(snowInterval);
        }, 10000);
    }
    J.Cache.empty("homeVerticalListData");
    J.Cache.empty("verticalEnd");
    J.Cache.empty('homeNavBarCache');
    J.Cache.empty('homeVerticalType');
    $('#banner_back').removeClass('isHoliday hasScene');
    //搜索词轮播
    var searchData = {
        data: data.searchBanner
    }
    J.Template.render("#searchBannerHome_div", "searchBannerHome_template", searchData, "replace");
    J.Cache.save('searchBanner',searchData);
    if(data.searchBanner.length > 1 ){
        textScroll('searchBannerHome_div');
    }

    // 广告
    if (data.advert.topList.length != 0) {
        J.Template.render("#homeTopAdvert_div", "homeTopAdvert_template", data.advert, "replace");
        //根据isHoliday的值判断，该片区首页banner的大小，
        if(data.isHoliday.length > 0){
            if(J.Cache.get('community')){
                communityId = J.Cache.get('community').data.id;
                data.isHoliday.map(function (item) {
                    if(item == communityId){
                        $('#banner_back').addClass('isHoliday');
                        $('#homeTopAdvert_div ul li').addClass('big').removeClass('small');
                        // $('#homeTopAdvert_div ul li').width($('#banner_back.isHoliday #homeTopAdvert_div').width());
                    }else{
                        if(data.scene){
                            $('#banner_back').addClass('hasScene');
                            $('#homeTopAdvert_div ul li').addClass('big').removeClass('small');
                            // $('#homeTopAdvert_div ul li').width($('#banner_back.hasScene #homeTopAdvert_div').width());
                        }else{
                            $('#banner_back').removeClass('hasScene');
                            $('#homeTopAdvert_div ul li').addClass('small').removeClass('big');
                            // $('#homeTopAdvert_div ul li').width($('#homeTopAdvert_div').width());
                        }
                    }
                });
            }
        }else{
            if(data.scene){
                $('#banner_back').addClass('hasScene');
                $('#homeTopAdvert_div ul li').addClass('big').removeClass('small');
                // $('#homeTopAdvert_div ul li').width($('#banner_back.hasScene #homeTopAdvert_div').width());
            }else{
                $('#banner_back').removeClass('hasScene');
                $('#homeTopAdvert_div ul li').addClass('small').removeClass('big');
                // $('#homeTopAdvert_div ul li').width($('#homeTopAdvert_div').width());
            }
        }
        // 广告轮播
        if(data.advert.topList.length > 1){
            if(scrollImg.scroll) delete scrollImg.scroll.box;
            scrollImg = Viwepager('#homeTopAdvert_div [data-name="homeTopAdvert"] ul', {
                loop: true, //循环切换
                auto: true, //自动切换
                callback: function(ind) { //这里传过来的是索引值
                    $('#homeTopAdvert_div [data-name="homeTopPage"] ol li').eq(ind).addClass('active').siblings().removeClass('active');
                }
            });
        }else{
            $('#homeTopAdvert_div div.page').css('display','none');
        }
    } else {
        $("#homeTopAdvert_div").empty();
    }

	// 新的首页
	if(data.homePageTemplateInfo.length) {
        data.homePageTemplateInfo.map(function(item, index) {
            if(item.crazyBuyInfo){
                if(item.crazyBuyInfo.todayCrazyBuyGoods && item.crazyBuyInfo.todayCrazyBuyGoods.length > 0){
                    $('#flashSale_div').css('display','block');
                }
                J.Cache.save('secKillGoodsScroll',false);
                secKillGoods(item.crazyBuyInfo.tomorrowLeftTime);
            }
            if(item.floor) {
                item.floor.sp.map(function(item1){
                    if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                        if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                            item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                        }
                    }else if(item1.serviceEvent.discountRuleType == 3){//折扣
                        item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent.toFixed(1);
                    }else if(item1.serviceEvent.discountRuleType == 8){//满减

                    }
                    if(item1.serviceEvent.serviceEventMarkPic){
                        item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                    }
                });
            }
             // 门店特惠 左右主图带商品
            if(item.shopDiscount) {
                item.shopDiscount.sp.map(function(item1){
                    if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                        if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                            item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                        }
                    }else if(item1.serviceEvent.discountRuleType == 3){//折扣
                        item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent.toFixed(1);
                    }else if(item1.serviceEvent.discountRuleType == 8){//满减

                    }
                    if(item1.serviceEvent.serviceEventMarkPic){
                        item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                    }
                });
            }
            if(item.threeGroup) {
                item.threeGroup.sp.map(function(item1){
                    if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                        if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                            item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                        }
                    }else if(item1.serviceEvent.discountRuleType == 3){//折扣
                        item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent.toFixed(1);
                    }else if(item1.serviceEvent.discountRuleType == 8){//满减

                    }
                    if(item1.serviceEvent.serviceEventMarkPic){
                        item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                    }
                });
            }
            if(item.ChooseThreeForNewUser) {
                item.ChooseThreeForNewUser.sp.map(function(item1){
                    if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                        if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                            item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                        }
                    }else if(item1.serviceEvent.discountRuleType == 3){//折扣
                        item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent.toFixed(1);
                    }else if(item1.serviceEvent.discountRuleType == 8){//满减

                    }
                    if(item1.serviceEvent.serviceEventMarkPic){
                        item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                    }
                });
            }
            if(item.sevenPiece) {
                item.sevenPiece.sp.map(function(item1){
                    if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                        if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                            item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                        }
                    }else if(item1.serviceEvent.discountRuleType == 3){//折扣
                        item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent.toFixed(1);
                    }else if(item1.serviceEvent.discountRuleType == 8){//满减

                    }
                    if(item1.serviceEvent.serviceEventMarkPic){
                        item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                    }
                });
            }
            if(index == data.homePageTemplateInfo.length-1){
                data.homePageTemplateSubsetId = item.homePageTemplateSubsetId;
            }
        });
        J.Template.render("#home_div", "newHomePageTemplateInfo_template", data, "replace");
        var currentCommunityName = J.Cache.get('community').data.name + '店';
        $('#currentCommunityName').text(currentCommunityName);
        $('.search_bar .communityDesc').text(J.Cache.get('community').data.communityDesc);
        if(J.Cache.get('address') && J.Cache.get('address').data) homeRefresh = false;
        
        if($('#fixedBox li ').length > 1){
            fixedScroll('fixedBox');
        }
        floorCreateFly('index_section');
		setTimeout(function() {
			data.homePageTemplateInfo.map(function(item, index) {
				if(item.floor) {
					var box = '#moduleFloor' + index + ' .lb ul';
					var par = {
						loop: true, //循环切换
			            auto: true //自动切换
                    };
                    if($(box).children().length > 1){
                        var scrollImg = Viwepager(box, par);
                    }
				}
			});
		}, 100);
    }
    if(!data.canPrize){
        $('#luckyDrawClick').attr('onclick','J.showToast("抽奖活动暂未开始，敬请期待...")');
        $('#luckyDrawClick i').removeClass('active');
    }else {
        $('#luckyDrawClick').attr('onclick','getAwards()');
        $('#luckyDrawClick i').addClass('active');
    }

    // 图片懒加载
    $('#home_div img').LazyLoad({
        container: 'article',
        effect: 'show',
        effectArgs: 'slow',
        load: null,
        offset: 0
    });

    // 滚动监听
    $('#home_article .scrolling').unbind().scroll(scrollFun);
    //
    if(data.seeList && data.seeList.length) {
        var num = parseInt(Math.random() * data.seeList.length);
        var searchName = data.seeList[num].searchName;
        // $("input[type='search'].shopSearch").attr('placeholder', searchName);
        J.Cache.save('searchName', searchName);
    } else {
        J.Cache.empty('searchName');
    }
    // 首页加载完之后加载首页下面的内容数据
    getHomeDynamically_service({startIndex : 1,pageSize : 3,homePageTemplateSubsetId:data.homePageTemplateSubsetId});
    $('#home_article .scrolling').unbind().scroll(scrollFun);
	//
	if(data.seeList.length) {
		var num = parseInt(Math.random() * data.seeList.length);
	    var searchName = data.seeList[num].searchName;
		// $("input[type='search'].shopSearch").attr('placeholder', searchName);
	    J.Cache.save('searchName', searchName);
	} else {
		J.Cache.empty('searchName');
	}
}
//计算首页疯抢倒计时
function secKillGoodsTime(secKillGoodsLeftTime){
    var s = secKillGoodsLeftTime * 1;
    var time = {
        hour: '',
        minute: '',
        second: ''
    };
    time.hour = Math.floor(s / (60 * 60));
    time.minute = Math.floor((s - time.hour * 60 * 60) / 60);
    time.second = s % 60;

    time.hour = time.hour < 10 ? '0' + time.hour : '' + time.hour;
    time.minute = time.minute < 10 ? '0' + time.minute : '' + time.minute;
    time.second = time.second < 10 ? '0' + time.second : '' + time.second;
    return time;
}
//疯抢循环倒计时
var secKillGoodsInterval;
function secKillGoods(secKillGoodsLeftTime){
    window.clearInterval(secKillGoodsInterval);
    var s = secKillGoodsLeftTime * 1 - 1;
    secKillGoodsInterval = window.setInterval(function() {
        var time = secKillGoodsTime(s);
        document.getElementById('flashSaleHours').innerText = time.hour;
        document.getElementById('flashSaleMins').innerText = time.minute;
        document.getElementById('flashSaleSecs').innerText = time.second;
        s = s-1;
        if(s < 0) {
            window.clearInterval(secKillGoodsInterval);
            $('#flashSale_div span.countDownTimes').css('display','none');
        }else{
            $('#flashSale_div span.countDownTimes').css('display','inline-block');
        }
    }, 1000);
}
// 首页监听滚动事件的调用的方法
var timer = null;
function scrollFun() {
    var scrollingHeight = $('#homeTopAdvert_div').height();
    var scrollTop = $('#home_article .scrolling').scrollTop();
    var n_styleHeight = $('#home_article .n_style').height();
    var s2;
    // if(scrollingHeight - scrollTop < n_styleHeight) {
    //     $('#home_article header.search_bar').css('background', '#ff4d40');
    //     $('#index_section nav b').addClass('active');
    //     // $('#home_article header.search_bar').css('background', 'linear-gradient(to right,#f3555f,#c64440)');
    // }else{
    //     $('#home_article header.search_bar').css('background', '');
    //     // $('#home_article header.search_bar').css('background', 'rgba(00,00,00,0.1);');
    //     $('#index_section nav b').removeClass('active');
    // }
    clearInterval(timer);
    timer = setInterval(function(){
        s2 = $('#home_article .scrolling').scrollTop();
        if(scrollTop == s2){
            clearInterval(timer);
            $('#toCouponList').removeClass('couponHide');
        }
    }, 300);
    $('#toCouponList').addClass('couponHide');
    if(scrollTop > 500){
        $('#home_article .returnTop').css('display','inline-block');
    }else{
        $('#home_article .returnTop').css('display','none');
    }
    var topBg = J.Cache.get('topBg').data;
    if(scrollTop < 100){
        if (!topBgImgShow) {
            topBgImgShow = true;
            $('#home_article>header').css('background', topBg.topBgImg);
            $('#home_article>header').css('background-size', '100%');
            $('#home_article>header').css('background-repeat', 'no-repeat');
        }
    } else {             
        if (topBgImgShow)    {
            topBgImgShow = false;
            $('#home_article>header').css('background', topBg.topBgColor);
            $('#home_article>header').css('background-size', '100%');
            $('#home_article>header').css('background-repeat', 'no-repeat');
        }
    }

    if(J.Cache.get("homeVerticalListData") && J.Cache.get("homeVerticalListData").data){
        var homeVerticalType = J.Cache.get("homeVerticalType").data;
        if(J.Cache.get('homeNavBarCache') && J.Cache.get('homeNavBarCache').data){
            // 有记录子集位置后下拉后所有子集位置归零
            if($('#home').scrollTop() <= J.Cache.get('homeNavBarCache').data - 5){
                $('#home_article .verticalBannerList').map(function(i){
                    $($('#home_article .verticalBannerList')[i]).data().top = 0;
                })
            }
            if($('#home').scrollTop() >= J.Cache.get('homeNavBarCache').data - 5){
                $('#' + homeVerticalType + ' li').css('background','#fff');
                $('#' + homeVerticalType + ' li .navTab').css('background','#fff');
            }else {
                $('#' + homeVerticalType + ' li ').css('background','#f6f6f6;');
                $('#' + homeVerticalType + ' li .navTab').css('background','#f6f6f6;');
            }
        }
        if($('#' + homeVerticalType).data().cache == false){
            // 记录tabBar在顶部时页面位置
            $('#' + homeVerticalType).data().cache = true;
            var stickyHeight = $("#" + homeVerticalType).position().top + $("#banner_back").height() + document.body.clientWidth*2.67/100;
            J.Cache.save('homeNavBarCache',stickyHeight);
        }
        if(!isSupportSticky()){
            if($('#' + homeVerticalType).data().cache == false){
                // 记录tabBar在顶部时页面位置
                $('#' + homeVerticalType).data().cache = true;
                var stickyHeight = $("#" + homeVerticalType).position().top + $("#banner_back").height() + document.body.clientWidth*2.67/100;
                J.Cache.save('homeNavBarCache',stickyHeight);
            }
            // 不支持sticky样式的系统吸顶处理
            if(J.Cache.get('homeNavBarCache') && J.Cache.get('homeNavBarCache').data){
                if($('#home').scrollTop() >= J.Cache.get('homeNavBarCache').data - 5){
                    $('#' + homeVerticalType).css("position", "");
                    $('#' + homeVerticalType + ' div.navBarDiv').addClass('active');
                    $('#' + homeVerticalType + ' li').css('background','#fff');
                    $('#' + homeVerticalType + ' li .navTab').css('background','#fff');
                }else{
                    $('#' + homeVerticalType + ' div.navBarDiv').removeClass('active');
                    $('#' + homeVerticalType + ' li ').css('background','#f6f6f6;');
                    $('#' + homeVerticalType + ' li .navTab').css('background','#f6f6f6;');
                }
            }
        }
        homeVerticalListPullUp();
        $('#home').unbind().scroll(scrollFun);
    }
}
//  首页监听
var stop = true;
//首页商品
function getHomeDynamically_control(data,param){
    var startIndex = param.startIndex;
    if(data.homePageTemplateInfo.length != 0 || param.startIndex == 1) {
    	data.homePageTemplateInfo.map(function(item, index) {
            if(item.crazyBuyInfo){
                if(item.crazyBuyInfo.todayCrazyBuyGoods && item.crazyBuyInfo.todayCrazyBuyGoods.length > 0){
                    $('#flashSale_div').css('display','block');
                }
                J.Cache.save('secKillGoodsScroll',false);
                secKillGoods(item.crazyBuyInfo.tomorrowLeftTime);
            }
            if(item.floor) {
                if(item.floor.lb.length == 1){
                    item.floor.picLength = 1;
                }
                item.floor.sp.map(function(item1){
                    if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                        if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                            item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                        }
                    }else if(item1.serviceEvent.discountRuleType == 3){//折扣
                        item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent*10;
                    }else if(item1.serviceEvent.discountRuleType == 8){//满减

                    }
                    if(item1.serviceEvent.serviceEventMarkPic){
                        item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                    }
                });
            }
             // 门店特惠 左右主图带商品
                if(item.shopDiscount) {
                    item.shopDiscount.sp.map(function(item1){
                        if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                            if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                                item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                            }
                        }else if(item1.serviceEvent.discountRuleType == 3){//折扣
                            item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent*10;
                        }else if(item1.serviceEvent.discountRuleType == 8){//满减

                        }
                        if(item1.serviceEvent.serviceEventMarkPic){
                            item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                        }
                    });
                }
                if(item.threeGroup) {
                    item.threeGroup.sp.map(function(item1){
                        if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                            if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                                item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                            }
                        }else if(item1.serviceEvent.discountRuleType == 3){//折扣
                            item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent*10;
                        }else if(item1.serviceEvent.discountRuleType == 8){//满减

                        }
                        if(item1.serviceEvent.serviceEventMarkPic){
                            item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                        }
                    });
                }
                if(item.ChooseThreeForNewUser) {
                    item.ChooseThreeForNewUser.sp.map(function(item1){
                        if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                            if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                                item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                            }
                        }else if(item1.serviceEvent.discountRuleType == 3){//折扣
                            item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent.toFixed(1);
                        }else if(item1.serviceEvent.discountRuleType == 8){//满减

                        }
                        if(item1.serviceEvent.serviceEventMarkPic){
                            item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                        }
                    });
                }
                if(item.sevenPiece) {
                    item.sevenPiece.sp.map(function(item1){
                        if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                            if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                                item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                            }
                        }else if(item1.serviceEvent.discountRuleType == 3){//折扣
                            item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent*10;
                        }else if(item1.serviceEvent.discountRuleType == 8){//满减

                        }
                        if(item1.serviceEvent.serviceEventMarkPic){
                            item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                        }
                    });
                }
                if(item.single && item.single.list.length > 0) {
                    item.single.list.map(function(item2){
                        item2.picture = picNetworkPrefix(item2.picture);
                        if(item2.serviceEventMarkPic){
                            item2.serviceEventMarkPic = picNetworkPrefix(item2.serviceEventMarkPic);
                        }
                        if(item2.priceInUse && item2.priceInUse.indexOf('线上特惠') >= 0){
                            item2.priceInUse = item2.priceInUse.split('线上特惠')[1];
                        }
                        if (item2.discountRuleType == 0 || item2.discountRuleType == 5) {//直降
                            if(item2.priceNotInUseValue && item2.priceNotInUseValue != null) {
                                item2.discountLabelPrice = (item2.priceNotInUseValue - item2.price4Show).toFixed(2);
                            }
                        } else if (item2.discountRuleType == 3) {//折扣
                            item2.discountPercent = item2.discountPercent.toFixed(1);
                            item2.priceInUse = '¥' + item2.priceInUse.split('¥')[1];
                        } else if (item2.discountRuleType == 8) {//满减

                        }
                    })
                }
                if(item.vertical){
                    J.Cache.save('verticalEnd',true);
                    item.vertical.list.map(function(item2,i){
                        item2.tabIndex = item.vertical.tabBar[i].tabIndex;
                        if(item2.goodsInfo.length > 0){
                            item2.goodsInfo.map(function(item3){
                                if(item3.picUrl){
                                    item3.picUrl = picNetworkPrefix(item3.picUrl);
                                }else{
                                    item3.picture = picNetworkPrefix(item3.picture);
                                    if(item3.serviceEventMarkPic){
                                        item3.serviceEventMarkPic = picNetworkPrefix(item3.serviceEventMarkPic);
                                    }
                                    if(item3.priceInUse && item3.priceInUse.indexOf('线上特惠') >= 0){
                                        item3.priceInUse = item3.priceInUse.split('线上特惠')[1];
                                    }
                                    if (item3.discountRuleType == 0 || item3.discountRuleType == 5) {//直降
                                        if(item3.priceNotInUseValue && item3.priceNotInUseValue != null) {
                                            item3.discountLabelPrice = (item3.priceNotInUseValue - item3.price4Show).toFixed(2);
                                        }
                                    } else if (item3.discountRuleType == 3) {//折扣
                                        item3.discountPercent = item3.discountPercent.toFixed(1);
                                        item3.priceInUse = '¥' + item3.priceInUse.split('¥')[1];
                                    } else if (item3.discountRuleType == 8) {//满减

                                    }
                                }
                            })
                        }
                    });
                }
                if(item.newVertical){
                    J.Cache.save('verticalEnd',true);
                    item.newVertical.list.map(function(item2,i){
                        item2.tabIndex = item.newVertical.tabBar[i].tabIndex;
                        if(item2.goodsInfo.length > 0){
                            item2.goodsInfo.map(function(item3){
                                if(item3.picUrl){
                                    item3.picUrl = picNetworkPrefix(item3.picUrl);
                                }else{
                                    item3.picture = picNetworkPrefix(item3.picture);
                                    if(item3.serviceEventMarkPic){
                                        item3.serviceEventMarkPic = picNetworkPrefix(item3.serviceEventMarkPic);
                                    }
                                    if(item3.priceInUse && item3.priceInUse.indexOf('线上特惠') >= 0){
                                        item3.priceInUse = item3.priceInUse.split('线上特惠')[1];
                                    }
                                    if (item3.discountRuleType == 0 || item3.discountRuleType == 5) {//直降
                                        if(item3.priceNotInUseValue && item3.priceNotInUseValue != null) {
                                            item3.discountLabelPrice = (item3.priceNotInUseValue - item3.price4Show).toFixed(2);
                                        }
                                    } else if (item3.discountRuleType == 3) {//折扣
                                        item3.discountPercent = item3.discountPercent.toFixed(1);
                                        item3.priceInUse = '¥' + item3.priceInUse.split('¥')[1];
                                    } else if (item3.discountRuleType == 8) {//满减

                                    }
                                }
                            })
                        }
                    });
                }
                if(index == data.homePageTemplateInfo.length-1){
                    data.homePageTemplateSubsetId = item.homePageTemplateSubsetId;
                    if(item.single){
                        data.isCustom = item.single.isCustom;
                        data.pageIndex = item.single.pageIndex;
                        data.single = true;
                    }
                }
            });
        J.Template.render('#home_div', 'homeProducts_template', data, 'add');
        var currentCommunityName = J.Cache.get('community').data.name + '店';
        $('#currentCommunityName').text(currentCommunityName);
        $('.search_bar .communityDesc').text(J.Cache.get('community').data.communityDesc);
        data.homePageTemplateInfo.map(function (item) {
            if(item.vertical || item.newVertical){
                var par = {};
                if(item.vertical){
                    if(!item.vertical.tabBar[0].subtitle){
                        $('#homeNavigationBar').height('12vw');
                        $('#homeNavigationBar .navBarDiv').height('12vw');
                        $('#homeNavigationBar .navTab').height('12vw');
                        $('#homeNavigationBar .line').css('top','3.5vw');
                    }
                    J.Cache.save('homeVerticalType','homeNavigationBar');
                    par.tabIndex = $('#homeNavigationBar div.navTab.active').attr('id');
                    if($('#homeNavigationBar div.navTab.active').data().maintab){
                        var hasMainTab = $('#homeNavigationBar div.navTab.active').data().maintab
                        par.mainTab = hasMainTab;
                        $('#homeList' + par.tabIndex).data().maintab = hasMainTab;
                        par.offSet = $('#home_article .verticalBannerList.active').data().offset;
                    }
                    par.pageSize = 8;
                    par.custom = $('#home_article .verticalBannerList.active').data().custom;
                    par.pageIndex = $('#home_article .verticalBannerList.active').data().pageindex;
                    item.vertical['tab' + par.tabIndex] = false;
                    if(item.vertical.list.length > 0){
                        item.vertical['tab' + par.tabIndex]= true;
                    }
                    item.vertical.tabIndex = par.tabIndex;
                    var listData = [{vertical:item.vertical}];
                }else if(item.newVertical){
                    if(!item.newVertical.tabBar[0].subtitle){
                        $('#homeThreeGroupsBar').height('12vw');
                        $('#homeThreeGroupsBar .navBarDiv').height('12vw');
                        $('#homeThreeGroupsBar .navTab').height('12vw');
                        $('#homeThreeGroupsBar .line').css('top','3.5vw');
                    }
                    J.Cache.save('homeVerticalType','homeThreeGroupsBar');
                    par.tabIndex = $('#homeThreeGroupsBar div.navTab.active').attr('id');
                    if($('#homeThreeGroupsBar div.navTab.active').data().maintab){
                        var hasMainTab = $('#homeThreeGroupsBar div.navTab.active').data().maintab;
                        par.mainTab = hasMainTab;
                        $('#homeList' + par.tabIndex).data().maintab = hasMainTab;
                        par.offSet = $('#home_article .verticalBannerList.active').data().offset;
                    }
                    par.pageSize = 15;
                    par.custom = $('#home_article .verticalBannerList.active').data().custom;
                    par.pageIndex = $('#home_article .verticalBannerList.active').data().pageindex;
                    par.pageNumber = $('#home_article .verticalBannerList.active').data().pagenumber;
                    item.newVertical['tab' + par.tabIndex] = false;
                    if(item.newVertical.list.length > 0){
                        item.newVertical['tab' + par.tabIndex]= true;
                    }
                    item.newVertical.tabIndex = par.tabIndex;
                    var listData = [{newVertical:item.newVertical}];
                }
                asynchronousLoading(0);
                J.Cache.save("homeVerticalListData", listData);
                $('#homeList'+par.tabIndex).data().isload =  false;
                homeVerticalBanner_control(par);
            }
        })
        floorCreateFly('index_section');
        setTimeout(function() {
            data.homePageTemplateInfo.map(function(item, index) {
                if(item.floor) {
                    var box = '#floor' + startIndex + index + ' .lb ul';
                    if(item.floor.lb.length > 1){
                        var scrollImg = Viwepager(box, {
                            loop: true, //循环切换
                            auto: true //自动切换
                        });
                    }
                }
            });
        },100);
    }
    if (data.homePageTemplateInfo.length > 0) {
        param.startIndex = param.startIndex + 1;
        param.homePageTemplateSubsetId = data.homePageTemplateSubsetId ;
        if( data.single){
            param.isCustom = data.isCustom;
            param.pageIndex = data.pageIndex;
        }
        // 添加滚动事件
        $('#home').unbind().scroll(function() {
            if(J.Cache.get("homeVerticalListData") && J.Cache.get("homeVerticalListData").data){
                homeVerticalListPullUp();
                $('#home').unbind().scroll(scrollFun);
                return;
            }
            // 滚动条距离头部距离
            var scrollTop = $('#home').scrollTop();
            // 滚动条总高度
            var scrollHeight = $('#home')[0].scrollHeight;
            // 显示偏移区域高度
            var offsetHeight = $('#home')[0].offsetHeight;
            //首页轮播图高度
            var scrollingHeight = $('#homeTopAdvert_div').height();
            //头部导航条高度
            var n_styleHeight = $('#home_article .n_style').height();
            // 判断头部导航条是否显示
            // if(scrollingHeight - scrollTop < n_styleHeight) {
            //     $('#home_article header.search_bar').css('background-color', '#ff4d40');
            //     $('#index_section nav b').addClass('active');
            //     // $('#home_article header.search_bar').css('background', 'linear-gradient(to right,#f3555f,#c64440)');
            //     $('#toCouponList').addClass('couponHide');
            // }else{
            //     $('#home_article header.search_bar').css('background', '');
            //     $('#home_article header.search_bar').css('background-color', 'rgba(00,00,00,0.1);');
            //     $('#index_section nav b').removeClass('active');
            //     $('#toCouponList').removeClass('couponHide');
            // }
            // 判断返回顶部按钮是否显示
            clearInterval(timer);
            timer = setInterval(function(){
                s2 = $('#home_article .scrolling').scrollTop();
                if(scrollTop == s2){
                    clearInterval(timer);
                    $('#toCouponList').removeClass('couponHide');
                }
            }, 300);
            $('#toCouponList').addClass('couponHide');
            if(scrollTop > 500){
                $('#home_article .returnTop').css('display','inline-block');
            }else{
                $('#home_article .returnTop').css('display','none');
            }
            var topBg = J.Cache.get('topBg').data;
            if(scrollTop < 100){
                if (!topBgImgShow) {
                    topBgImgShow = true;
                    $('#home_article>header').css('background', topBg.topBgImg);
                    $('#home_article>header').css('background-size', '100%');
                    $('#home_article>header').css('background-repeat', 'no-repeat');
                }
            } else {             
                if (topBgImgShow)    {
                    topBgImgShow = false;
                    $('#home_article>header').css('background', topBg.topBgColor);
                    $('#home_article>header').css('background-size', '100%');
                    $('#home_article>header').css('background-repeat', 'no-repeat');
                }
            }
            // console.log('1111111', scrollTop)
            if(scrollHeight - scrollTop - offsetHeight <= 500) {
                if(stop) {
                    stop = false;
                    // J.showMask();
                    getHomeDynamically_service(param);
                }
            }
        });
    } else {
        // 添加滚动事件
        $('#home').unbind().scroll(scrollFun);
        if(J.Cache.get('verticalEnd')) return;
        $('#home_div').append('<div class="refresh-container"><span class="refresh-label" style="font-size: 3.5vw;">~~我是有底线的~~</span></div>');
    }
}
// 加载其余子集
function asynchronousLoading(num){
    var homeVerticalType = J.Cache.get('homeVerticalType').data;
    if(num == $('#'+homeVerticalType + ' .navTab').length-1){
        return;
    }
    var par = {};
    par.num = num+1;
    var tab = $('#'+homeVerticalType + ' .navTab')[par.num];
    par.tabIndex = $(tab).attr('id');
    par.custom = $('#homeList' + par.tabIndex).data().custom;
    par.pageIndex = $('#homeList' + par.tabIndex).data().pageindex;
    par.pageNumber = $('#homeList' + par.tabIndex).data().pagenumber;
    if(homeVerticalType == 'homeNavigationBar'){
        par.pageSize = 8;
    }else if(homeVerticalType == 'homeThreeGroupsBar'){
        par.pageSize = 15;
    }
    console.log('其余子集', par)
    homeVerticalBanner_control(par);
}
// 首页竖横幅加载
function homeVerticalBanner_control(par){
    homeVerticalBanner_service(par,function(data){
        data['tab' + par.tabIndex] = false;
        if(data.list.length > 0){
            data['tab' + par.tabIndex]= true;
        }
        data.type = J.Cache.get('homeVerticalType').data;
        data.tabIndex = par.tabIndex;
        $('#homeList'+par.tabIndex).data().custom = data.custom;
        $('#homeList'+par.tabIndex).data().pageindex = data.pageIndex;
        $('#homeList'+par.tabIndex).data().pagenumber = data.pageNumber;
        data.list.map(function(item, i) {
            if(item.picUrl){
                item.picUrl = picNetworkPrefix(item.picUrl);
            }else{
                item.picture = picNetworkPrefix(item.picture);
                if(item.serviceEventMarkPic){
                    item.serviceEventMarkPic = picNetworkPrefix(item.serviceEventMarkPic);
                }
                if(item.priceInUse && item.priceInUse.indexOf('线上特惠') >= 0){
                    item.priceInUse = item.priceInUse.split('线上特惠')[1];
                }
                if (item.discountRuleType == 0 || item.discountRuleType == 5) {//直降
                    if(item.priceNotInUseValue && item.priceNotInUseValue != null) {
                        item.discountLabelPrice = (item.priceNotInUseValue - item.price4Show).toFixed(2);
                    }
                } else if (item.discountRuleType == 3) {//折扣
                    item.discountPercent = item.discountPercent.toFixed(1);
                    item.priceInUse = '¥' + item.priceInUse.split('¥')[1];
                } else if (item.discountRuleType == 8) {//满减
                    
                }
            }
        })
        var listData = {
            lists : [data]
        };
        if(par.num){
            asynchronousLoading(par.num);
        }else{
            if(data.mainTab){
                $('#homeList' + par.tabIndex).data().maintab = data.mainTab;
                $('#home_article .verticalBannerList.active').data().offset = data.offSet;
            }
            $('#homeList'+par.tabIndex).data().isload =  data['tab' + par.tabIndex];
            J.Cache.save("homeVerticalListData", listData);
        }
        console.log('listData', listData)
        J.Template.render("#homeList"+par.tabIndex, "verticalPull_template", listData, 'add');
        floorCreateFly('index_section');
    });
}
// 首页竖横幅下拉
function homeVerticalListPullUp(){
    var par = {};
    par.custom = $('#home_article .verticalBannerList.active').data().custom;
    par.pageIndex = $('#home_article .verticalBannerList.active').data().pageindex;
    par.pageNumber = $('#home_article .verticalBannerList.active').data().pagenumber;
    if( J.Cache.get('homeVerticalType').data == 'homeNavigationBar'){
        par.tabIndex = $('#homeNavigationBar div.navTab.active').attr('id');
        par.pageSize = 8;
    }else if(J.Cache.get('homeVerticalType').data == 'homeThreeGroupsBar'){
        par.tabIndex = $('#homeThreeGroupsBar div.navTab.active').attr('id');
        par.pageSize = 15;
    }
    if($('#' +  par.tabIndex).data().maintab != 0){
        par.mainTab = $('#homeList' +  par.tabIndex).data().maintab;
        par.offSet = $('#home_article .verticalBannerList.active').data().offset;
    }
    if($('#homeList'+ par.tabIndex).data().isload){
        $('#homeList'+ par.tabIndex).data().isload = false;
    }else{
        return;
    }
    homeVerticalBanner_control(par);
}
// 首页竖横幅切换
function homeChangeTabBar(index,isHome){
    var homeVerticalType = J.Cache.get("homeVerticalType").data;
    var activeLeft = $($('#' + homeVerticalType +' div.navTab.active')).offset().left;
    var id = $('#home_article .verticalBannerList.active')[0].id;
    if(J.Cache.get('homeNavBarCache') && J.Cache.get('homeNavBarCache').data){
        if($('#home').scrollTop() >= J.Cache.get('homeNavBarCache').data - 5){
            $('#' + id).data().top = $('#home').scrollTop();
        }else{
            $('#home_article .verticalBannerList').map(function(i){
                $($('#home_article .verticalBannerList')[i]).data().top = 0;
            })
        }
    }
    $($('#' + homeVerticalType + ' div.navTab')[index]).addClass('active').siblings('.navTab').removeClass('active');
    $($('#home_article .verticalBannerList')[index]).addClass('active').siblings('.verticalBannerList').removeClass('active');
    var actId = $('.verticalBannerList.active')[0].id;
    if(J.Cache.get('homeNavBarCache') && J.Cache.get('homeNavBarCache').data){
        if($('#home').scrollTop() >= J.Cache.get('homeNavBarCache').data - 5){
            if($('#' + actId).data().top && $('#' + actId).data().top != 0){
                $('#home').scrollTop($('#' + actId).data().top);
            }else{
                var height = J.Cache.get('homeNavBarCache').data + 5;
                // 首页模块重叠和不重叠时候计算的height有差距
                // if($('#home_div').hasClass('homeFoldUp')){
                //     $('#home').scrollTop(height - 13);
                // }else{
                    $('#home').scrollTop(height);
                // }
            }
        }
    }
    var left = $($('#' + homeVerticalType +' div.navTab')[index]).offset().left;
    if(activeLeft > left){
        if(left <= $(window).width()*3/4){
            $('#' + homeVerticalType + ' li').scrollLeft(  $('#' + homeVerticalType + ' li').scrollLeft() - $($('#' + homeVerticalType + ' div.navTab')[index]).width()*1.5);
        }
     }else if(left >= $(window).width()/3){
        $('#' + homeVerticalType + ' li').scrollLeft(  $('#' + homeVerticalType + ' li').scrollLeft() + $($('#' + homeVerticalType + ' div.navTab')[index]).width()*1.2);
    }
}
//切换今日明日疯抢
function changeSecKill(type){
	if(type == 1){
        $('#flashSale_div').addClass('active');
        $('.crazyBuyGoods.left').addClass('active').siblings().removeClass('active');
		// $('.todayBuy').addClass('active').siblings().removeClass('active');
		$('#secKillGoodsUl').css('display','block');
		$('#tomorrowSecKillGoods').css('display','none');
		// $('#robDaily').text('距结束');
	}else if(type == 2){
        $('#flashSale_div').removeClass('active');
        $('.crazyBuyGoods.right').addClass('active').siblings().removeClass('active');
		// $('.tomorrowForecast').addClass('active').siblings().removeClass('active');
		$('#tomorrowSecKillGoods').css('display','block');
		$('#secKillGoodsUl').css('display','none');
		// $('#robDaily').text('距开始');
	}else{
		J.showToast('疯抢活动还没有开始噢~')
	}
}
/**
 * [clickAdvert_control 点击轮播图广告方法]
 * @param  {[type]} type  [跳转类型 0不跳转  1商品     2活动    3url    4邻居圈说说  5优惠券   6分类列表  7活动页  8活动页v2
 *                          9优惠券列表  10活动页v3    11自定义活动页   12抽奖  13购买券   14购买券列表   15常购清单 16.卡充值 
 *                          17.会员专享 18.停车场 19.我的优惠券  20.会员购买页面  21.邀请有礼]
 * @param  {[type]} relatedId [可以是任何id,根据type来]
 */
function clickAdvert_control(type,relatedId,saleId){
    $("#currencyId").data().currency = relatedId;
    if (type == 1){
        getServiceEventDetails_service(relatedId, {sName: '', sIndex: 0});
    }else if (type == 2){
        alert("活动尚未开始，敬请期待")
    }else if (type == 3){
        J.Cache.save('routerLink',relatedId);
        J.Router.goTo('#iframe_section');
        // window.location.href = relatedId;
    }else if (type == 4){
        alert("邻居圈尚未开始，敬请期待")
    }else if (type == 5){
    	if(relatedId) {
    		if(saleId) {
    			getCouponDetailPage(relatedId, 0, saleId);
    		} else {
    			getCouponDetailPage(relatedId, 0, 0);
    		}
    	} else {
    		J.Router.goTo("#couponList_section");
    	}
    }else if(type == 6){
        homeMenu_control(relatedId);
    }else if(type == 7){
    	getHomePageActivity({activityId : relatedId})
    }else if(type == 8) {
    	activityPage_service(relatedId);
    }else if(type == 9) {
    	getCouponList_control();
    }else if(type == 10) {
        activityV3_service(relatedId);
    }else if(type == 11) {
        getNewActivePage_control(relatedId);
    }else if(type == 12) {
        // judgeCanPrize_service(function(data) {
        //     console.log(data);
        //     getAwards();
        // });
        getAwards();
    }else if(type == 13) {
        // 购买券
        if(relatedId) {
    		if(saleId) {
    			getCouponDetailPage(relatedId, 0, saleId);
    		} else {
    			getCouponDetailPage(relatedId, 0, 0);
    		}
    	} else {
    		J.Router.goTo('#integralCouponList_section');
    	}

    }else if(type == 14) {
        // 购买券列表
        J.Router.goTo('#integralCouponList_section');
    }else if(type == 15) {
        J.Router.goTo("#oftenBuyList_section");
    } else if (type == 16) {
        J.Router.goTo("#rechargeOfSuguo_section");
        if(isWechatClient()){
            getJSSDKConfigParams_service();
        }
        pay.suguoCardTimeList = {
            timeBeanList: {},
            timeValue: 0,
            timeDay: 0,
            uploadImg: {
                image: ''
            }
        }
    } else if (type == 17) {
        getBaiMingDanList();
        J.Cache.empty('baiMingDanList');
    } else if (type == 18) {
        goParking_control()
    } else if (type == 19) {
        J.Router.goTo("#myCoupon_section");
    } else if (type == 20) {
        goToBuyVIP_control();
    } else if (type == 21) {
        if(J.Cache.get('login')){
            var level = J.Cache.get('login').data.level;
            if(level == 5 || level == 6){
                J.showToast('邀请有礼活动暂未开始');
            }else{
                J.Router.goTo("#posterShare_section");
            }
        }else{
            J.showToast('请先登录');
            J.Router.goTo('#login_section');
        }
    }
}

// 获取优惠券列表
function getCouponList_control() {
    J.Router.goTo("#couponList_section");
}

// 购买优惠券
function buyCoupon_control(couponId, price, saleId) {
    if(!J.Cache.get('login')){
        quickLogin();
        return;
    }
    J.Cache.save('payCouponId',couponId);
    J.Router.goTo("#payMethod_section");
    calculateAvailableIntegrationAndBalance_service(price, 1);
    setTimeout(function() {
        $("#payMethod_section").find('[data-name="couponPay"]').val(couponId);
        // 加一个绩效
        $("#payMethod_section").find('[data-name="couponPay"]').data().saleId = saleId;
        $("#payMethod_section").find('[data-name="offlinePay"]').hide();

    }, 300)
}
// 设置支付页面
function setPayPage(payType) {
    var type = parseInt(payType);
    switch (type) {
        case 1:
            $("#payMethod").hide()
            $(".modePayList .payment-list[data-type='0']").removeClass('show');
            $(".payment-list[data-name='integration']").addClass("show");
            break;
        case 2:
            $("#payMethod").hide()
            $(".modePayList .payment-list[data-type='0']").removeClass('show');
            $(".payment-list[data-name='activityIntegration']").addClass("show");
            break;
        case 3:
            $("#payMethod").hide()
            $(".modePayList .payment-list[data-type='0']").removeClass('show');
            $(".payment-list[data-name='blance']").addClass("show");
            break;
        case 4:
            $("#payMethod").hide()
            $(".modePayList .payment-list[data-type='0']").removeClass('show');
            $(".payment-list[data-name='groupBalance']").addClass("show");
            break;
        case 5:
            $(".modePayList .payment-list[data-type='0']").removeClass('show');
            break;
        default:
            break;
    }
}

//活动页1
function getHomePageActivity_control(param,data){
    var tplWay = param.startIndex > 1 ? 'add' : 'replace' ;
    if(data.baseInfo && data.groups){
        if(param.startIndex == 1) {
            J.Refresh('#pageActivity_article').destroy();
        }
        J.Template.render("#pageActivity_div","pageActivity_template", data, tplWay);
        for(var i = 0; i < data.positionIndex.length; i++) {
            if(data.positionIndex[i] == 'c') {
                var item = data.position[i];
                $('#pageActivityCarousel_div[data-type="' + item + '"] ul li').width(document.body.clientWidth);
                var box = '#pageActivityCarousel_div[data-type="' + item + '"] [data-name="homeTopAdvert"] ul';
                var par = {
                    loop: true, //循环切换
                    auto: true, //自动切换
                }
                if($(box).children().length <= 1) par.auto = false;
                var scrollImg = Viwepager(box, par);
            }
        }
        setTimeout(function () {
            J.Template.render("#pageActivityPro_div","pageActivityPro_template", data, tplWay);
        },100);
    }else {
        J.Template.render("#pageActivityPro_div","pageActivityPro_template", data, tplWay);
    }
    setTimeout(function () {
        J.hideMask();
        J.Scroll("#pageActivity_article", {});
        if (data.rp.length >= 10) {
            J.Refresh('#pageActivity_article', 'pullUp', function() {
                var scroll = this;
                setTimeout(function() {
                    $('#getHomePageActivity_section header').attr('data-clearScroll',true); //商品列表页hide时不清滚动条
                    param.startIndex = param.startIndex + 1;
                    getHomePageActivity(param);
                    scroll.refresh();
                }, 10);
            });
        }else{
            J.Refresh('#pageActivity_article').destroy();
            $('#pageActivity_div').append('<div class="refresh-container"><span class="refresh-label">已加载完成</span></div>');
            J.Scroll("#pageActivity_article", {});
            var heigth = $('#pageActivity_div')[0].clientHeight - $('#pageActivity_article')[0].clientHeight;
            if(param.startIndex > 1){
                $('#getHomePageActivity_section .scrollWrapper')[0].style.transform = 'translate(0px, -' + heigth + 'px) scale(1) translateZ(0px)';
            }
        }
    },200);
}
//活动2滚动监听
function activityPage_control(listTits){
    $('#activityTwo_article').unbind ('scroll');
    $('#activityTwo_article').scroll(function() {
        getActivityPageDiv();
        var Top_Height = $('#actTwoAdvert_div').height() + $('#actTeJia_div').height();
        var height = $('#activityTwo_article')[0].scrollTop - Top_Height ;
        var top;
        for(var i = 0; i < listTits.length; i++) {
            var st = $('#activityTwo_article')[0].scrollTop;
            var j = i + 1;
            var _Tits = $(document.getElementsByClassName(i))[0][0];
            if(j < listTits.length){
                top = document.getElementById(listTits[j].categoryId).offsetTop;
                if (st <= top - 50){
                    $(_Tits).addClass('active').siblings('a').removeClass('active');
                    break;
                }
            }else{
                top = document.getElementById(listTits[i].categoryId).offsetTop;
                var top1 = document.getElementById(listTits[i - 1].categoryId).offsetTop;
                if (st >= top1 + 20){
                    $(_Tits).addClass('active').siblings('a').removeClass('active');
                    break;
                }
            }
            if(i >= 1){
                $('#tits li')[0].scrollLeft += $('#tits li')[0].children[i].offsetWidth;
            }else{
                $('#tits li')[0].scrollLeft = 0;
            }
        }
        var firstCategoryName = $(document.getElementsByClassName(0))[0][0];
        if(st <= Top_Height ){
            $(firstCategoryName).addClass('active').siblings('a').removeClass('active');
            $('#tits li')[0].scrollLeft =  1;
        }
            if(height > 45 ){
                $(' #activityTwo_article').css('top',105);
                $('#listTitles').css('display','block');
                $('#listTits #tits').css('display','none');
            }else if(height < 0){
                $(firstCategoryName).addClass('active').siblings('a').removeClass('active');
                $('#listTits #tits').css('display','block');
                $(' #activityTwo_article').css('top',64);
                $('#listTitles').css('display','none');
            }
    })
}
//活动2点击监听
function titActive(i,id){
    var x = $(document.getElementsByClassName(i))[0][0];
    $(x).addClass('active').siblings('a').removeClass('active');
    var Top_Height = $('#actTwoAdvert_div').height() + $('#actTeJia_div').height();
    var height = document.getElementById(id).offsetTop - Top_Height;
    $('#activityTwo_article')[0].scrollTop = document.getElementById(id).offsetTop;
        if(height > 100){
            $(' #activityTwo_article').css('top',105);
            $('#listTitles').css('display','block');
            $('#listTits #tits').css('display','none');
        }else if(height < 0){
            $('#listTits #tits').css('display','block');
            $(' #activityTwo_article').css('top',64);
            $('#listTitles').css('display','none');
        }
}

//倒计时循环
var myInterval;
function countDown(countDownTime,sec){
    window.clearInterval(myInterval);
    var s = countDownTime * 1 - 1;
    if(sec == 'activityPage_section'){
        myInterval = window.setInterval(function() {
            var time = secKill(s);
            document.getElementById('countdownDays').innerText = time.days;
            document.getElementById('countdownHours').innerText = time.hour;
            document.getElementById('countdownMins').innerText = time.minute;
            document.getElementById('countdownSecs').innerText = time.second;
            s = s-1;
            if(s < 0) {
                window.clearInterval(myInterval);
                activityPage_service($('#isCountDown').data().id);
            }
        }, 1000);
    }
}

// 停车场页面
function goParking_control() {
	if(isWechatClient()) {
		location.href = 'https://wei.vipxiaoqu.com/park/wechat/parking.html';
	} else {
		J.showToast('请在微信端打开');
	}
}

// 购买优惠券service前确认control
function submitCouponOrder_control() {
    var _money = $("#payMethod_section h3").text();
    // var _money = $("#payMethod_section").find('span[name=finalMoney]').text();
    var couponId = $("#payMethod_section").find('[data-name="couponPay"]').val();
    if(isNullString(couponId)) couponId = J.Cache.get('payCouponId').data;
    var param = {
        num: 1,
        couponId: couponId,
        integralOff: parseInt($("#integrationVal").val()),
        balanceOff: parseFloat($("#blanceVal").val()).toFixed(2),
        saleId: $("#payMethod_section").find('[data-name="couponPay"]').data().saleId,
        total: pay.total
    };
	console.log(param);
    // 支付方式
    if (pay.mock.blance.thirdPatMethod != 0) {
        param.payMethod = 0;
        $("#payMethod li").each(function() {
            if ($(this).hasClass('active')) {
                param.payMethod = $(this).find('label').attr("value");
            }
        })
    } else {
        param.payMethod = 0;
    }
    // 调用不同支付接口
    if (param.payMethod == 0 && pay.mock.blance.thirdPatMethod != 0) {
        J.alert('提示', '还需支付' + pay.mock.blance.thirdPatMethod + '元,请支付');
    } else {
        // J.dialogbox('共支付' + pay.total + '元,需第三方平台支付' + _money + '元,确认支付吗', function() {
        //     buyCoupon_service(param);
        // })
        if (param.payMethod == 0) {
            J.Popup.confirm4('确认支付吗？','本次需支付' + _money + '元','取消','确定', function() {
                buyCoupon_service(param);
            })
        } else {
            buyCoupon_service(param);
        }
    }
}

// 购买vip service前确认control
function submitVIPOrder_control() {
    var _money = $("#payMethod_section h3").text();
    var param = {
        num: 1,
        integralOff: parseInt($("#integrationVal").val()),
        promotionalIntegralOff: parseInt($("#activityIntegrationVal").val()),
        balanceOff: parseFloat($("#blanceVal").val()).toFixed(2),
        groupBalanceOff: parseFloat($("#groupBlanceVal").val()).toFixed(2),
        // saleId: $("#payMethod_section").find('[data-name="couponPay"]').data().saleId,
        total: pay.total,
        payMethod: 0,
        vipCoupon: pay.memberDeductCoupon.couponSelect
    };
	console.log(param);
    // 支付方式
    if (pay.mock.blance.thirdPatMethod != 0) {
        $("#payMethod li").each(function() {
            if ($(this).hasClass('active')) {
                param.payMethod = $(this).find('label').attr("value");
            }
        })
    }
    // 调用不同支付接口
    if (param.payMethod == 0 && pay.mock.blance.thirdPatMethod != 0) {
        J.alert('提示', '还需支付' + pay.mock.blance.thirdPatMethod + '元,请支付');
    } else {
        // J.dialogbox('共支付' + pay.total + '元,需第三方平台支付' + _money + '元,确认支付吗', function() {
        //     // buyCoupon_service(param);
        //     buyVIP_control(param);
        // })

        if (param.payMethod == 0) {
            J.Popup.confirm4('确认支付吗？','本次需支付' + _money + '元','取消','确定', function() {
                buyVIP_control(param);
            })
        } else {
            buyVIP_control(param);
        }
    }
}

// 购买VIP
function buyVIP_control(mock) {
    //level 0:普通用户 1：白名单用户 2：黑名单A级 3：黑名单B级 4：黑名单C级 5：黑名单D级 6：黑名单E级
    if(J.Cache.get('login').data.level != 0 && J.Cache.get('login').data.level != 1){
        J.showToast('暂时无法购买');
        return;
    }
    buyVIP_service(mock)
}

//退出登录默认更改片区为奥体 （不在使用中）
function saveSommunity_control(id, name,type) {
	var _data = {};
	//没有登录或者登录没有收货地址，直接更改片区
    _data = {
        id: id,
        name: name,
        type: type
    };
    J.Cache.save('community', _data);
    changeCommunity_service(id);
}

//生成search列表
function getList_control(data) {
//	$('#searchList_div').css('top','1000px')
	$('#searchList_div').show();
//	$('#searchList_div').animate({top:'0px'}, 300, function() {})
	J.Template.render('#searchList_ul', 'searchList_template', data, "replace");

	$('#searchList_div').click(function() {
		$('#searchList_div').hide();
//		$('#searchList_div').animate({top:'1000px'},300 ,function() {
//			$('#searchList_div').hide();
//		});
	});
}
//点击列表的search方法
function searchSerName_control(name) {
//  $("#home_article input[type='search']").val('');
    searchEventName_control(name);
	$('#searchList_div').hide();
}

//首页扫码
function homePageScanCode() {
	scanQRCode(function(res) {
		console.log(res);
		if(res.resultType == 'EAN_8' || res.resultType == 'EAN_13') {
			getProductId(res.resultText);
		}
		if(res.resultType == 'WTY_CODE') {
			var param = res.resultText.split(',');
			clickAdvert_control(param[0], param[1],param[2]);
		}
	});
}

//获取二维码或条码
function scanQRCode(callback) {
    //扫码文本格式如下所示 类型,id  代码如同首页广告就可以
    if (isWechatClient()) {
    	var url = 'ws/wechatAction' + versionMessage.version + '!getJSSDKConfigParams.sy';
	    var par = {
	        JSSDKUrl: window.location.href.split('#')[0]
	    };
	    service.get(url, par, function(data) {
	        wx.config({
	            debug: false,
	            appId: data.appId,
	            timestamp: data.timestamp,
	            nonceStr: data.nonceStr,
	            signature: data.signature,
	            jsApiList: [
	                'scanQRCode'
	            ]
	        });

	        wx.error(function(res) {
				console.log(res);
	        });
	        wx.ready(function() {
	            wx.scanQRCode({
	                needResult: 1, // 默认为0，扫描结果由微信处理，1则直接返回扫描结果，
	                scanType: ["qrCode","barCode"], // 可以指定扫二维码还是一维码，默认二者都有
	                success: function (res) {
	                	console.log(res, '原始的扫码数据')
	                    var result = res.resultStr; // 当needResult 为 1 时，扫码返回的结果
	                    var param = result.split(',');
	                    var par = {};
	                    if(param[0] == 'EAN_8' || param[0] == 'EAN_13') {
	                    	par.resultType = param[0];
	                    	par.resultText = param[1];
	                    } else {
	                    	par.resultType = 'WTY_CODE';
	                    	par.resultText = res.resultStr;
	                    }
	                    console.log(par);
	                    callback(par);
	                }
	            });
	        });
	    });
    } else {
        cordova.plugins.barcodeScanner.scan(
            function(result) {
            	console.log(result, '原始的扫码数据')
            	var par = {};
                if(result.format == 'EAN_8' || result.format == 'EAN_13') {
                	par.resultType = result.format;
					par.resultText = result.text;
                } else {
                	par.resultType = 'WTY_CODE';
                	par.resultText = result.text;

                }
                callback(par);
            },
            function(error) {
                alert("Scanning failed: " + error);
            }
        );
    }
}

//跳转分类菜单
function homeMenu_control(id){
    $("#classification_article").children('header').attr('value',false);//其他页面跳转指定分类不默认加载刷新
    J.Cache.save('isActivePage',true);
    var lin = window.location.href;
    J.Router.goTo('#index_section');
    $($('#index_footer').children()[1]).addClass('active').siblings().removeClass('active');
    $('#classification_article').addClass('active').siblings().removeClass('active');
    getServiceMenuBetter_service(id);
    // 首页点击模块切换到分类 不触发articleshow 这里获取分类数据
    if(lin.indexOf('index_section') >= 0){
        $('#classification_article article').addClass('active');
        // getServiceMenuBetter_service(id);
        if(J.Cache.get('searchBanner') && J.Cache.get('searchBanner').data){
            searchData = J.Cache.get('searchBanner').data
        }
        J.Template.render("#searchBannerClassify_div", "searchBannerClassify_template", searchData, "replace");
        if(searchData.data.length > 1 ){
            textScroll('searchBannerClassify_div');
        }
        J.Cache.empty('isActivePage');
    }
}
// 苏果充值获取地址
function getAddressForRecharge_control(){
    if(J.Cache.get('address') && J.Cache.get('address').data){
        var address = J.Cache.get('address').data;
        if(!isEmptyObject(address)){
            // address.address = address.address.substr(0,14);
            $('#rechargeOfSuguo_form [data-name="addressId"]').attr('data-addressId',address.id).attr('data-communityId',address.communityId); //地址姓名
            $('#rechargeOfSuguo_form [data-name="name"]').text(address.name); //地址姓名
            $('#rechargeOfSuguo_form [data-name="contact"]').text(address.contact); //地址电话
            $('#rechargeOfSuguo_form [data-name="address"]').text(address.address); //地址
            if(address.userFamilyLabel != null){
                $('#rechargeOfSuguo_form [data-name="label"]').show().text(address.userFamilyLabel.labelName).removeClass('blue yellow');
                if(address.userFamilyLabel.labelName.indexOf('公司') > -1 ){
                    $('#rechargeOfSuguo_form [data-name="label"]').addClass('blue');
                }
                if(address.userFamilyLabel.labelName.indexOf('学校') > -1 ){
                    $('#rechargeOfSuguo_form [data-name="label"]').addClass('yellow');
                }
            }
        }else{
            $('#rechargeOfSuguo_section [data-name="editAddress"]').addClass('none');
            $('#rechargeOfSuguo_form .has-address').addClass('none').siblings().removeClass('none');
        }
        
    }
}

// 新增苏果充值订单
function addSuguoOrder_control(ele) {
    $(ele).removeAttr('onclick');
    $(ele).css('filter', 'grayscale(100%)');
    setTimeout(function(){
        $(ele).attr('onclick','addSuguoOrder_control(this)');
        $(ele).css('filter', 'none');

    },2000);
    var addressId = $('#rechargeOfSuguo_form [data-name="addressId"]').attr('data-addressId');
    var addressCommunityId = $('#rechargeOfSuguo_form [data-name="addressId"]').attr('data-communityId');
    var community = J.Cache.get('community').data;
    if (!isNullString(addressId)) {
        if (addressCommunityId == community.id) {
            var mock = $('.suguoCardList').serializeArray();
            console.log(mock);
            // var messge = {
            //     'suguoCardCode' : '请输入卡号',
            //     'money' : '金额不能为空'
            // };
            var mock = $('.suguoCardList').serializeArray();
            var suguoTotalMoney = 0;
            var suguoCardCodeArr = [];
            var suguoCarList = [];
            var txtContent = J.Cache.get('suguocardConfirm').data;
            for(var i = 0; i < mock.length; i = i + 2) {
                console.log(i);

                if (mock[i].value.length == 25 && mock[i].value.indexOf('233602')==0) {
                    // var reg = new RegExp("^[0-9]+(.[0-9]{1,2})?$");
                    var reg = /^(0|[1-9]\d{0,6})(\.\d{1,2})?$/;
                    if(reg.test(mock[i+1].value)){
                        // 卡号
                        suguoCardCodeArr.push(mock[i].value);
                        // 金额
                        suguoTotalMoney = suguoTotalMoney + mock[i+1].value * 1;
                        // 卡号金额集合
                        suguoCarList.push({
                            cardNum: mock[i].value,
                            value: mock[i+1].value * 1
                        })
                    } else {
                        $(".suguoCardList .text-white").eq(i/2).addClass('err')
                        J.showToast('金额小于10000000，且最多两位小数');
                        return;
                    }
                } else {
                    console.log('0.0.0.0.0.0')
                    $(".suguoCardList .text-white").eq(i/2).addClass('err')
                    J.showToast('请输入正确的苏果卡号');
                    return;
                }
            }

            var par = {
                addressId: addressId,
                suguoCardCode: suguoCardCodeArr.toString(),
                money: suguoTotalMoney,
                suguoCarList: JSON.stringify(suguoCarList),
                picture: pay.suguoCardTimeList.uploadImg.image
            }
            if($('#expressTime').hasClass('active')){
                if($('#selectedExpressTime').text()){
                    par.visitingTime = pay.suguoCardTimeList.time;
                }else {
                    J.showToast('请选择上门取卡时间');
                    return;
                }
            }
            if (suguoCardCodeArr.length == 0) {
                J.showToast('请输入卡号');
                return;
            }
            var suguoMoney = Number($('#minSuguoVal').text());
            if (suguoTotalMoney < suguoMoney) {
                J.showToast('苏果卡最低充值金额为' + suguoMoney +'元');
                return;
            }
            console.log(par, JSON.stringify(suguoCarList));
            J.Popup.confirm4('提示',txtContent,'取消','提交',function(){
                setTimeout(function () {
                    addSuguoOrder_service(par); 
                }, 300);
            },function(){

            })
        } else {
            J.alert('提示', '您所选的商品无法送达您的送货区域，请更改地址或更改所在区域');
        }
    } else {
        J.alert('提示', '请添加地址后充值');
    }
}

// 增加一个苏果卡
function addSuguoCar() {
    var htmlStr = '<div class="text-white">' +
                    '<div>' +
                        '<label>苏果卡号</label>' +
                        '<input type="text" onchange="importSuguoCardNum(this)" name="suguoCardCode"  placeholder="请输入完整的苏果卡号" maxlength="25"></input>' +
                    '</div>' +
                    '<div>' +
                        '<label>充值金额</label>' +
                        '<input type="number" onchange="importSuguoCardSum(this)" onblur="totalSuguoCard(this)" placeholder="请输入该卡对应的充值金额" name="money"></input>' +
                    '</div>' +
                    '<i class="deleteDiv" onclick="removeSuguoCar(this)"></i>' +
                '</div>'
    $("#rechargeOfSuguo_article .suguoCardList").append(htmlStr);
}

// 删除一个苏果卡
function removeSuguoCar(ele) {
    console.log(ele);
    $(ele).parent().remove();
}
// 输入苏果卡号
function importSuguoCardNum(ele) {
    var cardNumber = ele.value.replace(/[^\d]/g, "");
    ele.value = cardNumber;
    if (cardNumber.length == 25 && cardNumber.indexOf('233602') == 0) {
        $(ele).parents('.text-white').removeClass('err');
        totalSuguoCard();
    } else {
        $(ele).parents('.text-white').addClass('err');
        J.showToast('请输入正确的苏果卡号');
    }
}
// 输入苏果卡金额
function importSuguoCardSum(ele) {
    console.log('0.0.0.0.0.0.0.0.0')
    var cardSum = ele.value;
    console.log('cardSum', cardSum);
    // if (!cardSum) $(ele).parent('.text-white').addClass('err');


    // var reg = new RegExp("^[0-9]+(.[0-9]{1,2})?$");
    var reg = /^(0|[1-9]\d{0,6})(\.\d{1,2})?$/;

    console.log('reg.test(cardSum)', reg.test(cardSum));
    if(reg.test(cardSum)){
        $(ele).parents('.text-white').removeClass('err');
        $(ele).parents('.text-white').find('[name="suguoCardCode"]').trigger('change');
    } else {
        $(ele).parents('.text-white').addClass('err');
    }
}

// 合计苏果卡金额
function totalSuguoCard() {
    var mock = $('.suguoCardList').serializeArray();
    var suguoTotalMoney = 0;
    for(var i = 0; i < mock.length; i = i + 2) {
        if (mock[i].value.length == 25) {
            console.log('mock[i+1].value', mock[i+1], mock[i+1].value);
            
            // var reg = new RegExp("^[0-9]+(.[0-9]{1,2})?$");
            var reg = /^(0|[1-9]\d{0,6})(\.\d{1,2})?$/;

            if(reg.test(mock[i+1].value)){
                suguoTotalMoney = suguoTotalMoney + mock[i+1].value * 1;
            }

        } else {
            continue;
        }
    }
    console.log('suguoTotalMoney', suguoTotalMoney);
    suguoTotalMoney = Math.formatFloat(suguoTotalMoney);
    $('#rechargeOfSuguo_article .suguoTotalMoney').text(suguoTotalMoney);
}


// 首页红包
function getRedPacket_control() {
	var par = {}
	if(J.Cache.get('login')) {
		par.phone = J.Cache.get('login').data.phone
	}
	getRedPacket_service(par, function(data) {
		var id = data.couponId
		var pic = picNetworkPrefix(data.picture);
		$('#homeRedPacket_div').addClass('active');
		$('#homeRedPacket_div .redPacketBox').css('background-image', 'url(' + pic + ')');

		$('#homeRedPacket_div .redPacketBox').unbind('click');
		$('#homeRedPacket_div .redPacketBox').bind('click',function() {
			if(!J.Cache.get('login')) {
				$(this).parent().removeClass('active');
				J.Router.goTo('#login_section');
				return;
			}
			receiveRedPacket_service(id, 0);
			$(this).parent().removeClass('active');
		});
	});
}

// 关闭用户协议 
function closeStatement () {
    J.Cache.save("statementBox", true);
    $('#statementBox').removeClass('active');
    console.log('关闭用户协议de定位')
    // 定位
    getServiceZone();
    // 通知
    onDeviceReady();
}

// 关闭红包页面 不是公用的方法
function xRedPacketMark(ele) {
    $(ele).parent().parent().removeClass('active');
    event.stopPropagation();
}
//退货提示
function xRefundMark(ele) {
    $(ele).parent().parent().removeClass('active');
    event.stopPropagation();
    orders.goMyOrders('6');//售后订单
}
// 是否返回上一页
function returnBack(){
    if(J.Cache.get('secondActivityId') && J.Cache.get('secondActivityId').data == true){
        getNewActivePage_control(J.Cache.get('firstActivityId').data,true);
        //活动页点击跳活动页  返回上一个活动页加左切出
        $('#newActivePage_section').addClass('fadeInLeft');
        setTimeout(function(){
            $('#newActivePage_section').removeClass('fadeInLeft');
        },300);
    }else{
        history.go(-1);
        firstActivity = true;
    }
}
// 获取自定义活动页数据
function getNewActivePage_control(activityId,type) {
    if(!firstActivity){//活动页点击跳活动页加右切入
        $('#newActivePage_section').addClass('fadeInRight');
        setTimeout(function(){
            $('#newActivePage_section').removeClass('fadeInRight');
        },300);
    }
    J.Router.goTo('#newActivePage_section');
    $('#newActivePage_article').css('background','url(../www/img/bg/newactive-bg.png) no-repeat');
    $('#newActivePage_article').css('background-size','100vw');
    J.Cache.empty("activePageData");
    if(type == undefined && firstActivity){
        J.Cache.save('firstActivityId',activityId);
        firstActivity = false;
    }
    if(activityId == J.Cache.get('firstActivityId').data){
        J.Cache.save('secondActivityId',false);
    }else {
        J.Cache.save('secondActivityId',true);
    }
    // 每次请求数据时候清除页面
    $("#newActivePage_div").html('');
    J.Cache.empty("verticalListData");
    J.Cache.empty('navBarCache');
    getNewActiveData_control ({homePageActivityId : activityId,custom:0});
}

function getNewActiveData_control (par) {
    gitNewActivePage_service(par, function(data) {
        if(data.activityType == 1) {
            data.lists.map(function(item, i) {
                if(item.type == 1) {    //轮播图
                    item.banner.map(function(item2) {
                        item2.pic = picNetworkPrefix(item2.pic);
                    });
                }
                if(item.type == 2) {   //优惠券
                    var nowTime = new Date().getTime();
                    item.coupon.map(function(item2) {
                        //有效期前一天
                        var date = item2.endTime ? item2.endTime : '2099-12-31 23:59:59',
                        previousTime = 0,
                        defaultMark = 0,
                        startTime = item2.startTime.substring(0,10).replace(/-/g,'/'),
                        endTime = item2.endTime.substring(0,10).replace(/-/g,'/');
                        date = date.substring(0,19);    
                        date = date.replace(/-/g,'/'); 
                        previousTime= new Date(date).getTime() - 24*60*60*1000;
                        if(nowTime >= previousTime && endTime != startTime){
                            defaultMark = 1;
                        }
                        item2.defaultMark = defaultMark;
                        if(!isNullString(item2.cornerMarkPic)){
                            item2.cornerMarkPic = picNetworkPrefix(item2.cornerMarkPic);
                        }
                        // item2.startTime = item2.startTime.split(' ')[0];
                        // item2.endTime = item2.endTime.split(' ')[0];
                        if(!isNullString(item2.picture)){
                            item2.picture = picNetworkPrefix(item2.picture);
                        }
                        if(!isNullString(item2.titlePic)){
                            item2.titlePic = picNetworkPrefix(item2.titlePic);
                        }
                    });
                }
                if(item.type == 3) {

                }
                if(item.type == 4) {    //商品
                    
                    if(item.shopCategories) {
                        if(item.shopCategories.categoryImgUrl) {
                            item.shopCategories.categoryImgUrl = picNetworkPrefix(item.shopCategories.categoryImgUrl);
                        }
                        if(item.shopCategories.shopping){
                            item.shopCategories.shopping.map(function(item2){
                                if(item2.picUrl){//竖banner
                                    item2.picUrl = picNetworkPrefix(item2.picUrl);
                                }else{
                                    if(item2.picture) item2.picture = picNetworkPrefix(item2.picture);
                                    if(item2.serviceEventMarkPic){
                                        item2.serviceEventMarkPic = picNetworkPrefix(item2.serviceEventMarkPic);
                                    }
                                    if(item2.priceInUse){
                                        if(item2.priceInUse.indexOf('线上特惠') >= 0){
                                            item2.priceInUse = item2.priceInUse.split('线上特惠')[1];
                                        }
                                        if(item2.priceInUse.indexOf('：') >= 0){
                                            item2.priceInUse = item2.priceInUse.replace('：',':');
                                        }
                                    }
                                    if (item2.discountRuleType == 0 || item2.discountRuleType == 5) {//直降
                                        if(item2.priceNotInUseValue && item2.priceNotInUseValue != null) {
                                            item2.discountLabelPrice = (item2.priceNotInUseValue - item2.price4Show).toFixed(2);
                                        }
                                    } else if (item2.discountRuleType == 3) {//折扣
                                        item2.discountPercent = item2.discountPercent.toFixed(1);
                                        item2.priceInUse = '¥' + item2.priceInUse.split('¥')[1];
                                    } else if (item2.discountRuleType == 8) {//满减
        
                                    }
                                }
                            });
                        }
                    }
                }
                if(item.type == 5) {      //特价商品
                    if(data.lists[0].type == 1){
                        if(data.lists[0].banner && data.lists[0].banner.length != 0){
                            data.bgimage = picNetworkPrefix(data.lists[0].banner[0].pic);
                        }
                    }else if(data.lists[0].type == 6){
                        if(data.lists[0].pic){
                            data.bgimage = picNetworkPrefix(data.lists[0].pic[0].pic);
                        }
                    }
                    item.bargainGoods.map(function(item2) {
                        item2.serviceEvent.picture = picNetworkPrefix(item2.serviceEvent.picture);
                        if(item2.serviceEvent.serviceEventMarkPic){
                            item2.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item2.serviceEvent.serviceEventMarkPic);
                        }
                        if(item2.serviceEvent.priceInUse && item2.serviceEvent.priceInUse.indexOf('线上特惠') >= 0){
                            item2.serviceEvent.priceInUse = item2.serviceEvent.priceInUse.split('线上特惠')[1];
                        }
                        if (item2.serviceEvent.discountRuleType == 0 || item2.serviceEvent.discountRuleType == 5) {//直降
                            if(item2.serviceEvent.priceNotInUseValue && item2.serviceEvent.priceNotInUseValue != null) {
                                item2.serviceEvent.discountLabelPrice = (item2.serviceEvent.priceNotInUseValue - item2.serviceEvent.price4Show).toFixed(2);
                            }
                        } else if (item2.serviceEvent.discountRuleType == 3) {//折扣
                            item2.serviceEvent.discountPercent = item2.serviceEvent.discountPercent.toFixed(1);
                            item2.serviceEvent.priceInUse = '¥' + item2.serviceEvent.priceInUse.split('¥')[1];
                        } else if (item2.serviceEvent.discountRuleType == 8) {//满减

                        }
                    });
                }
                if(item.type == 6) {      //静态图
                    if(item.pic.length > 0){
                        item.pic.map(function(item2){
                            item2.pic = picNetworkPrefix(item2.pic);
                        });
                    }
                }
                if(item.type == 7) {       //小专题
                    item.themes.map(function(item2) {
                        item2.pic = picNetworkPrefix(item2.pic);
                    });
                }
                if(item.type == 8) {       // 综合型大横幅之场景模块
                    item.banner.map(function(item2) {
                        item2.pic = picNetworkPrefix(item2.pic);
                    });
                }
                if(item.type == 9) {       //综合型大横幅之挂载活动
                    item.banner.map(function(item2) {
                        item2.pic = picNetworkPrefix(item2.pic);
                    });
                }
                if(item.type == 10) {       //小号横幅
                    item.miniBanner.map(function(item2) {
                        item2.pic = picNetworkPrefix(item2.pic);
                    });
                }
                if(item.type == 11 || item.type == 17) {       //竖型横幅
                    if(item.list){
                        item.list.map(function(item2) {
                            if(item2.goodsInfo.length > 0){
                                item2.goodsInfo.map(function(item3){
                                    if(item3.picUrl){
                                        item3.picUrl = picNetworkPrefix(item3.picUrl);
                                    }else{
                                        item3.picture = picNetworkPrefix(item3.picture);
                                        if(item3.serviceEventMarkPic){
                                            item3.serviceEventMarkPic = picNetworkPrefix(item3.serviceEventMarkPic);
                                        }
                                        if(item3.priceInUse && item3.priceInUse.indexOf('线上特惠') >= 0){
                                            item3.priceInUse = item3.priceInUse.split('线上特惠')[1];
                                        }
                                        if (item3.discountRuleType == 0 || item3.discountRuleType == 5) {//直降
                                            if(item3.priceNotInUseValue && item3.priceNotInUseValue != null) {
                                                item3.discountLabelPrice = (item3.priceNotInUseValue - item3.price4Show).toFixed(2);
                                            }
                                        } else if (item3.discountRuleType == 3) {//折扣
                                            item3.discountPercent = item3.discountPercent.toFixed(1);
                                            item3.priceInUse = '¥' + item3.priceInUse.split('¥')[1];
                                        } else if (item3.discountRuleType == 8) {//满减
    
                                        }
                                    }
                                })
                            }
                        });
                    }
                }
                if(item.type == 12) {       //一组两件
                    item.bargainGoods.map(function(item2) {
                        item2.serviceEvent.picture = picNetworkPrefix(item2.serviceEvent.picture);
                        if(item2.serviceEvent.serviceEventMarkPic){
                            item2.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item2.serviceEvent.serviceEventMarkPic);
                        }
                        if(item2.serviceEvent.priceInUse && item2.serviceEvent.priceInUse.indexOf('线上特惠') >= 0){
                            item2.serviceEvent.priceInUse = item2.serviceEvent.priceInUse.split('线上特惠')[1];
                        }
                        if (item2.serviceEvent.discountRuleType == 0 || item2.serviceEvent.discountRuleType == 5) {//直降
                            if(item2.serviceEvent.priceNotInUseValue && item2.serviceEvent.priceNotInUseValue != null) {
                                item2.serviceEvent.discountLabelPrice = (item2.serviceEvent.priceNotInUseValue - item2.serviceEvent.price4Show).toFixed(2);
                            }
                        } else if (item2.serviceEvent.discountRuleType == 3) {//折扣
                            item2.serviceEvent.discountPercent = item2.serviceEvent.discountPercent.toFixed(1);
                            item2.serviceEvent.priceInUse = '¥' + item2.serviceEvent.priceInUse.split('¥')[1];
                        } else if (item2.serviceEvent.discountRuleType == 8) {//满减

                        }
                    });
                }
                if(item.type == 13){      //长形一排三组分别主题框
                    if(item.lb) {
                        item.lb.pic = picNetworkPrefix(item.lb.pic);
                    }
                    item.sp.map(function(item1){
                        if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                            if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                                item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                            }
                        }else if (item1.serviceEvent.discountRuleType == 3){//折扣
                            item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent.toFixed(1);
                        }else if (item1.serviceEvent.discountRuleType == 8) {//满减

                        }
                        if(item1.serviceEvent.serviceEventMarkPic){
                            item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                        }
                        if(item1.serviceEvent.picture){
                            item1.serviceEvent.picture = picNetworkPrefix(item1.serviceEvent.picture);
                        }
                    });
                }
                if(item.type == 14) {       //方形一排4-5组
                    item.subsetDetails.map(function(item1) {
                        if(item1.picUrl) {
                            item1.picUrl = picNetworkPrefix(item1.picUrl);
                        }
                    });
                }
                if(item.type == 15) {       //一组7件楼层
                    if(item.lb.pic) {
                        item.lb.pic = picNetworkPrefix(item.lb.pic);
                    }
                    item.sp.map(function(item1){
                        if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                            if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                                item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                            }
                        }else if(item1.serviceEvent.discountRuleType == 3){//折扣
                            item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent.toFixed(1);
                        }else if (item1.serviceEvent.discountRuleType == 8) {//满减

                        }
                        if(item1.serviceEvent.serviceEventMarkPic){
                            item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                        }
                        if(item1.serviceEvent.picture){
                            item1.serviceEvent.picture = picNetworkPrefix(item1.serviceEvent.picture);
                        }
                    });
                }
                if(item.type == 16) {      //超大商品页
                    if(item.pic){
                        item.pic.pic = picNetworkPrefix(item.pic.pic);
                    }
                }
                if(item.type == 18){      //新人商品
                    if(item.lb) {
                        item.lb.pic = picNetworkPrefix(item.lb.pic);
                    }
                    item.sp.map(function(item1){
                        if(item1.serviceEvent.discountRuleType == 0 || item1.serviceEvent.discountRuleType == 5){//直降
                            if(item1.serviceEvent.priceNotInUseValue && item1.serviceEvent.priceNotInUseValue != null) {
                                item1.serviceEvent.discountLabelPrice = (item1.serviceEvent.priceNotInUseValue - item1.serviceEvent.price4Show).toFixed(2);
                            }
                        }else if(item1.serviceEvent.discountRuleType == 3){//折扣
                            item1.serviceEvent.discountPercent = item1.serviceEvent.discountPercent.toFixed(1);
                        }else if(item1.serviceEvent.discountRuleType == 8){//满减
                        }
                        if(item1.serviceEvent.serviceEventMarkPic){
                            item1.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item1.serviceEvent.serviceEventMarkPic);
                        }
                        if(item1.serviceEvent.picture){
                            item1.serviceEvent.picture = picNetworkPrefix(item1.serviceEvent.picture);
                        }
                    });
                }
                if(item.type == 19) {
                    item.hotPic = picNetworkPrefix(item.hotPic);
                    item.list.map(function(item1) {
                        item1.goodsInfo.map(function(item2) {
                            item2.picture = picNetworkPrefix(item2.picture);
                            if(item2.serviceEventMarkPic){
                                item2.serviceEventMarkPic = picNetworkPrefix(item2.serviceEventMarkPic);
                            }
                            if(item2.priceInUse){
                                item2.priceInUse = '¥' + item2.priceInUse.split('¥')[1];
                            }
                        })
                    })
                }
            });
        } else if(data.activityType == 2) {
            data.lists.map(function(item) {
                item.foodMain.map(function(item2) {
                    if(item2.masterGraphUrl) {
                        item2.masterGraphUrl = picNetworkPrefix(item2.masterGraphUrl);
                    }

                })
            })
            console.log(data);
        }
        if(par.page == undefined){
            data.isScroll = false;//false是第一次加载
        }else{
            data.isScroll = true;//true下拉加载
        }
        data.homePageActivityId = par.homePageActivityId;
        data.timeOut = false;
        if(!data.allEnd){
            data.timeOut = true;
        }
        J.Cache.save("activePageData", data);
        buildNewActivePage_control();
    });

}
// 加载活动页其余子集
function asyncLoading(num,homePageActivityId){
    var verticalType = J.Cache.get('verticalType').data;
    if(num == $('#'+ verticalType + ' .navTab').length-1){
        return;
    }
    var par = {};
    par.num = num+1;
    var tab = $('#'+ verticalType + ' .navTab')[par.num];
    par.tabIndex = $(tab).attr('id');
    par.custom = $('#list' + par.tabIndex).data().custom;
    par.offSet = $('#list' + par.tabIndex).data().offset;
    par.pageIndex = $('#list' + par.tabIndex).data().pageindex;
    par.pageNumber = $('#list' + par.tabIndex).data().pagenumber;
    par.homePageActivityId = homePageActivityId;
    if(verticalType == 'navigationBar'){
        par.pageSize = 8;
    }else if(verticalType == 'threeGroupsBar'){
        par.pageSize = 15;  
    } else if(verticalType == 'navCrunchies') {
        par.pageSize = 15;
    }
    getVerticalBanne_control(par);
}
// 自定义竖横幅加载
function getVerticalBanne_control(par){
    par.custom = par.custom ? par.custom : '';
    par.offSet = par.offSet ? par.offSet : '';
    console.log('00090909090', par)
    getVerticalBanner_service(par,function(data){
        data['tab' + par.tabIndex] = false;
        if(data.list.length > 0){
            data['tab' + par.tabIndex]= true;
        }
        data.homePageActivityId = par.homePageActivityId;
        if(J.Cache.get('verticalType').data == 'navigationBar'){
            data.type = 11;
        }else if(J.Cache.get('verticalType').data == 'threeGroupsBar'){
            data.type = 17;
        } else if (J.Cache.get('verticalType').data == 'navCrunchies') {
            data.type = 19;
        }
        data.tabIndex = par.tabIndex;
        $('#list'+par.tabIndex).data().custom = data.custom;
        $('#list'+par.tabIndex).data().offset = data.offSet;
        $('#list'+par.tabIndex).data().pageindex = data.pageIndex;
        $('#list'+par.tabIndex).data().pagenumber = data.pageNumber;
        data.list.map(function(item, i) {
            if(item.picUrl){
                item.picUrl = picNetworkPrefix(item.picUrl);
            }else{
                item.picture = picNetworkPrefix(item.picture);
                if(item.serviceEventMarkPic){
                    item.serviceEventMarkPic = picNetworkPrefix(item.serviceEventMarkPic);
                }
                if(item.priceInUse && item.priceInUse.indexOf('线上特惠') >= 0){
                    item.priceInUse = item.priceInUse.split('线上特惠')[1];
                }
                if (item.discountRuleType == 0 || item.discountRuleType == 5) {//直降
                    if(item.priceNotInUseValue && item.priceNotInUseValue != null) {
                        item.discountLabelPrice = (item.priceNotInUseValue - item.price4Show).toFixed(2);
                    }
                } else if (item.discountRuleType == 3) {//折扣
                    item.discountPercent = item.discountPercent.toFixed(1);
                    item.priceInUse = '¥' + item.priceInUse.split('¥')[1];
                } else if (item.discountRuleType == 8) {//满减

                }
            }
        })
        var listData = {
            lists : [data]
        }
        if(par.num){
            asyncLoading(par.num,par.homePageActivityId);
        }else{
            if(data.mainTab){//第一个子集存起来mainTab这个字段
                $('#list' + par.tabIndex).data().maintab = data.mainTab;
                // $('#newActivePage_article .verticalBannerList.active').data().offset = data.offSet;
            }
            $('#list'+par.tabIndex).data().isload =  data['tab' + par.tabIndex];
            J.Cache.save("verticalListData", listData);
        }
        console.log(listData);
	    J.Template.render("#list"+par.tabIndex, "newActivePage_template", listData, 'add');
        floorCreateFly('newActivePage_section');
    });
}
// 自定义活动页渲染
function buildNewActivePage_control() {
	var data = J.Cache.get("activePageData").data;
	if(data.activity_bg_color != ''){
        $('#newActivePage_div').css('background', data.activity_bg_color);
    }
    // activityType: 1  自定义活动页， activityType: 2 菜单类型的活动页
    if(data.title.type == 1) {
        $('#newActivePage_section header').addClass('lucency');
        $('#newActivePage_section article').addClass('lucency');
    } else if(data.title.type == 2) {
        $('#newActivePage_section header').removeClass('lucency');
        $('#newActivePage_section article').removeClass('lucency');
        $('#newActivePage_section header h1').html(data.title.name);
    }
    var tplWay = data.isScroll == false ? 'replace': 'add' ;
    if(data.activityType == 1) {
        var datas = {
            list: '2'
        };
        J.Template.render("#newActivePage_div", "newActivePage_template", data, tplWay);
        // 第一次加载数据
        if(!data.isScroll){
            $('#newActivePage_article').addClass('renderAnim').css('overflow','hidden');
            setTimeout(function(){
                $('#newActivePage_article').css('overflow','auto');
                $('#newActivePage_article').scrollTop(1);
            },300)
            $('#newActivePage_article').css('background-image','none');
            $('#newActivePage_article').css('background-color','#fff');
        }
        data.lists.map(function (item) {
            if(item.type == 11 || item.type == 17 || item.type == 19){
                if(item.tabBar){
                    var par = {
                        homePageActivityId: data.homePageActivityId,
                    }
                    if(item.type == 11){//竖横幅一排两个
                        J.Cache.save('verticalType','navigationBar');
                        par.pageSize = 8;
                        if(item.tabBar[0].subtitle == null){
                            $('#navigationBar').height('12vw');
                            $('#navigationBar .navBarDiv').height('12vw');
                            $('#navigationBar .navTab').height('12vw');
                            $('#navigationBar .line').css('top','3.5vw');
                        }
                    }else if(item.type == 17){//竖横幅一排三个
                        J.Cache.save('verticalType','threeGroupsBar');
                        par.pageSize = 15;
                        if(item.tabBar[0].subtitle == null){
                            $('#threeGroupsBar').height('12vw');
                            $('#threeGroupsBar .navBarDiv').height('12vw');
                            $('#threeGroupsBar .navTab').height('12vw');
                            $('#threeGroupsBar .line').css('top','3.5vw');
                        }
                    } else if (item.type == 19) {//榜单
                        J.Cache.save('verticalType','navCrunchies');
                        par.pageSize = 15;
                        if(item.tabBar[0].subtitle == null){
                            $('#navCrunchies').height('10vw');
                            $('#navCrunchies .navBarDiv').height('10vw');
                            $('#navCrunchies .navTab').height('10vw');
                            $('#navCrunchies .line').css('top','2.5vw');
                        }
                    }
                    asyncLoading(0,data.homePageActivityId);
                    par.tabIndex = $('#'+ J.Cache.get('verticalType').data + ' div.navTab.active').attr('id');
                    if($('#' + J.Cache.get('verticalType').data + ' div.navTab.active').data().maintab){
                        //第一个子集存起来mainTab这个字段
                        var hasMainTab = $('#' + J.Cache.get('verticalType').data + ' div.navTab.active').data().maintab;
                        par.mainTab = hasMainTab;
                        $('#list' + par.tabIndex).data().maintab = hasMainTab;
                    }
                    par.offSet = $('#newActivePage_article .verticalBannerList.active').data().offset;
                    par.custom = $('#newActivePage_article .verticalBannerList.active').data().custom;
                    par.pageIndex = $('#newActivePage_article .verticalBannerList.active').data().pageindex;
                    par.pageNumber = $('#newActivePage_article .verticalBannerList.active').data().pagenumber;
                    item['tab' + par.tabIndex] = false;
                    if(item.list.length > 0){
                        item['tab' + par.tabIndex]= true;
                    }
                    item.tabIndex = par.tabIndex;
                    var listData = {
                        lists : [item]
                    }
                    J.Cache.save('verticalListData',listData);
                    $('#list'+ par.tabIndex).data().isload = false;
                    getVerticalBanne_control(par);
                }
            }
        })
        if(tplWay == 'replace'){
            $('.bg-blur').css('background','url(' + data.bgimage + ') no-repeat').css('background-size','100%');
        }
        if(data.isScroll == false){
            $('#newActivePage_section .scrolling')[0].scrollTop = 0;
        }
        floorCreateFly('newActivePage_section');
        data.lists.map(function(item, index) {
            if(item.type == 1) {
                var box = '#banner' + index + data.subsetId + ' ul';
                var par = {
                    loop: true, //循环切换
                    auto: true //自动切换
                };
                if($(box).children().length > 1) {
                    var scrollImg = Viwepager(box, par);
                }
            }
        });
    } else if(data.activityType == 2){
        J.Template.render("#newActivePage_div", "newActivePageMenu_template", data, "replace");
        floorCreateFly('newActivePage_section');
    }
}
//自定义活动页下拉
function newActivePagePullUp(){
    if(J.Cache.get("verticalListData") && J.Cache.get("verticalListData").data){
        verticalListPullUp();
        return;
    }
    var data;
    if(J.Cache.get("activePageData") && J.Cache.get("activePageData").data){
        data = J.Cache.get("activePageData").data;
    }else{
        return;
    }
    if (data.allEnd) {
        // 先不加到底提示，最后一个模块是banner时候会不好看
        // if(!data.activityEnd){
        //     $('#newActivePage_div').append('<div class="refresh-container"><span class="refresh-label" style="font-size: 3.5vw;">~~到底啦啊啊啊啊啊~~</span></div>');
        //     data.activityEnd = true;
        //     J.Cache.save("activePageData",data);
        // }
    }else{
        // 滚动条距离头部距离
        var scrollTop = $('#newActivePage_article').scrollTop();
        // 滚动条总高度
        var scrollHeight = $('#newActivePage_article')[0].scrollHeight;
        // 显示偏移区域高度
        var offsetHeight = $('#newActivePage_article')[0].offsetHeight;
        if(scrollHeight - scrollTop - offsetHeight <= 200) {
            if(data.timeOut){
                data.timeOut = false;
                J.Cache.save("activePageData", data);
                getNewActiveData_control({homePageActivityId : data.homePageActivityId,subsetId:data.subsetId,page:data.page,custom:data.custom});
            }
        }
    }
}
// 竖横幅下拉
function verticalListPullUp(){
    var par = {
        homePageActivityId: $("#currencyId").data().activitypageid
    }
    par.custom = $('#newActivePage_article .verticalBannerList.active').data().custom;
    par.pageIndex = $('#newActivePage_article .verticalBannerList.active').data().pageindex;
    par.pageNumber = $('#newActivePage_article .verticalBannerList.active').data().pagenumber;
    if(J.Cache.get('verticalType').data == 'navigationBar'){
        par.tabIndex = $('#navigationBar div.navTab.active').attr('id');
        par.pageSize = 8;
    }else if(J.Cache.get('verticalType').data == 'threeGroupsBar'){
        par.tabIndex = $('#threeGroupsBar div.navTab.active').attr('id');
        par.pageSize = 15;
    } else if (J.Cache.get('verticalType').data == 'navCrunchies') {
        par.tabIndex = $('#navCrunchies div.navTab.active').attr('id');
        par.pageSize = 15;
    }
    if($('#list' +  par.tabIndex).data().maintab){//第一个子集存起来mainTab这个字段
        var hasMainTab = $('#list' +  par.tabIndex).data().maintab;
        par.mainTab = hasMainTab;
    }
    par.offSet =  $('#newActivePage_article .verticalBannerList.active').data().offset;
    // // 滚动条距离头部距离
    // var scrollTop = $('#newActivePage_article .verticalBannerList.active').scrollTop();
    // // 滚动条总高度
    // var scrollHeight = $('#newActivePage_article .verticalBannerList.active')[0].scrollHeight;
    // // 显示偏移区域高度
    // var offsetHeight = $('#newActivePage_article .verticalBannerList.active')[0].offsetHeight;
    // if(scrollHeight - scrollTop - offsetHeight <= 100) {
        if($('#list'+ par.tabIndex).data().isload){
            $('#list'+ par.tabIndex).data().isload = false;
        }else{
            return;
        }
        getVerticalBanne_control(par);
    // }
}

//  竖型横幅切换tab
function changeTabBar(index,isTab){
    var verticalType = J.Cache.get("verticalType").data;
    var activeLeft = $($('#' + verticalType +' div.navTab.active')).offset().left;
    var id = $('#newActivePage_article .verticalBannerList.active')[0].id;
    if(J.Cache.get('navBarCache') && J.Cache.get('navBarCache').data){
        if($('#newActivePage_article').scrollTop() >= J.Cache.get('navBarCache').data - 5){
            $('#' + id).data().top = $('#newActivePage_article').scrollTop();
        }else{
            $('#newActivePage_article .verticalBannerList').map(function(i){
                $($('#newActivePage_article .verticalBannerList')[i]).data().top = 0;
            })
        }
    }
    $($('#' + verticalType + ' div.navTab')[index]).addClass('active').siblings('.navTab').removeClass('active');
    $($('#newActivePage_article .verticalBannerList')[index]).addClass('active').siblings('.verticalBannerList').removeClass('active');
    var actId = $('#newActivePage_article .verticalBannerList.active')[0].id;
    if(J.Cache.get('navBarCache') && J.Cache.get('navBarCache').data){
        if($('#newActivePage_article').scrollTop() >= J.Cache.get('navBarCache').data-5){
            if($('#' + actId).data().top && $('#' + actId).data().top != 0){
                $('#newActivePage_article').scrollTop($('#' + actId).data().top);
            }else{
                $('#newActivePage_article').scrollTop(J.Cache.get('navBarCache').data);
            }
        }
    }
    var left = $($('#' + verticalType +' div.navTab')[index]).offset().left;
    if(activeLeft > left){
        if(left <= $(window).width()*3/4){
            $('#' + verticalType + ' li').scrollLeft(  $('#' + verticalType + ' li').scrollLeft() - $($('#' + verticalType + ' div.navTab')[index]).width()*1.5);
        }
     }else if(left >= $(window).width()/3){
        $('#' + verticalType + ' li').scrollLeft(  $('#' + verticalType + ' li').scrollLeft() + $($('#' + verticalType + ' div.navTab')[index]).width()*1.2);
    }
}
function changeMenu(ele, id) {
    $(ele).addClass("active").siblings().removeClass("active");
    $('#newActivePage_div .menuList [data-id="' + id + '"]').addClass("active").siblings().removeClass("active");
}

// 获取菜品相关信息
function getFoodMain(foodMainId,isThis) {
    $("#currencyId").data().currency = foodMainId;
    if(isThis){//菜品跳菜品
        $('#foodMain_section').addClass('fadeInRight');
        setTimeout(function(){
            $('#foodMain_section').removeClass('fadeInRight');
        },300);
    }
    J.Router.goTo('#foodMain_section');
    var par = {
        foodMainId: foodMainId,
        wtyCommunityId: J.Cache.get("community").data.id
    }
    getFoodMain_service(par, function(data) {
        var data = data;
        // 步骤
        data.foodMain.picUrl = picNetworkPrefix(data.foodMain.picUrl);
        // banner
        if(data.foodMain.rotationUrls && $.trim(data.foodMain.rotationUrls).length > 0){
            data.foodMain.banner = data.foodMain.rotationUrls.split(",");
            data.foodMain.banner.map(function(item, i) {
                data.foodMain.banner[i] = picNetworkPrefix(item);
            })
        }
        // 食材
        data.foodDetails.map(function(item) {
            item.picture = picNetworkPrefix(item.picture);
        })
        // 推荐商品
        data.foodRecommends.map(function(item) {
            item.masterGraphUrl = picNetworkPrefix(item.masterGraphUrl);
        })
        J.Template.render("#foodMain_div", "foodMain_template", data, "replace");
        floorCreateFly('foodMain_section');
        $('#foodMain_div .cooking div .star_val').css("width", data.foodMain.difficulty * 4 + 'vw');
        $('#foodMain_section .scrolling')[0].scrollTop = 0;
        // 广告轮播
        var box = '#foodMainBanner ul';
        var par = {
            loop: true, //循环切换
            auto: true, //自动切换
            callback: function(ind) { //这里传过来的是索引值
                $('#foodMain_div  [data-name="foodImgBoxDoc"] ol li').eq(ind).addClass('active').siblings().removeClass('active');
            }
        }

        if(data.foodMain.banner.length > 1) {
            var scrollImg = Viwepager(box, par);
        }
    })
}

// 找相似菜品
function getSameFoodDetails(serviceEventId) {
    J.Router.goTo('#foodMaterial_section');
    cartNum_service('foodMaterial_section');
    var par = {
        serviceEventId: serviceEventId,
        wtyCommunityId: J.Cache.get("community").data.id
    }
    getSameFoodDetails_service(par, function(data) {
        console.log(data);
        data.sameDetails.map(function(item) {
            item.picture = picNetworkPrefix(item.picture);
            if(item.serviceEventMarkPic){
                item.serviceEventMarkPic = picNetworkPrefix(item.serviceEventMarkPic);
            }
            if(item.priceInUse && item.priceInUse.indexOf('线上特惠') >= 0){
                item.priceInUse = item.priceInUse.split('线上特惠')[1];
            }
            if (item.discountRuleType == 0 || item.discountRuleType == 5) {//直降
                if(item.priceNotInUseValue && item.priceNotInUseValue != null) {
                    item.discountLabelPrice = (item.priceNotInUseValue - item.price4Show).toFixed(2);
                }
            } else if (item.discountRuleType == 3) {//折扣
                item.discountPercent = item.discountPercent.toFixed(1);
                item.priceInUse = '¥' + item.priceInUse.split('¥')[1];
            } else if (item.discountRuleType == 8) {//满减

            }
        })

        J.Template.render("#foodMaterial_div", "foodMaterial_template", data.sameDetails, "replace");
        floorCreateFly('foodMaterial_section');

    })}
//抽奖转盘
function turnningPlate(data,turnplate) {
    // angles 初始位置到中奖奖项需要旋转的角度 减去每份的一半 指针指向中间
    // var angles = data.resultPrizeId * (360 / data.selection.length) - (360 / (data.selection.length * 2));
    var angles = data.resultPrizeId * (360 / data.selection.length);
    var ang = 360 - (360 / (data.selection.length * 2));
    if (angles < ang) {
        angles = ang - angles;
    } else {
        angles = 360 - angles + ang;
    }
    $('.pointer').click(function () {
        if(J.Cache.get('turnplate')){
            J.showToast('您的网络开小差啦');
            return;
        }
        if(data.remainingNumber <= 0){
            J.showToast('抽奖机会已经用完啦');
            return;
        }
        if (turnplate.bRotate) return;
        turnplate.bRotate = !turnplate.bRotate;
        rePrize(turnplate.txt.resultPrizeId);
        $('.turntable_box').stopRotate();
        $('.turntable_box').rotate({
            angle: 0,
            // animateTo: angles + 1860,
            animateTo: angles + 1800 + 360 / (data.selection.length * 2),
            duration: 3000,
            callback: function () {
                if(turnplate.txt.resultPrizeId == 0){
                    $('#congratulation').text('');
                    $('#winnerPrize').text(turnplate.txt.goodsName);
                }else {
                    $('#congratulation').text('恭喜你');
                    $('#winnerPrize').text(turnplate.txt.goodsName);
                }
                $('#turnResult').css('display','block');
            }
        });
    });
}
//雪花特效
var snowInterval;
function getsnow(){
    var container = document.querySelector(".snow");
    var containerWidth = $(container).width();
    var containerHeight = $(container).height();
    var particle;
    var camera;
    var scene;
    var renderer;
    var mouseX = 0;
    var mouseY = 0;
    var windowHalfX = window.innerWidth / 2;
    var windowHalfY = window.innerHeight / 2;
    var particles = [];
    var particleImages = [new Image(),new Image(),new Image(),new Image(),new Image()];
    particleImages[0].src = "img/snow1.png";
    particleImages[1].src = "img/snow2.png";
    particleImages[2].src = "img/snow3.png";
    particleImages[3].src = "img/snow4.png";
    particleImages[4].src = "img/snow5.png";
    var snowNum = 300;
    function init() {
        camera = new THREE.PerspectiveCamera(75, containerWidth / containerHeight, 1, 10000);
        camera.position.z = 1000;
        scene = new THREE.Scene();
        scene.add(camera);
        renderer = new THREE.CanvasRenderer();
        renderer.setSize(containerWidth, containerHeight);
        for (var i = 0; i < snowNum; i++) {
            var material = new THREE.ParticleBasicMaterial({ map: new THREE.Texture(particleImages[i % 5]) });
            particle = new Particle3D(material);
            particle.position.x = Math.random() * 2000 - 1000;
            particle.position.y = Math.random() * 2000 - 1000;
            particle.position.z = Math.random() * 2000 - 1000;
            particle.scale.x = particle.scale.y = 1;
            scene.add(particle);
            particles.push(particle)
        }
        if(container != null){
            container.appendChild(renderer.domElement);
            snowInterval = setInterval(loop, 1000 / 50)
        };
    }
    function loop() {
        for (var i = 0; i < particles.length; i++) {
            var particle = particles[i];
// 滚动到楼层模块，减少雪花 （自定义）
            if ($(window).scrollTop() < 1000) {
                particle.scale.x = particle.scale.y = 1;
            } else {
                if (i > particles.length / 5 * 3) {
                    particle.scale.x = particle.scale.y = 0;
                } else {
                    particle.scale.x = particle.scale.y = 0.8;
                }
            }
            particle.updatePhysics();
            with(particle.position) {
                if (y < -1000) {
                    y += 2000
                }
                if (x > 1000) {
                    x -= 2000
                } else {
                    if (x < -1000) {
                        x += 2000
                    }
                }
                if (z > 1000) {
                    z -= 2000
                } else {
                    if (z < -1000) {
                        z += 2000
                    }
                }
            }
        }
        camera.position.x += (mouseX - camera.position.x) * 0.005;
        camera.position.y += (-mouseY - camera.position.y) * 0.005;
        camera.lookAt(scene.position);
        renderer.render(scene, camera)
    }
    init()
}


// 抽奖暖场商品
function prizeGoods_control(index) {
    var par = {
        startIndex: index || 1,
        pageSize: 9
    }
    console.log('暖场商品', par);
    prizeGoods_service(par, function(data) {
        data.map(function(item) {
            item.picture = picNetworkPrefix(item.picture);
            item.serviceEventMarkPic = picNetworkPrefix(item.serviceEventMarkPic);
            item.priceStr = '¥' + item.priceInUse.split('¥')[1];

            if (item.discountRuleType == 0 || item.discountRuleType == 5) {//直降
                if(item.priceNotInUseValue && item.priceNotInUseValue != null) {
                    item.discountLabelPrice = (item.priceNotInUseValue - item.price4Show).toFixed(2);
                }
            }
        })
        var tplWay = par.startIndex > 1 ? 'add' : 'replace' ;
        console.log(data);
        if (par.startIndex == 1 || data.length) {
            J.Template.render('#turnShopList_ul','turnShopList_template', data, tplWay);
        }
        
        // 商品数量
        if (data.length >= par.pageSize) {
            $('#turnPlate_article').unbind().scroll(function() {
                var distance = $("#turnPlate_article > div").height() - $("#turnPlate_article").scrollTop();
                console.log(distance);
                if (distance < 1000) {
                    $('#turnPlate_article').unbind();
                    prizeGoods_control(par.startIndex + 1);
                }
            });

            // setTimeout(() => {
            // 	getMenuProductList_control(menuProductPar.menuId, menuProductPar.startIndex + 1);
            // }, 100);
        }else{
            $('#turnPlate_article').unbind();
            // if(!(data.length == 0 && menuProductPar.startIndex == 1)){
            // 	$('#menuProductList .refresh-container.finish').remove();
            // 	$('#menuProductList_ul').after('<div class="refresh-container finish"><span class="refresh-label">已加载完成</span></div>');
            // }
        }
    }, function() {
        
    })
}