Mobile = (function($) {
    // var serverUrl = "http://test.vipxiaoqu.com/wty/";
    var _body = "wty";
    var _key = "chuwa";
    var _payResult = false;
    /**
     * [pay description]
     * @param  {[type]} type            [weixinJSSDK 公众号支付 weixinQR 扫码支付 weixin 获取微信公众号支付参数 alipay 支付宝支付 union 银联支付]
     * @param  {[type]} money           [第三方支付金额]
     * @param  {[type]} businessText    [业务逻辑参数]
     * @param  {[type]} payMethod         [自定义支付方式]
     * @param  {[type]} successCall       [自定义成功回调方法]
     * @return {[type]}                 [description]
     */
    var pay = function(type, money, businessText,successCall,errorCall ,payMethod) {
        var method = {
            'alipay' : 1 ,
            'union' : 2,
            'weixinJSSDK' : 4,
            'weixin' : 5,
            'weixinQR' : 6,
        };

        if (type == "alipay") {
            var par = {
                payMethod: method[type],
                key: _key, //秘钥，一串写死的字符串
                total_fee: money,
                out_trade_no :  businessText.tradeNo,
                alreadyPayStr :  businessText.alreadyPayStr
            }
            // var payPar = getPaymentParams(par);
            getPaymentParams(par,function(e){
                console.log(e);
                var payPar = e;
                if (payPar != "false") {
                    var payInfo = payPar.alipayStr;
                    if (isIOS()) {
                        cordova.plugins.alipay.payment(payInfo, function success(e) {
                            if (successCall) {
                                successCall();
                            } else {
                                _payResult = true;
                                payResult();
                            }
                        }, function error(e) {
                            J.showToast(e.memo);
                            if(errorCall) {
                                errorCall();
                            }
                        });
                    } else {
                        cordova.plugins.alipay.payment(payInfo, function success(e) {
                            if (successCall) {
                                successCall();
                            } else {
                                _payResult = true;
                                payResult();
                            }
                        }, function error(e) {
                            if(errorCall) {
                                errorCall();
                            }
                        });
                    }
                }
            })
        } else if (type == "weixinJSSDK") {
            var par = {
                payMethod: method[type],
                wechatPayUrl: window.location.href.split("#")[0], //当前页面的绝对地址
                openId: J.Cache.get('openId').data,
                money: money,
                key: _key,
                body: _body,
                tradeNo :  businessText.tradeNo
            }
            if(payMethod){
                par.payMethod = payMethod ;
            }
            // var payPar = getPaymentParams(par);
            getPaymentParams(par,function(e){
                var payPar = e;
                wx.config({
                    debug: false,
                    appId: payPar.appid,
                    timestamp: payPar.timeStamp,
                    nonceStr: payPar.nonceStr,
                    signature: payPar.signature,
                    jsApiList: [
                        'chooseWXPay'
                    ]
                });
                if (payPar != "false") {
                    var mock = {
                        businessText: JSON.stringify(businessText),
                        money : money
                    }
                    wx.chooseWXPay({
                        timestamp: payPar.timeStamp+"",
                        nonceStr: payPar.nonceStr,
                        package: 'prepay_id=' + payPar.packages,
                        signType: payPar.signType,
                        paySign: payPar.paySign,
                        success: function(res) {
    //                  	$.post(payPar.wechatNotifyUrl, mock, function(data) {});
                            if(successCall){
                                successCall();
                            }else{
                                WeixinJSBridge.invoke('closeWindow', {}, function(res) {
                                    alert(res.err_msg);
                                });
                            }
                        },
                        cancel: function(res) {
                            console.log("微信支付错误", par, res);
                            errorCall();
                        },                 
                        fail:function(res) {
                            errorCall();
                        }
                    });
                }
            }) 
        } else if (type == "weixinQR") {
            var par = {
                payMethod: method[type],
                money: money,
                businessText: JSON.stringify(businessText),
                orderNo:  businessText.tradeNo,
                body: _body,
                key: _key
            }
            // var payPar = getPaymentParams(par);
            getPaymentParams(par,function(e){
                var payPar = e;
                if (payPar != "false") {
                    //这里还要改，放到新页面
                    var $img;
                    $("#QRimg").show();
                    $img = $("<img />");
                    var _QRCodeUrl = payPar.QRCodeUrl.replace(/&quot;/g,'"');
                    console.log(_QRCodeUrl)
                    $img.attr("src", _QRCodeUrl);
                    $("#QRimg").append($img);
                }
            })
           
        } else if (type == "union") {
            var par = {
                payMethod: method[type],
                key: _key,
                txnAmt: money,
                orderNo:  businessText.tradeNo,
                reqReserved: JSON.stringify(businessText)
            }
            var url = serverUrl + "pay/payment/paymentAction!getPaymentParams.sy?";
            if (isIOS()) {
                $.getJSON(url, par, function(data) {
                    if (data.success) {
                        navigator.unionpay.pay({
                            tn: data.obj.tn
                        }, function(code) {
                            _payResult = true;
                            payResult();
                        }, function(code) {

                        });
                    }
                })
            } else {
                var permissions = cordova.plugins.permissions;
                permissions.hasPermission(permissions.READ_PHONE_STATE, checkPermissionCallback, null);

                function checkPermissionCallback(status) {
                    if (!status.hasPermission) {
                        var errorCallback = function() {
                            alert("您没有赋予应用足够的权限，无法支付");
                        }

                        permissions.requestPermission(
                            permissions.READ_PHONE_STATE,
                            function(status) {
                                if (!status.hasPermission) errorCallback();
                            },
                            errorCallback);
                    } else {
                        $.getJSON(url, par, function(data) {
                            if (data.success) {
                                navigator.unionpay.pay({
                                    tn: data.obj.tn
                                }, function(code) {
                                    _payResult = true;
                                    payResult();
                                }, function(code) {

                                });
                            }
                        })
                    }
                }

            }

        } else if (type == "weixin") {
            var par = {
                payMethod: method[type],
                money: money,
                wechatPayUrl: window.location.href.split("#")[0], //当前页面的绝对地址
                tradeNo:  businessText.tradeNo,
                openId:  businessText.openId,
                key: _key
            }
            // var dzyOpenId = "oOmXqjh_5q5Q1xwY4NBCcrgEgQ6I";
            par.openId = dzyOpenId;
            // var payPar = getPaymentParams(par);
            getPaymentParams(par,function(e){
                var payPar = e;
                var params = {
                    appId: payPar.appid,
                    partnerid: payPar.partnerId, // 商户id
                    prepayid: payPar.packages, // prepay id
                    noncestr: payPar.nonceStr, // nonce
                    timestamp: payPar.timeStamp, // timestamp
                    sign: payPar.signType, // signed string
                };
                console.log('微信支付参数', params);
                Wechat.sendPaymentRequest(params, function() {
                    _payResult = true;
                    payResult();
                }, function(reason) {
                    console.log('支付失败回调', reason);
                    if(errorCall) {
                        errorCall();
                    }
                });
            });
        }
    }
    /**
     * [readyPay 预付款接口，获取各个支付方式需要的参数]
     * @param  {[type]} type [1公众号支付 2扫码支付 3获取微信公众号支付参数 4支付宝支付 5银联支付]
     * @return {[type]} e    [各个支付方式需要的参数]
     */
    var getPaymentParams = function(par,callback) {
            var e;
            var par = par;
            var url = serverUrl + "ws/paymentAction!getPaymentParams.sy";
            // $.ajaxSettings.async = false;

            $.getJSON(url, par, function(data) {
                if (data.success) {
                    e = data.data;
                    console.log(e);
                } else {
                    e = "false";
                    J.showToast(data.message);

                    if (data.code == 4003) {
                        if (isWechatClient()) {
                            getOpenId();
                        }
                    }
                }
                callback(e);
            })
            // return e;
        }
        /**
         * [isIOS 判断IOS/Android]
         * @return {Boolean} [true 是IOS]
         */
    var isIOS = function() {
        if (window.device.platform == "Android") {
            return false;
        } else {
            return true;
        }
    };

    var payResult = function() {
        if (_payResult) {
            J.showToast("支付成功");
            window.history.go(-1);
        } else {
            J.alert("支付失败");
        }
    };
    return {
        pay: pay,
        getPaymentParams: getPaymentParams,
        isIOS: isIOS,
        payResult: payResult
    }
})(J.$);
