/**
 * [getShoppingCar_control 获取购物车数据处理]
 * @param  {Object} data [处理数据]
 */
function getShoppingCar_control(data) {
	J.Cache.save('shoppingCarData', data);
	J.Cache.save('editArray', []);
	J.Template.render("#shoppingCar_article", "shoppingCar_template", data, "replace");
    getSelectedMemory();
    slideDelete(0);
    // 失效商品除去第一条外隐藏
    if ($("#shoppingCar_article ul.invalidList li").length > 1){
        $("#shoppingCar_article ul.invalidList li:not(:first-of-type)").hide();
    }
}
/**
 * [getSelectedMemory 处理用户信息--选中记忆]
 * @param  {Object} selMemory [购物车选中记忆]
 * @param  {Number} id  [片区id]
 * @param  {Number} userId [用户id]
 */
function getSelectedMemory() {
    // 取消订单再次购买全选购物车
    if (J.Cache.get('checkAll')) {
        if (J.Cache.get('checkAll').data) {
            $('#totalChecked').trigger('click');
            J.Cache.empty('checkAll');
            return;
        }
    }

    var selMemory,id,userId;
    if(J.Cache.get('community')){
        id = J.Cache.get('community').data.id;
    }
    if(J.Cache.get('selectedMemory')){
        selMemory = J.Cache.get('selectedMemory').data;
        if(J.Cache.get('login')){
            userId= J.Cache.get('login').data.id;
            if(!isEmptyObject(selMemory[id]) && !isEmptyObject(selMemory[id][0])){
                selMemory[id][userId] = $.extend(selMemory[id][0],selMemory[id][userId]);
                delete selMemory[id][0];
            }
        }else{
            userId = 0;
        }
        if(!isEmptyObject(selMemory[id]) && !isEmptyObject(selMemory[id][userId])){
            showSelectedMemory_control(selMemory,id,userId);
        }
    }
}
/**
 * [cacheSelectedMemory 存储选中记忆]
 * @param  {Boolean} hasActive [是否选中] 选中存1，未选中存0
 * @param  {string} type [操作类型] 'add'：添加选中数据， 'del':删除选中数据
 * @param  {Object} selectedMemory [购物车选中记忆]
 * @param  {Number} id  [片区id]
 * @param  {Number} userId [用户id] 默认值0--未登录状态下没有用户
 */
function cacheSelectedMemory(ele,hasActive,type) {
    var val = ele.val(),
        selectedMemory,
        id,
        userId=0;
    if(J.Cache.get('login')) {
        userId = J.Cache.get('login').data.id;
    }
    if(J.Cache.get('community')) {
        id= J.Cache.get('community').data.id;
    }
    if(J.Cache.get('selectedMemory')){
        selectedMemory= J.Cache.get('selectedMemory').data;
        if(isEmptyObject(selectedMemory[id])){
            selectedMemory[id] = {};
        }
        if(isEmptyObject(selectedMemory[id][userId])){
            selectedMemory[id][userId] = {};
        }
    }else {
        selectedMemory = {};
        selectedMemory[id] = {};
        selectedMemory[id][userId] = {};
    }
    if(hasActive){
        if(type == 'add'){
            selectedMemory[id][userId][val] = 1;
        }else{
            if(!J.Cache.get('login')){
                delete selectedMemory[id][userId][val];
            }
        }
    }else{
        selectedMemory[id][userId][val] = 0;
    }
    J.Cache.save('selectedMemory',selectedMemory)

}

/**
 * [showSelectedMemory_control 显示选中记忆]
 * @param  {Object} memory [购物车选中记忆]
 * @param  {Number} id  [片区id]
 * @param  {Number} userId [用户id]
 */
function showSelectedMemory_control(memory,id,userId){
    var ids = memory[id][userId],
        list={};
    $("#shoppingCar_article ul.validList li").each(function(){
        list[$(this).val()] = $(this);
    });
    for(var i in ids) {
        if(list[i]){
            if(ids[i] == 1){
                $(list[i][0]).find('label[data-name=radio]').trigger('click');
            }else{
                $(list[i][0]).find('label[data-name=radio]').removeClass('active');
            }
        }else{
            if(J.Cache.get('login')){
                delete memory[id][userId][i];
            }
        }
    }
    J.Cache.save('selectedMemory',memory);
}
// 左滑删除 type 0:购物车 1：我的地址列表
function slideDelete(type){
    var startX,endX;
    $('.item-box').off('click').on('click',function(){
        if(checkSlide()) {
            restSlide();
        }else{
            if(type == 0){
                getServiceEventDetails_service($(this).find('.left.car').data().id, {sName: '', sIndex: 0});
            }else{
                homeSwitchMyAddress_servic($(this).parent(), $(this).parent().data().id)
            }
        }
    })
    $('.list-item').off('touchstart').on('touchstart',function(e){
        // 记录初始位置
        startX = e.touches[0].clientX;
        console.log(e);
    })
    $('.list-item').off('touchend').on('touchend',function(e){
        // 当前滑动的元素
        var parentElement = e.currentTarget;
        console.log(parentElement.dataset.type);
        // 记录结束位置
        endX = e.changedTouches[0].clientX;
        console.log(endX);
        // 左滑
        if( parentElement.dataset.type == 0 && startX - endX > 100 ){
            restSlide();
            if(type == 0){
                $('.delete').css('line-height',Number($('.delete').height())-10 + 'px');
            }else{
                $('.delete').css('line-height',Number($('#myAddress_section .delete').height()) + 'px');
            }
            parentElement.dataset.type = 1;
        }
        // 右滑
        if( parentElement.dataset.type == 1 && startX - endX < -30 ){
            restSlide();
            parentElement.dataset.type = 0;
        }
        startX = 0;
        endX = 0;
    })
}
//复位滑动状态
function restSlide(){
    var listItems = document.querySelectorAll('.list-item');
    // 复位
    for( var i = 0 ; i < listItems.length ; i++){
        listItems[i].dataset.type = 0;
    }
}
//判断当前是否有滑块处于滑动状态
function checkSlide(){
    var listItems = document.querySelectorAll('.list-item');
    for( var i = 0 ; i < listItems.length ; i++){
        if( listItems[i].dataset.type == 1 ) {
            return true;
        }
    }
    return false;
 }
/**
 * [controlFold_control 无效商品折叠展开]
 * @param  {String} type [点击类型 '0'展开 '1'折叠]
 */
function controlFold(ele,type){
    var element = $("#shoppingCar_article ul.invalidList li:not(:first-of-type)");
    switch (type) {
    case 0:
        element.show();
        break;
    case 1:
        element.hide();
        break;
    }
    $(ele).removeClass('active').siblings().addClass('active');
}
/**
 * [countTotal_control 计算价格和数量]
 * @param  {Object} elements [当前元素]
 * @param  {String} handleType  [点击类型 'one'单体 'all'全选 'some'一系列商品]
 */
function countTotal_control(elements, handleType) {
    var shopCarList = {}
	var isAllOn = true;
    $(elements).toggleActive();
    if($(elements).hasClass('active')){
        $('#payMoney').removeClass('notClick');
    }
	if(handleType == 'one') {
		var isSomeOn = true;
		var ele = elements.parentElement.parentElement.querySelector('.car_title');
		var eleLi = elements.parentElement.parentElement.querySelectorAll('label[data-name=radio]');
		for(var i = 0; i < eleLi.length; i++) {
			isSomeOn = isSomeOn && $(eleLi[i]).hasClass('active');
		}
		isSomeOn ? $(ele).addClass('active') : $(ele).removeClass('active');
	}
	$("#shoppingCar_article ul.validList li").each(function(index,element) {
		var el = $(this).find('label[data-name=radio]');
		if (handleType == 'all'){
			$(elements).hasClass('active') ? el.addClass('active') : el.removeClass('active');
			this.parentElement.querySelector('.car_title').className =  $(elements).hasClass('active') ? 'car_title active' : 'car_title'
		}else if (handleType == 'one'){
			$("#totalChecked").removeClass('active');
		}else if (handleType == 'some'){
			$(elements).hasClass('active') ? $(elements).parent().find('label[data-name=radio]').addClass('active') : $(elements).parent().find('label[data-name=radio]').removeClass('active');
			$("#totalChecked").removeClass('active');
		}

        // 商户
        var merchantid = el.data().merchantid;
        var merchantName = el.data().key;
        var basicWeight = $(el).parents('.validList').data().basicweight;
        var amount = $(el).parents('.validList').data().amount;
        if (!shopCarList[merchantid]) {
            shopCarList[merchantid] = {
                merchantName: merchantName,
                basicWeight: basicWeight,
                amount: amount,
                total: 0,
                num: 0,
                totalWeight: 0,
                // 品类满减
                cateList: []
                
            }
        }
        
		if (el.hasClass('active')) {
            var num = parseInt(el.data().num);
            var price = el.attr('data-price');
            var weight = el.data().weight;
            var discountRule = el.data().discountrule;
            var type = el.data().type;
            var nnum = el.data().nnum;
            var proportion = el.data().proportion;
            var merchantMoney = 0;
            if (type == 6) {
                merchantMoney = merchantMoney + parseInt(num - parseInt(num / nnum)) * price + parseInt(num / nnum) * 0;
            } else if (type == 7) {
                merchantMoney = merchantMoney + parseInt(num - parseInt(num / nnum)) * price + parseInt(num / nnum) * price * proportion;
            } else if (type == 8) {
                var p = discountRule.substring(1).split('减');
                var m = price * num;
                if(p[0]>m){
                    merchantMoney += price * num;
                }else{
                    merchantMoney += price * num - p[1];
                }
            } else {
                merchantMoney += price * num;
            }

            // 不同门店的价格
            shopCarList[merchantid].total = ((shopCarList[merchantid].total || 0)*1 + merchantMoney).toFixed(2);
            shopCarList[merchantid].num += num;
            shopCarList[merchantid].totalWeight += weight * num;
			// totalNum += num;
			cacheSelectedMemory($(this), true, 'add');
		}else{
            cacheSelectedMemory($(this), false, 'add');
            // 不同门店的价格
            // shopCarList[merchantid].total = ((shopCarList[merchantid].total || 0)*1 + merchantMoney).toFixed(2);
            // console.log('0000000000000', merchantMoney)
        }
		isAllOn = isAllOn && el.hasClass('active');
	})


    // 品类满减
    var cateInfo = pay.cateInfo;
    for (const key in shopCarList) {
        if (Object.hasOwnProperty.call(shopCarList, key)) {
            const item = shopCarList[key];

            for (const cateNumber in cateInfo) {
                if (Object.hasOwnProperty.call(cateInfo, cateNumber)) {
                    const cate = cateInfo[cateNumber];
                    // 获取满足条件的商品
                    var targetList = $("#shoppingCar_article ul.validList li label.active[data-name=radio][data-merchantid='"+key+"'][data-batch='"+cateNumber+"']");

                    var total = 0;
                    targetList.each(function() {
                        var el = $(this);
                        console.log('带批次号的商品', el.data().price, parseInt(el.data().num), el);
                        var price = el.data().price;
                        var num = el.data().num;
                        total += price * num;
                    })

                    if (total > cate.man) {
                        console.log(item.total, cate.jian);
                        item.total = (item.total * 1 - cate.jian).toFixed(2);
                        item.cateList.push(cate);
                        console.log('0.0.0.0.0,品类满减成功',item.total, item, cate);
                    }
                }
            }
        }
    }


    
    // 总计
    var aggregate = 0;
    var allUp = 0;
    pay.par.disType = 1;
    pay.selectMerchant = [];
    for (const key in shopCarList) {
        if (Object.hasOwnProperty.call(shopCarList, key)) {
            const item = shopCarList[key];
            aggregate = Math.formatFloat(aggregate * 1 + item.total * 1).toFixed(2);
            allUp = allUp + item.totalWeight;

            // 判断自提还是配送
            if (key == 2) {
                console.log(key,item)
                if (item.basicWeight < item.totalWeight) {
                    pay.par.disType = 2;
                    
                }
            }
            if (item.num > 0) {
                pay.selectMerchant.push(key);
            }
        }
    }

    $("#totalMoney").text(aggregate);
    console.log("总价总重", aggregate, allUp);

    console.log('不同商户选中商品的总价', shopCarList)
    J.Template.render("#shoppingCartSettlement", "shoppingCartSettlement_template", shopCarList, "replace");

    isAllOn ? $("#totalChecked").addClass('active') : $("#totalChecked").removeClass('active');

    for (var key in shopCarList) {
        if (Object.hasOwnProperty.call(shopCarList, key)) {
            var item = shopCarList[key];
            var difference = Math.formatFloat(item.amount - item.total);
            if (difference <= 0) {
                $("#shoppingCar_article ul.list_icon[data-merchantid='"+key+"'] .settlement .orderAmountMoney").text(0);
                $("#shoppingCar_article ul.list_icon[data-merchantid='"+key+"'] .addOnHint").hide();
            } else {
                $("#shoppingCar_article ul.list_icon[data-merchantid='"+key+"'] .settlement .orderAmountMoney").text(difference);
                $("#shoppingCar_article ul.list_icon[data-merchantid='"+key+"'] .addOnHint").show();
            }
            
        }
    }
}

// 计算购物车价格和数量(编辑商品数量)
function countTotalAndNumber_control() {
    var shopCarList = {}
    var totalNum = 0;
    var isAllOn = true;
    $("#shoppingCar_article ul.validList li").each(function() {
        var el = $(this).find('label[data-name=radio]');

        // 商户
        var merchantid = el.data().merchantid;
        var merchantName = el.data().key;
        var basicWeight = $(el).parents('.validList').data().basicweight;
        var amount = $(el).parents('.validList').data().amount;
        if (!shopCarList[merchantid]) {
            shopCarList[merchantid] = {
                merchantName: merchantName,
                basicWeight: basicWeight,
                amount: amount,
                total: 0,
                num: 0,
                totalWeight: 0,
                cateList: []
            }
        }

        if (el.hasClass('active')) {
            var num = parseInt(el.data().num);
            var price = el.attr('data-price');
            var weight = el.data().weight;
            var discountRule = el.data().discountrule;    
            var type = el.data().type;
            var nnum = el.data().nnum;
            var proportion = el.data().proportion;
            var merchantMoney = 0;

            if (type == 6) {
                merchantMoney = merchantMoney + parseInt(num - parseInt(num / nnum)) * price + parseInt(num / nnum) * 0;
            } else if (type == 7) {
                merchantMoney = merchantMoney + parseInt(num - parseInt(num / nnum)) * price + parseInt(num / nnum) * price * proportion;
            }  else if (type == 8) {
                var p = discountRule.substring(1).split('减');
                var m = price * num;
                if(p[0]>m){

                    merchantMoney += price * num;
                }else{

                    merchantMoney += price * num - p[1];
                }
            } else {

                merchantMoney += price * num;
            }

            // 不同门店的价格
            shopCarList[merchantid].total = ((shopCarList[merchantid].total || 0)*1 + merchantMoney).toFixed(2);
            shopCarList[merchantid].num += num;
            shopCarList[merchantid].totalWeight += weight * num;
        }

        isAllOn = isAllOn && el.hasClass('active');
    })

    // 品类满减
    var cateInfo = pay.cateInfo;
    for (const key in shopCarList) {
        if (Object.hasOwnProperty.call(shopCarList, key)) {
            const item = shopCarList[key];

            for (const cateNumber in cateInfo) {
                if (Object.hasOwnProperty.call(cateInfo, cateNumber)) {
                    const cate = cateInfo[cateNumber];
                    // 获取满足条件的商品
                    var targetList = $("#shoppingCar_article ul.validList li label.active[data-name=radio][data-merchantid='"+key+"'][data-batch='"+cateNumber+"']");

                    var total = 0;
                    targetList.each(function() {
                        var el = $(this);
                        console.log('带批次号的商品', el.data().price, parseInt(el.data().num), el);
                        var price = el.data().price;
                        var num = el.data().num;
                        total += price * num;
                    })

                    if (total > cate.man) {
                        console.log(item.total, cate.jian);
                        item.total = (item.total * 1 - cate.jian).toFixed(2);
                        item.cateList.push(cate);
                        console.log('0.0.0.0.0,品类满减成功',item.total, item, cate);
                    }
                }
            }
        }
    }


    for (var key in shopCarList) {
        var item = shopCarList[key].total;
        console.log('06666666',item)
        $("#shoppingCar_article .merchantPay[data-merchant='" + key + "'] .merchantMoney").text(item);
    }

    // 总计
    var aggregate = 0;
    var allUp = 0;
    pay.par.disType = 1;
    pay.selectMerchant = [];
    for (const key in shopCarList) {
        if (Object.hasOwnProperty.call(shopCarList, key)) {
            const item = shopCarList[key];
            aggregate = Math.formatFloat(aggregate * 1 + item.total * 1).toFixed(2);
            allUp = allUp + item.totalWeight;

            // 判断自提还是配送
            if (key == 2) {
                if (item.basicWeight < item.totalWeight) {
                    pay.par.disType = 2;
                }
            }
            if (item.num > 0) {
                pay.selectMerchant.push(key);
            }
        }
    }

    $("#totalMoney").text(aggregate);
    console.log("总价总重", aggregate, allUp);

    console.log('不同商户选中商品的总价111', shopCarList)
    J.Template.render("#shoppingCartSettlement", "shoppingCartSettlement_template", shopCarList, "replace");

    $("#totalNum").text(totalNum);

    for (var key in shopCarList) {
        if (Object.hasOwnProperty.call(shopCarList, key)) {
            var item = shopCarList[key];
            var difference = Math.formatFloat(item.amount - item.total);
            if (difference <= 0) {
                $("#shoppingCar_article ul.list_icon[data-merchantid='"+key+"'] .settlement .orderAmountMoney").text(0);
                $("#shoppingCar_article ul.list_icon[data-merchantid='"+key+"'] .addOnHint").hide();
            } else {
                $("#shoppingCar_article ul.list_icon[data-merchantid='"+key+"'] .settlement .orderAmountMoney").text(difference);
                $("#shoppingCar_article ul.list_icon[data-merchantid='"+key+"'] .addOnHint").show();
            }
            
        }
    }

    // 配送指标（满多少包邮，还差多少）
    // var orderAmount = $("#orderAmount").text();
    // var orderAmountMoney = orderAmount - shopCarList[2];
	// if(orderAmountMoney > 0){
	// 	$('#orderAmountMoney').text(orderAmountMoney.toFixed(2));
    //     $('#addOnHint').css('display','block');
	// }else{
    //     $('#addOnTip').css('display','none');
    //     $('#addOnHint').css('display','none');
	// }
}

/**
 * [deleteEvents_control 删除购物车选中商品]
 * @param  {Number} id [单品id 左滑删除]
 */
function deleteEvents_control(id) {
    var deleteArr = [];
    if(id){
        deleteArr.push(id);
    }else{
        $("#shoppingCar_article ul.validList li").each(function() {
            if ($(this).find('label[data-name=radio]').hasClass('active')) deleteArr.push(parseInt($(this).val()));
        })
    }
	deleteArr.length != 0 ? J.Popup.confirm4('提示','确认将这些宝贝删除?','取消','确认', function() {
        console.log(deleteArr);
        if(id){//单品左滑删除
            deleteShoppingCar_service(deleteArr,function(){
                $("#shoppingCar_article ul.validList li").each(function() {
                    if ($(this).val() == id) {
                        if($(this).parent()[0].children.length <= 3){
                            $(this).parent().find('p.car_title').remove();
                            $(this).parent().find('div.settlement').remove();
                        }
                        $(this).remove();
                        countTotal_control();//计算价格和数量
                        var hasActive = $(this).find('label[data-name=radio]').hasClass('active');
                        cacheSelectedMemory($(this),hasActive,'del');//更新记忆选中缓存
                    };
                })
            });
        }else{
            deleteShoppingCar_service(deleteArr, function() {
                $("#shoppingCar_article ul.validList li").each(function() {
                    if ($(this).find('label[data-name=radio]').hasClass('active')) {
                        if($(this).parent()[0].children.length <= 3){
                            console.log($(this).parent());
                            $(this).parent().find('p.car_title').remove();
                            $(this).parent().find('div.settlement').remove();
                        }
                        $(this).remove();
                        $("#totalNum").text("0");
                        $("#totalMoney").text("0.00");
                        $('#addOnTip').css('display','none');
                        // $('#addOnHint').css('display','none');
                        // $('#shoppingCart_article .scrolling').css('bottom','51px');
                        cacheSelectedMemory($(this),true,'del');
                    }
                });
                $('.newGoods .sp li .mes i.active').removeClass('active').text('选它');
                countTotal_control();//计算价格和数量
            });
        }
	},function(){
        // 取消操作
    }) : J.showToast('您还没有选择宝贝哦');
}
/**
 * [deleteInvalidEvents_control 删除购物车失效商品]
 */
function deleteInvalidEvents_control() {
	var Obj = {},
        deleteArr = [];
	$("#shoppingCar_article ul.invalidList li").each(function() {
        var item = $(this).data();
        if(!J.Cache.get('login')) {
            item.unloginId = getUnloginId();
        }
        Obj[item.id] = item;
	});
	for (var i in Obj ){
        deleteArr.push(Obj[i]);
    }
	J.Popup.confirm4('提示','确认将这些宝贝删除?','取消','确认', function() {
        deleteInvalidEvents_service(deleteArr);
	},function (){
        // 取消操作
    });
}

/**
 * [editShopCar_control 编辑购物车]
 * @param  {Object} elements   [当前元素]
 * @param  {String} handleType [操作类型  'edit'编辑 'finish'完成]
 */
function editShopCar_control(elements, handleType) {
	$(elements).parent().hide().siblings('nav.right').show();
	var fn = {
		edit: function() {
			$("#shoppingCar_article div.right.edit").show().siblings("div.right").hide();
			$("#payMoney").hide().siblings(".sub-btn").show();
		},
		finish: function() {
			$("#shoppingCar_article div.right.edit").hide().siblings("div.right").show();
			$("#payMoney").show().siblings(".sub-btn").hide();
			if(!J.Cache.get('login')) {
                // J.showToast('请先登录哟~');
                // return;
				getOfflineShoppingCar_service();
			} else {
				getShoppingCar_service();
			}

		},
		clearData: function() {
			$("#shoppingCar_article").find('label[data-name=radio]').removeClass('active');
			$("#shoppingCar_article .car_title").removeClass('active');
			$("#totalChecked").removeClass('active');
			$("#totalNum").text("0");
			$("#totalMoney").text("0.00");
		}
	}
	fn[handleType]();
	fn.clearData();
}

/**
 * [editShopCarNum_control 编辑购物车商品数量]
 * @param  {Object} elements [当前元素]
 * @param  {Number} id       [编辑商品id]
 * @param  {Number} num      [现在数量]
 * @param  {String} handleType  [编辑类型  'mulNum'减 'addNum'加 不存在该参数则为手动输入]
 * @param  {Number} canBuyNumber     [限购，-1则不限购]
 * @param  {Number} stockNum         [库存]
 * @param  {Number} beginBuyNum      [最小数]
 */
function editShopCarNum_control(id, num, elements,handleType,canBuyNumber,stockNum,beginBuyNum) {
    var canEdit = true;
    if(handleType) eidtNum(handleType, num, elements,canBuyNumber,stockNum,beginBuyNum,function(){
        canEdit = false;
    });
	var newNum = handleType ? parseInt($(elements).siblings('input').val()) : $(elements).val();
	// 手动输入时判断
	if(!handleType){
		var msg = /^[0-9]*$/;
		if(msg.test(newNum)){
			if(newNum <= 0){
				J.showToast('数量至少为1~~');
                $(elements).val($(elements).data().val);
				return;
			}
		}else{
			J.showToast('请输入数字');
            console.log('以前的数字', $(elements).val());
			$(elements).val($(elements).data().val);
			return;
		}
	}
	var editArray = [];
	var obj = {
		shoppingCarId: id,
		num: parseInt(newNum)
	};
	var handle = {
		success : function(data){
            // console.log(elements)
            $('.item[value="' + id + '"] label').data().num = obj.num;
            $('.item[value="' + id + '"] label').attr('data-num',obj.num);//编辑之后改变data-num属性值
            // console.log($('.item[value="' + id + '"] label').data().num);
            
            // 重新计算价格
            countTotalAndNumber_control();

            // if(!J.Cache.get('login')) {
            //     console.log('------')
            //     getOfflineShoppingCar_service('edit');
            // } else {
            //     getShoppingCar_service('edit');
            // }

            // 修改购物车的时候判断你是否有优惠规则 针对超出数量按原价购买商品
            if(data.discountRule != null){
                if(J.Cache.get('login')) {
                    getShoppingCar_service()
                }
            }
            cartNum_service();
		},
		error : function(data){
			var msg = (isNullString(data.message)) ? error_message : data.message;
			J.showToast(msg);
			handleType ? $(elements).siblings('input').val(num) : $(elements).val(num);
		}
	};
	editArray.push(obj);
    setTimeout(function(){
        if(canEdit == true){
            editShoppingCar_service(editArray, handle);
        }
    },200)
}

/**
 * [shopCarPopup_control 编辑购物车颜色和型号]
 * @param  {Number} shopCarId [当前编辑ID]
 */
function shopCarPopup_control(shopCarId) {
	var data = J.Cache.get('shoppingCarData').data;
	var html = '';
	for (var k in data) {
		data[k].value.map(function(item) {
			if (item.id == shopCarId) {
				html = createPopupHtml(item.serviceEvent,'shopCarEventInfo'); //生成弹出框html
			}
		})
	}
	html += '</ul>';
	J.Popup.bottomsheet({
		html: html,
		buttons: [{
			text : '确定',
			class: 'brick-red',
			handler: function(){
				specificationPopup_control(shopCarId,'','shopCarEventInfo');
			}
		}]
	});
    event.stopPropagation();
}

/**
 * [editSpecification_control 编辑购物车规格]
 * @param  {Number} cartId [购物车id]
 * @param  {String} size   [size]
 * @param  {String} color  [color]
 */
function editSpecification_control(cartId, size, color) {
	var editArray = [];
	var obj = {
		shoppingCarId: cartId,
		size: size,
		color: color
	}
	editArray.push(obj);
	var handle = {
		success: function() {
			$("#shoppingCar_article span[data-name='specification']").map(function(index, el) {
				if ($(el).attr('data-id') == cartId) $(el).text( obj.color + ' ' + obj.size);
			})
		},
		error: function(data, xhr) {
			service.error(xhr, data);
		}
	}
	editShoppingCar_service(editArray, handle);
}
//选择送货时间
function selectTime(index) {
    $('#payLists_section .groupNot').css("height", $(document).height());
    $('#payLists_section .groupNot').css("width", $(document).width());
    $('#payLists_section .groupNot').show();


    var timeList = pay.payLists.data[index].deliveryTimeInfo.timeBeanList;
    
    var deliverySId = pay.par.deliveryTId;
    var timeDay = pay.par.timeDay;
    document.getElementById('deliveryTimes').innerHTML = '';

    var html = '<div class="timeTitle"><i class="closeSelectTime"></i><h1>选择送达时间</h1></div>' + 
        '<div class="chooseContent">' +
            '<div class="timeContent">' + 
                '<div class="timeLeft">';
    // 天
    for (var i = 0; i < timeList.length; i++) {
        var item = timeList[i];
        if (i == 0) {
            html += '<div class="timeWeek active">' + item.week + '</div>'
        } else {
            html += '<div class="timeWeek">' + item.week + '</div>'
        }
    }
    html += '</div>'
    // 时间段
    for (var i = 0; i < timeList.length; i++) {
        var item = timeList[i];
        if (i == 0) {
            html += '<div id="firstDayList" class="timeRight active"><ul>'
        } else {
            html += '<div id="firstDayList" class="timeRight"><ul>'
        }
        for (var j = 0; j < item.timeBeanList.length; j++) {
            var ele = item.timeBeanList[j];
            var arr = ele.timeText.split('(');

            // class="active"
            if(ele.sequence == deliverySId){
                html += '<li class="active" data-value="' + ele.timeText + '" data-sequence="' + ele.sequence + '"><span style="display: inline-block;width: 50vw;">' + arr[0];
            } else {
                html += '<li data-value="' + ele.timeText + '" data-sequence="' + ele.sequence + '"><span style="display: inline-block;width: 50vw;">' + arr[0];
            }
            if (arr[1]) {
                html += '<br>(' + arr[1]
            }
            html += '</span><i></i></li>';
        }
        html += '</ul></div>';
    }
    html += '</div></div>';
    document.getElementById('deliveryTimes').innerHTML = html;
 
    var seleDay = $('#deliveryTimes .timeWeek')[timeDay];
    var seleTime =  $('#deliveryTimes .timeRight')[timeDay];
    $(seleDay).addClass('active').siblings().removeClass('active');
    $(seleTime).addClass('active').siblings().removeClass('active');
    $('#deliveryTimes').css('display','block');
    $('#deliveryTimes .timeWeek').bind('click', function(){
        $(this).addClass('active').siblings().removeClass('active');
        var i = $(this).index();
        var ele = $('#deliveryTimes .timeRight')[i];
        $(ele).addClass('active').siblings().removeClass('active');
    });
    $('#deliveryTimes li').bind('click', function(){
        $('.payList_button.deliver').css('display','none');
        $(this).addClass('active').siblings().removeClass('active');
        var value = $(this).data().sequence;
        pay.par.deliveryTId = value;
        var timer = $('#deliveryTimes .timeWeek.active').text() + $(this).data().value;//展示的时间
        var time = $(this).text();//传给后台的时间
        $('.selectedDeliveryTime').css('display','inline-block');
        $('.selectedDeliveryTime').text(timer);
        pay.par.deliveryTimer = timer;
        pay.par.deliveryTime = time;
        //选择时间不去掉优惠券
        // pay.mock.couponUse = false;   //去掉优惠券时去掉优惠券是否可用
        // delete pay.couponJsonStr;
        // delete pay.param.couponJsonStr;
        pay.param.deliveryTime = pay.par.deliveryTime;
        pay.param.deliveryTimer = pay.par.deliveryTimer;
        pay.param.deliveryTId = pay.par.deliveryTId;
        $('#deliveryTimes').css('display','none');
        $('#payLists_section .groupNot').hide();
        // getSelectedShoppingCar_service(pay.par, 2);
        pay.params = {mock:pay.par,eventType:2};



        pay.payLists.data[index].par.deliveryTime = pay.par.deliveryTime;
        pay.payLists.data[index].par.deliveryTId = pay.par.deliveryTId;

        // 获取运费重新计算价格
        calculatePriceWithDisType_service(index);
    });
    // $('#deliveryTimes .closeSelectTime').off().on('click',function(){
    //     $('#payLists_section .groupNot').hide();
    //     $('#deliveryTimes').css('display','none');
    // });
	// pay.par.deliveryTId = ele.value;
	// if(ele.value) {
	// 	pay.par.deliveryTime = $(ele).find("option:selected").text();
	// } else {
	// 	pay.par.deliveryTime = '';
	// }
	// getSelectedShoppingCar_service(pay.par, 2);
}

//选择自提时间
function pickSelectTime(index) {
    $('#payLists_section .groupNot').css("height", $(document).height());
    $('#payLists_section .groupNot').css("width", $(document).width());
    $('#payLists_section .groupNot').show();

    var timeList = pay.payLists.data[index].deliveryTimeInfo.ztTimeBeanList;

    // var timeList = pay.mock.deliveryTimeInfo.psTimeBeanList;
    var deliverySId = pay.par.deliveryTId;
    var timeDay = pay.par.timeDay;
    document.getElementById('pickDeliveryTimes').innerHTML = '';

    var html = '<div class="timeTitle"><i class="closeSelectTime"></i><h1>选择送达时间</h1></div>' + 
    '<div class="chooseContent">' +
        '<div class="timeContent">' + 
            '<div class="timeLeft">';
    // 天
    for (var i = 0; i < timeList.length; i++) {
        var item = timeList[i];
        if (i == 0) {
            html += '<div class="timeWeek active">' + item.week + '</div>'
        } else {
            html += '<div class="timeWeek">' + item.week + '</div>'
        }
    }
    html += '</div>'
    // 时间段
    for (var i = 0; i < timeList.length; i++) {
        var item = timeList[i];
        if (i == 0) {
            html += '<div id="firstDayList" class="timeRight active"><ul>'
        } else {
            html += '<div id="firstDayList" class="timeRight"><ul>'
        }
        for (var j = 0; j < item.timeBeanList.length; j++) {
            var ele = item.timeBeanList[j];
            var arr = ele.timeText.split('(');

            // class="active"
            if(ele.sequence == deliverySId){
                html += '<li class="active" data-value="' + ele.timeText + '" data-sequence="' + ele.sequence + '"><span style="display: inline-block;width: 50vw;">' + arr[0];
            } else {
                html += '<li data-value="' + ele.timeText + '" data-sequence="' + ele.sequence + '"><span style="display: inline-block;width: 50vw;">' + arr[0];
            }
            if (arr[1]) {
                html += '<br>(' + arr[1]
            }
            html += '</span><i></i></li>';
        }
        html += '</ul></div>';
    }
    html += '</div></div>';
    document.getElementById('pickDeliveryTimes').innerHTML = html;

    var seleDay = $('#pickDeliveryTimes .timeWeek')[timeDay];
    var seleTime =  $('#pickDeliveryTimes .timeRight')[timeDay];
    $(seleDay).addClass('active').siblings().removeClass('active');
    $(seleTime).addClass('active').siblings().removeClass('active');
    $('#pickDeliveryTimes').css('display','block');
    $('#pickDeliveryTimes .timeWeek').bind('click', function(){
        $(this).addClass('active').siblings().removeClass('active');
        var i = $(this).index();
        var ele = $('#pickDeliveryTimes .timeRight')[i];
        $(ele).addClass('active').siblings().removeClass('active');
    });
    $('#pickDeliveryTimes li').bind('click', function(){
        $('.payList_button.pick').css('display','none');
        $(this).addClass('active').siblings().removeClass('active');
        var value = $(this).data().sequence;
        pay.par.deliveryTId = value;
        var timer = $('#pickDeliveryTimes .timeWeek.active').text() + $(this).data().value;//展示的时间
        var time = $(this).text();//传给后台的时间
        $('#pickSelectedDeliveryTime').css('display','inline-block');
        $('#pickSelectedDeliveryTime').text(timer);
        pay.par.deliveryTimer = timer;
        pay.par.deliveryTime = time;
        //选择时间不去掉优惠券
        // pay.mock.couponUse = false;   //去掉优惠券时去掉优惠券是否可用
        // delete pay.couponJsonStr;
        // delete pay.param.couponJsonStr;
        pay.param.deliveryTime = pay.par.deliveryTime;
        pay.param.deliveryTimer = pay.par.deliveryTimer;
        pay.param.deliveryTId = pay.par.deliveryTId;
        $('#pickDeliveryTimes').css('display','none');
        $('#payLists_section .groupNot').hide();
        // getSelectedShoppingCar_service(pay.par, 2);
        pay.params = {mock:pay.par,eventType:2};


        pay.payLists.data[index].par.deliveryTime = pay.par.deliveryTime;
        pay.payLists.data[index].par.deliveryTId = pay.par.deliveryTId;

        // 获取运费重新计算价格
        calculatePriceWithDisType_service(index);
    });
    // $('#pickDeliveryTimes .closeSelectTime').off().on('click',function(){
    //     $('#payLists_section .groupNot').hide();
    //     $('#pickDeliveryTimes').css('display','none');
    // });
	// pay.par.deliveryTId = ele.value;
	// if(ele.value) {
	// 	pay.par.deliveryTime = $(ele).find("option:selected").text();
	// } else {
	// 	pay.par.deliveryTime = '';
	// }
	// getSelectedShoppingCar_service(pay.par, 2);
}

/**
 * [editRefundNum_control 编辑退货商品数量]
 * @param  {String} handleType  [编辑类型  'mulNum'减 'addNum'加 不存在该参数则为手动输入]
 * @param  {Number} num      [现在数量]
 * @param  {Object} elements [当前元素]
 * @param  {Number} id       [编辑商品id]
 */
function editRefundNum_control(num, elements,handleType,canRefundNumber) {
    if(canRefundNumber == 0){
        J.showToast('啊呀,此商品没有可退数量了!');
        $(elements).val(0);
        return;
    }
    // discountRuleType  6第二件0元  7是第二件n折   折扣商品仅允许全退！！！
    if($(elements).parents('.singleProduct').hasClass('max-val')){
        $(elements).parents('.singleProduct').find('.right input').val(0).attr('readonly',true);
        $(elements).parents('.singleProduct').find('.right label').attr('onclick','J.showToast("抱歉，折扣商品仅支持全部退，请仔细查看售后规则！")');
        J.showToast("抱歉，折扣商品仅支持全部退，请仔细查看售后规则！");
        return;
    }
    if(handleType) editRefundNum(handleType, num, elements,canRefundNumber);
    var newNum = handleType ? parseInt($(elements).siblings('input').val()) : $(elements).val();
    // 手动输入时判断
    if(!handleType){
        var msg = /^[0-9]*$/;
        if(newNum){
            if(msg.test(newNum)){
                if(newNum < 0){
                    J.showToast('数量至少为0~~');
                    $(elements).val(0);
                    countTotalNum_control();
                    return;
                }else if(newNum > canRefundNumber){
                    J.showToast('超出可退数量了哦~~');
                    $(elements).val(canRefundNumber);
                    countTotalNum_control();
                }
            }else{
                J.showToast('请输入数字');
                $(elements).val(0);
                countTotalNum_control();
                return;
            }
        }else {
            $(elements).val(0);
            countTotalNum_control();
            return;
        }
    }
}
/**
 * [editRefundNum 编辑退货数量]
 * @param  {String} handleType  [操作类型  'mulNum'减 'addNum'加]
 * @param  {Number} num      [现在数量]
 * @param  {Object} elements [当前元素]
 */
function editRefundNum(handleType, num, elements,canRefundNumber) {
    var fn = {
        mulNum: function() {
            if (parseInt(num) >= 1) {
                $(elements).siblings('input').val(parseInt(num) - 1);
                countTotalNum_control();
            } else {
                J.showToast('可退数量最低为0');
            }
        },
        addNum: function() {
			if(num < canRefundNumber) {
				$(elements).siblings('input').val(parseInt(num) + 1);
                countTotalNum_control();
			} else {
				J.showToast('超出可退数量了哦');
			}
        }
    };
    fn[handleType]();
}
/**
 * [countTotalNum_control 计算退货数量]
 * @param  {Object} elements [当前元素]
 */
function countTotalNum_control(elements,canRefundNumber) {
    if(canRefundNumber == 0){
        J.showToast('啊呀,此商品没有可退数量了!');
        return;
    }
    var totalNum = 0;
    var canRefundMoney = 0;
    if(elements){
        $(elements).toggleActive();
        // discountRuleType 6第二件0元    7是第二件n折   折扣商品仅允许全退！！！
        if($(elements).parent().hasClass('max-val')){
            var selectNum = $(elements).hasClass('active') ? canRefundNumber : 0;
            $(elements).parent().find('.right input').val(selectNum).attr('readonly',true);
            $(elements).parent().find('.right label').attr('onclick','J.showToast("抱歉，折扣商品仅支持全部退，请仔细查看售后规则！")');
        }
        // 判断input值是否大于0（用户先编辑数量后勾选） 大于则使用input值  否则使用可退数量最大值
        var refundValue = $(elements).parent().find('.right input').val();
        var canRefund = refundValue > 0 ? refundValue : canRefundNumber;
        // 当前商品为选中状态展示数量 反之展示0
        var selectNum = $(elements).hasClass('active') ? canRefund : 0;
        $(elements).parent().find('.right input').val(selectNum);

        var isSomeOn = true;
        var eleLi = elements.parentElement.parentElement.querySelectorAll('label[data-name=radio]');
        for(var i = 0; i < eleLi.length; i++) {
            isSomeOn = isSomeOn && $(eleLi[i]).hasClass('active');
        }
        // isSomeOn true表示当前全选 改变全选按钮状态
        isSomeOn ? $('#refundProducts .select-all').addClass('active') : $('#refundProducts .select-all').removeClass('active')
	}
	if(pay.refund.serviceEvent.length == 1 ){
        var el = $("#categoriesRefund li label[data-name=radio]");
        var inputVal = $(el).parent().find('.right input').val();
        var msg = /^[0-9]*$/;
        if(inputVal){
            if(msg.test(inputVal)){
                if(inputVal < 0){
                    J.showToast('数量至少为0~~');
                    $(el).parent().find('.right input').val(0);
                }
            }else{
                J.showToast('请输入数字');
                $(el).parent().find('.right input').val(0);
            }
        }else{
            $(el).parent().find('.right input').val(0);
        }
        if (el.hasClass('active')) {
            var num = parseInt($(el).parent().find('.right input').val());
            var id = parseInt((el).parent().data().id);
            var priceData = parseFloat($(el).data().price);
            totalNum += num;
            canRefundMoney += priceData * num;
            pay.refund.selectId = id;
        }
        // $("#categoriesRefund li").each(function() {
        //     var el = $(this).find('label[data-name=radio]');
        //     if (el.hasClass('active')) {
        //         var num = parseInt($(el).parent().find('.right input').val());
        //         totalNum += num;
        //     }
        // });
	}else{
        $("#refundProducts li").each(function() {
            var el = $(this).find('label[data-name=radio]');
            var inputVal = $(el).parent().find('.right input').val();
            var msg = /^[0-9]*$/;
            if(inputVal){
                if(msg.test(inputVal)){
                    if(inputVal < 0){
                        J.showToast('数量至少为0~~');
                        $(el).parent().find('.right input').val(0);
                    }
                }else{
                    J.showToast('请输入数字');
                    $(el).parent().find('.right input').val(0);
                }
            }else{
                $(el).parent().find('.right input').val(0);
            }
            if (el.hasClass('active')) {
                var num = parseInt($(el).parent().find('.right input').val());
                var priceData = parseFloat($(el).data().price);
                totalNum += num;
                canRefundMoney += priceData * num;
            }
        });
    }
    pay.refund.totalNum = totalNum;
    pay.refund.canRefundMoney = Math.formatFloat(canRefundMoney);
    $("#totalRefundNum").text(totalNum);
    $("#refundProductsNum").text(totalNum);
    $("#refund-money").text('￥' + Math.formatFloat(canRefundMoney));
}
// 全选退货商品 数量默认最大可退数量
function selectRefundAll(ele) {
    $(ele).toggleActive();
    if($(ele).hasClass('active')){
        // 全选
        $("#refundProducts li label").addClass('active');
        $("#refundProducts li").each(function() {
            var el = $(this).find('label[data-name=radio]');
            // 判断input值是否大于0（用户先编辑数量后勾选） 大于则使用input值  否则使用可退数量最大值
            var refundValue = $(this).find('.right input').val();
            var canRefund = refundValue > 0 ? refundValue : el.data().num;
            $(this).find('.right input').val(canRefund);
        })
    }else{
        $("#refundProducts li .right").find('input').val(0);
        $("#refundProducts li label").removeClass('active');
    }
    countTotalNum_control();
}
//选择自提或配送
function selectPickUpGoods(index, type) {

    if (type == 1) {
        // 配送
        $('.merchant').eq(index).find('.deliverSelected').addClass('active');
        $('.merchant').eq(index).find('.selfSelected').removeClass('active');

        $('.merchant').eq(index).find('.pickUpAddress').hide();
        $('.merchant').eq(index).find('.order-time.delivery').addClass('active');
        $('.merchant').eq(index).find('.order-time.pick').removeClass('active');

        $('.merchant').eq(index).find('.freightCoupon_li').show();
        $('.merchant').eq(index).find('.privilege').show();
    } else {
        // 自提
        $('.merchant').eq(index).find('.deliverSelected').removeClass('active');
        $('.merchant').eq(index).find('.selfSelected').addClass('active');

        $('.merchant').eq(index).find('.pickUpAddress').show();
        $('.merchant').eq(index).find('.order-time.delivery').removeClass('active');
        $('.merchant').eq(index).find('.order-time.pick').addClass('active');

        $('.merchant').eq(index).find('.freightCoupon_li').hide();
        $('.merchant').eq(index).find('.privilege').hide();
    }

    pay.payLists.data[index].par.disType = type;
    pay.payLists.data[index].par.deliveryTId = '';
    pay.payLists.data[index].par.deliveryTime = '';

    pay.param.disType = type;
    // return;
    calculatePriceWithDisType_service(index);

}


// 未登录将商品加入购物车
function saveOfflineShopCar(shopCarId) {
	console.log(shopCarId);
	var arr = [];
	if(!J.Cache.get('offlineShopCar')) {
		arr.push(shopCarId);
	} else {
		arr = J.Cache.get('offlineShopCar').data;
        arr.push(shopCarId);
        for(var i=0; i<arr.length - 1; i++){
            if(arr[i] == shopCarId){
                arr.splice(i,1);
            }
        }
	}
	J.Cache.save('offlineShopCar', arr);
}
//退货选择时间
function selectReturnTime() {
    $('#applyRefund_section .groupNot').css("height", $(document).height());
    $('#applyRefund_section .groupNot').css("width", $(document).width());
    $('#applyRefund_section .groupNot').show();
    var timeList = pay.refund.inDoorTime.timeBeanList;
    var timeValue = pay.refund.timeValue;
    var timeDay = pay.refund.timeDay;
    document.getElementById('refundTimes').innerHTML = '';
    var html = '<div class="timeTitle"><i class="closeSelectTime"></i><h1>选择取件时间</h1></div><div class="chooseContent"><div class="timeContent"><div class="timeLeft">';    
    if(timeList.firstDay.timeBeanList && timeList.firstDay.timeBeanList.length > 0){
        html += '<div class="timeWeek active">' + timeList.firstDay.week + '</div><div class="timeWeek">' + timeList.secondDay.week
             + '</div></div><div id="firstDayList" class="timeRight active"><ul>';
        for(var i = 0; i < timeList.firstDay.timeBeanList.length; i++) {
            if(timeList.firstDay.timeBeanList[i].sequence == timeValue){
                html += '<li class="active" data-sequence="' + timeList.firstDay.timeBeanList[i].sequence + '"><span style="display: inline-block;width: 50vw;">'
                     + timeList.firstDay.timeBeanList[i].timeText + '</span><i></i></li>'
            }else {
                html += '<li data-sequence="' + timeList.firstDay.timeBeanList[i].sequence + '"><span style="display: inline-block;width: 50vw;">'
                     + timeList.firstDay.timeBeanList[i].timeText + '</span><i></i></li>'
            }
            if(i == timeList.firstDay.timeBeanList.length - 1){
                html += '</ul></div><div id="secondDayList" class="timeRight"><ul>';
            }
        }
        for(var i = 0; i < timeList.secondDay.timeBeanList.length; i++) {
            if(timeList.secondDay.timeBeanList[i].sequence == timeValue){
                html += '<li class="active" data-sequence="' + timeList.secondDay.timeBeanList[i].sequence + '"><span style="display: inline-block;width: 50vw;">'
                     + timeList.secondDay.timeBeanList[i].timeText + '</span><i></i></li>'
            }else {
                html += '<li data-sequence="' + timeList.secondDay.timeBeanList[i].sequence + '"><span style="display: inline-block;width: 50vw;">'
                     + timeList.secondDay.timeBeanList[i].timeText + '</span><i></i></li>'
            }
            if(i == timeList.secondDay.timeBeanList.length - 1){
                html += '</ul></div></div></div>';
                document.getElementById('refundTimes').innerHTML = html;
            }
        }

    }else{
        html += '<div class="timeWeek active">' + timeList.secondDay.week +'</div></div><div class="timeRight"><ul>';
        for(var i = 0; i < timeList.secondDay.timeBeanList.length; i++) {
            if(timeList.secondDay.timeBeanList[i].sequence == timeValue){
                html += '<li class="active" data-sequence="' + timeList.secondDay.timeBeanList[i].sequence + '"><span style="display: inline-block;width: 50vw;">'
                     + timeList.secondDay.timeBeanList[i].timeText + '</span><i></i></li>'
            }else {
                html += '<li data-sequence="' + timeList.secondDay.timeBeanList[i].sequence + '"><span style="display: inline-block;width: 50vw;">'
                     + timeList.secondDay.timeBeanList[i].timeText + '</span><i></i></li>'
            }
            if(i == timeList.secondDay.timeBeanList.length - 1){
                html += '</ul></div></div></div>';
                document.getElementById('refundTimes').innerHTML = html;
            }
        }
    }
    var seleDay = $('#refundTimes .timeWeek')[timeDay];
    var seleTime =  $('.timeRight')[timeDay];
    $(seleDay).addClass('active').siblings().removeClass('active');
    $(seleTime).addClass('active').siblings().removeClass('active');
    $('#refundTimes').css('display','block');
    $('#refundTimes .timeWeek').bind('click', function(){
        $(this).addClass('active').siblings().removeClass('active');
        var i = $(this).index();
        var ele = $('#refundTimes .timeRight')[i];
        $(ele).addClass('active').siblings().removeClass('active');
    });
    $('#refundTimes li').bind('click', function(){
        $(this).addClass('active').siblings().removeClass('active');
        var value = $(this).data().sequence;
        pay.refund.timeValue = value;
        var timer = $('.timeWeek.active').text() + $(this).text();//展示的时间
        var time = $(this).text();//传给后台的时间
        $('#refund-time .refund-right').text(timer);
        pay.refund.deliveryTimer = timer;
        pay.refund.deliveryTime = time;
        pay.refund.timeDay = $('.timeWeek.active').index();
        $('#refundTimes').css('display','none');
        $('#applyRefund_section .groupNot').hide();
    });
    // $('#refundTimes .closeSelectTime').off().on('click',function(){
    //     $('#applyRefund_section .groupNot').hide();
    //     $('#refundTimes').css('display','none');
    // });
}
// 退货页面选择原因
function choseRefundReason(el) {
    var mock = {
        0:'质量问题',
        1:'未收到货',
        2:'不想买了/计划有变',
        3:'多买',
        4:'其他原因'
    };
    var selectReasonValue = $('#refund-cause .refund-right').attr('data-choose');
    $('#applyRefund_section .groupNot').css("height", $(document).height());
    $('#applyRefund_section .groupNot').css("width", $(document).width());
    $('#applyRefund_section .groupNot').show();
    document.getElementById('refundReasonBox').innerHTML = '';
    var html= '<div><i class="closeCouponsSelect"></i><h1>退款原因</h1></div><ul>';
    if(Object.keys(mock).length != 0) {
        for(var k in mock) {
            var val = JSON.stringify(mock[k]);
            if(k == selectReasonValue) {
                html += '<li class="item active" data-key="' + k + '"  data-val=' + val + '  data-name="' + mock[k] + '"><span class="color-change">' + mock[k] + '</span><i></i></li>';
            } else {
                html += '<li class="item" data-key="' + k + '"  data-val=' + val + '  data-name="' + mock[k] + '"><span class="color-change">' + mock[k] + '</span><i></i></li>';
            }
        }
        html += '<li id="refundReason"><textarea name="" cols="5" rows="3" placeholder="请输入您的退货原因..." onblur="saveReason();" maxlength="50"></textarea>'
             + '<button onclick="saveReason();">提交</button></li></ul>';
        document.getElementById('refundReasonBox').innerHTML = html;
        if(selectReasonValue == 4){
            $('#refundReason').addClass('active');
            $('#refundReason textarea').val(pay.refund.otherReason);
        }
        $('#refundReasonBox').css('display','block');
        $("#refundReasonBox li.item").on('click', function() {
            $(this).addClass('active').siblings().removeClass('active');
            var selectReasonVal = parseInt($(this).attr('data-key'));
            var selectReasonName = $(this).attr('data-name');
            $('#refund-cause .refund-right').text(selectReasonName).attr('data-choose', selectReasonVal);
            pay.refund.ressonValue = selectReasonVal;
            pay.refund.ressonName = selectReasonName;
            pay.refund.otherReason = '';
            $('#refund-time').css('display','block');
            if(selectReasonVal != 4){
                if(selectReasonVal == 1){
                    $('#refund-time').css('display','none');
                    $('#refund-time .refund-right').text('请选择');
                    pay.refund.deliveryTime = '';//取件时间清空
                    pay.refund.deliveryTimer = '';//取件时间清空
                    delete pay.refund.timeValue;
                    delete pay.refund.timeDay;
                }else{
                    $('#refund-time').css('display','block');
                }
                setTimeout(function() {
                    $('#refundReasonBox').css('display','none');
                    $('#applyRefund_section .groupNot').hide();
                }, 50);
            }
            refundItem(selectReasonVal);
        });
    }
    // $('#refundReasonBox .closeCouponsSelect').off().on('click',function(){
    //     $('#applyRefund_section .groupNot').hide();
    //     $('#refundReasonBox').css('display','none');
    // });
}


function listenKeybord() {
    console.log("失去焦点");
    if(isWechatClient()) {
        setTimeout(function() {
            console.log("微信");
            window.scroll(0,document.body.clientHeight);
            document.body.scrollTop = 0;
            document.documentElement.scrollTop = 0;
            window.scrollTo(0, Math.max(document.body.clientHeight, document.documentElement.clientHeight))
        }, 100);
    }
    if(isAndroidIosApp()) {
        if(isIOS()) {
            setTimeout(function() {
                console.log("iosApp");
                window.scroll(0,document.body.clientHeight);
                document.body.scrollTop = 0;
                document.documentElement.scrollTop = 0;
                window.scrollTo(0, Math.max(document.body.clientHeight, document.documentElement.clientHeight))
            }, 100);
        }
    }
}

//购物车、常购清单tab
function shoppingCartTab(type,ele){
    $(ele).addClass('active').siblings().removeClass('active');
    if(type == 0){
        $('.cart-tab-0').addClass('active');
        $('.cart-tab-1').removeClass('active');
        $('#deleteEvents').show();
        $('#shoppingCart_article .scrolling').css('bottom','51px');
        getShoppingCar();
        $("#shoppingCart").scrollTop(0);
    }else{
        $('#deleteEvents').hide();
        $('.cart-tab-1').addClass('active');
        $('.cart-tab-0').removeClass('active');
        $('#shoppingCart_article .scrolling').css('bottom','0');
        myOftenBuyList_service();
        $("#shoppingCart").scrollTop(0);
    }
}

//获取购物车
function getShoppingCar() {
    if (!J.Cache.get('login')) {
        // J.showToast('请先登录哟~');
        // return;
        getOfflineShoppingCar_service();
        if($("#shoppingCar_article ul.validList li label[data-name=radio].active").length == 0){
            $('#payMoney').addClass('notClick');
        }
    }else{
        var userCommunityId = J.Cache.get('login').data.communityId;
        var gpsCommunityId = J.Cache.get('community').data.id;
        $('#payMoney').removeClass('notClick');
        if (isNullString(userCommunityId)) {
            saveCommunity_service(gpsCommunityId, getShoppingCar_service);
        } else {
            getShoppingCar_service();
        }
    }
    $('#totalChecked').removeClass('active');
    $("#payMoney").show().siblings(".sub-btn").hide();
    childrenAticleToggleActive('shoppingCart_article', 'addClass');
    if(mobilePay) mobilePay = false;
}