/**
 * [getServiceEventDetails_service 获取商品详情service]
 * @param  {Number} eventId [商品id]
 * @param  {Object} source    [统计来源]
 */
function getServiceEventDetails_service(eventId, source, isRendering, perfId, joinIn, communityId) {
    var productPar = {
        serviceEventId: eventId,
        communityId: communityId || J.Cache.get('community').data.id
    }
    J.Cache.save("productPar", productPar);
        
    // 加入点击统计
    getGoodEvent(eventId, 14, source);

    if (location.hash !== '#productDetail_section') {
        J.Router.goTo("#productDetail_section");
        return;
    } else {
        $('#productDetail_section').addClass('fadeInRight');
		setTimeout(function(){
			$('#productDetail_section').removeClass('fadeInRight');
		},300);
        getServiceEventDetailsData(eventId, isRendering, perfId, joinIn, communityId);
    }
}

// 获取商品详情
function getServiceEventDetailsData(eventId, isRendering, perfId, joinIn, communityId) {
    $('#productList_section header').attr('data-clearScroll', true); //商品列表页hide时不清滚动条
    //  J.showMask();
    var url = 'ws/serviceAction' + versionMessage.version + '!getServiceEventDetails.sy';
    if(!J.Cache.get('community')) {
        J.Cache.save('community', {id: "1", name: "奥体", type: "0"});
        //切换地址、片区需要刷新“我的”页面用户的账户信息（例如优惠券<优惠券按片区加载>）
        $('#userInfo_div').attr('data-refresh','true');
    }
    var par = {
        serviceEventId: eventId,
        communityId: communityId || J.Cache.get('community').data.id
    };
    if(perfId) {
        par.perfId = perfId
    }
    J.Cache.save('detailEventId', eventId);
    service.get(url, par, function (data) {
        
        console.log('eventId:' + eventId);
        // $("#currencyId").data().currency = eventId;
        // page.currencyId = eventId;
        if (data.brandClass) {
            data.brandClass.picture = picNetworkPrefix(data.brandClass.picture);
        }
        if(data.isCollage){
            getRelateServiceEvent_service(eventId, data, 1); //获取关联商品
        }else{
            getRelateServiceEvent_service(eventId, data, 2); //获取关联商品
        }
        if(data.priceNotInUse) data.priceNotInUse = '¥'+ data.priceNotInUse.split('¥')[1];
        data.discountSymbol = data.priceInUse.split('¥')[0];
        if (data.description) {
            data.description = data.description.replace(/&amp;nbsp;/g, '&nbsp;').replace(/&lt;/g, '<').replace(/&gt;/g, '>')
                .replace(new RegExp("&amp;lt;br/&amp;gt;", "gm"), "<br/>").replace(/\r/ig, '<br>').replace(/\n/ig, '<br>')
        }
        var userPictures = [];
        var expertPictures = [];
        if(data.commentInfo.userBetterComment && data.commentInfo.userBetterComment != null){
            if(data.commentInfo.userBetterComment.picture) {
                userPictures = data.commentInfo.userBetterComment.picture.split(',');
                for(var i = 0; i < userPictures.length; i++) {
                    userPictures[i] = fileServerUrl + userPictures[i];
                }
            }
            data.commentInfo.userBetterComment.picture = userPictures;
            data.commentInfo.userBetterComment.photo = fileServerUrl  + data.commentInfo.userBetterComment.photo;
            if(data.commentInfo.userBetterComment.name.length >= 11){
                data.commentInfo.userBetterComment.name = data.commentInfo.userBetterComment.name.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
            }
        }
        if(data.commentInfo.expertBetterComment && data.commentInfo.expertBetterComment != null){
            if(data.commentInfo.expertBetterComment.picture) {
                expertPictures = data.commentInfo.expertBetterComment.picture.split(',');
                for(var i = 0; i < expertPictures.length; i++) {
                    expertPictures[i] = fileServerUrl + expertPictures[i];
                }
            }
            data.commentInfo.expertBetterComment.picture = expertPictures;
            data.commentInfo.expertBetterComment.photo = fileServerUrl  + data.commentInfo.expertBetterComment.photo;
            if(data.commentInfo.expertBetterComment.name.length >= 11){
                data.commentInfo.expertBetterComment.name = data.commentInfo.expertBetterComment.name.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
            }
        }
        if (!isNullString(data.picture)) data.picture = picNetworkPrefix(data.picture);
        // 轮播图
        if (!isNullString(data.carouselPicture)) {
            var carouselList = [];
            data.carouselPicture = data.carouselPicture.split(',');
            data.carouselPicture.map(function (item, index) {
                var data = {
                    url: picNetworkPrefix(item),
                };
                carouselList.push(data);
            })
            carouselList[0].hasActive = true;
            data.carouselPicture = carouselList;
        } else {
            var carouselData = {
                url: data.picture,
                hasActive: true
            }
            data.carouselPicture = [];
            data.carouselPicture.push(carouselData);
        }
        // 标签
        if(!isNullString(data.detailTag)) {
            data.detailTag = data.detailTag.split(',');
        }
        var specification = [];
        var colorName = $.trim(data.colorName);
        var color = $.trim(data.color);
        var sizeName = $.trim(data.sizeName);
        var size = $.trim(data.size);
        if (colorName && colorName.length > 0) {
            var obj = {
                name: colorName,
                val: [""],
                key: 'colorName'
            };
            if(color && color.length > 0){
                obj.val = color.split(",");
            }
            specification.push(obj);
        }
        if (sizeName && sizeName.length > 0) {
            var obj = {
                name: sizeName,
                val: [""],
                key: 'sizeName'
            };
            if(size && size.length > 0){
                obj.val = size.split(",");
            }
            specification.push(obj);
        }
        J.Cache.save('beginBuyNum', {id:data.id, beginBuyNum: data.beginBuyNum});
        data.specification = specification;
        data.serviceLastTime = data.serviceLastTime ? data.serviceLastTime : 0;
        if(data.description){
            if (data.description.split('<img').length >= 2) {
                var mock = $(data.description);
                var _item = "";
                if (mock.find("img").length != 0) {
                    mock.find("img").map(function (ele, e) {
                        $(e).attr('src', picNetworkPrefix($(e).attr('src')));
                    });
                    $.each(mock, function (index, item) {
                        _item = _item + $(item).prop("outerHTML");
                    });
                    data.description = _item;
                }
            }
            if (data.description.indexOf('&nbsp;') >= 0) {
                data.description.replace(/&nbsp;/g, ' ');
            }
        }

        // 规格显示
        var unitArr = [];
        if (data.specificatDesc) {
            unitArr.push(data.specificatDesc);
        }
        if (data.unit) {
            unitArr.push(data.unit);
        }
        data.unitText = unitArr.toString().replace(/,/g, '/');

        

        console.log(data, '分享')
        var shareData = {
            title: data.name,
            imgUrl: data.picture,
            eventId: eventId,
            type: data.type,
            price4Show: data.price4Show
        };
        J.Cache.save('share', shareData);
        J.Cache.save('groupShare', shareData);
    
        // 新分享
        var shareUrl
        var communityId = J.Cache.get('community').data.id
        if (J.Cache.get('login')) {
            var id = J.Cache.get('login').data.id;
            shareUrl = wechatUrl + '?serviceEventId=' + data.id + '&communityId=' + communityId + '&specialStr=' + guid2() + '&userId=' + id + '&type=3' + '#productDetail_section';
        } else {
            shareUrl = wechatUrl + '?serviceEventId=' + data.id + '&communityId=' + communityId + '&type=3' + '#productDetail_section';
        }
        console.log(shareUrl);
        var sharePar = {
            title: data.shareTitle,
            desc: data.shareText,
            link: shareUrl,
            imgUrl: picNetworkPrefix(data.pic1)
        }
        J.Cache.save('shareProductPar', sharePar);
        // 设置分享
        if (isWechatClient()) {
            getJSSDKConfigParams_service();
            wx.ready(function(){
                shareWTYProductPay_control()
            });
        }
        data.userlevel = 0;
        // 用户 
        if (J.Cache.get('login')) {
            data.userlevel = J.Cache.get('login').data.level;
        }
        if(data.schedulePrice != null){
            data.schedulePrice = data.schedulePrice.split('¥')[1];
        }
        if(data.isCollage){
            data.joinIn = joinIn;
            getGrouponProductDetail_control(data, isRendering);
        }else{
            if(data.priceNotInUse && data.priceNotInUse != null){
                if(data.realPrice == Number(data.priceNotInUse.split('原价:¥')[1])){
                    data.realPrice = null;
                }
            }
            getProductDetail_control(data, isRendering);
        }
        J.hideMask();
        // $('#productDetail_section .invalidProduct').removeClass('active');
    },function(data){
        if(data){
            J.showToast(data.message);
        }
    });
    // if( J.Cache.get('login')){
    //     var url1 = 'ws/userBigDataAction!saveUserBigData.sy';
    //     var par = {
    //         type : 0,
    //         serviceEventId : eventId
    //     };
    //     service.get(url1, par, function (data){
    
    //     });
    // }

}
/*
* 获取金豆商品详情
* */
function getYiBeansEventDetails_service(eventId){
    $('#yiBeansCart').hide();
    var url = 'ws/serviceAction' + versionMessage.version + '!viewDetailsGoods.sy';
    var par = {
        serviceEventId: eventId
    };
    service.get(url, par, function (data) {
        if (data.brandClass) {
            data.brandClass.picture = picNetworkPrefix(data.brandClass.picture);
        }
        if (data.description) {
            data.description = data.description.replace(/&amp;nbsp;/g, '&nbsp;').replace(/&lt;/g, '<').replace(/&gt;/g, '>')
                .replace(new RegExp("&amp;lt;br/&amp;gt;", "gm"), "<br/>");
        }
        if (!isNullString(data.picture)) data.picture = picNetworkPrefix(data.picture);
        // 轮播图
        if (!isNullString(data.carouselPicture)) {
            var carouselList = [];
            data.carouselPicture = data.carouselPicture.split(',');
            data.carouselPicture.map(function (item, index) {
                var data = {
                    url: picNetworkPrefix(item)
                };
                carouselList.push(data);
            });
            carouselList[0].hasActive = true;
            data.carouselPicture = carouselList;
        } else {
            var carouselData = {
                url: data.picture,
                hasActive: true
            };
            data.carouselPicture = [];
            data.carouselPicture.push(carouselData);
        }
        // 标签
        if(!isNullString(data.detailTag)) {
            data.detailTag = data.detailTag.split(',');
        }
        if(data.description){
            if (data.description.split('<img').length >= 2) {
                var mock = $(data.description);
                var _item = "";
                if (mock.find("img").length != 0) {
                    mock.find("img").map(function (ele, e) {
                        $(e).attr('src', picNetworkPrefix($(e).attr('src')));
                    });
                    $.each(mock, function (index, item) {
                        _item = _item + $(item).prop("outerHTML");
                    });
                    data.description = _item;
                }
            }
            if (data.description.indexOf('&nbsp;') >= 0) {
                data.description.replace(/&nbsp;/g, ' ');
            }
        }
        J.Router.goTo("#yiBeansProductDetail_section");
        getYiBeansProductDetail_control(data);
        J.hideMask();
    },function(data){
        if(data){
            J.showToast(data.message);
        }
    });
}
/*
*获取关联商品
* place   0 订单详情  1拼团  2商品详情  3购物车
 */
function getRelateServiceEvent_service(eventId, mock, place, orderMainId) {
    var url = 'ws/serviceAction' + versionMessage.version + '!getRelateServiceEvent.sy';
    var par = {
        serviceEventId: eventId,
        place: place
    };
    if(orderMainId) {
    	par.orderMainId = orderMainId;
    }
    if (par.place == 0) {
        service.get(url, par, function (data) {
        	if(data) {
	            data.map(function (item) {
                    if (!isNullString(item.picture)) item.picture = picNetworkPrefix(item.picture);
                    if(item.serviceEventMarkPic){
                        item.serviceEventMarkPic = picNetworkPrefix(item.serviceEventMarkPic);
                    }
                    item.priceInUse = '¥'+item.priceInUse.split('¥')[1];
	            });
        	} else {
        		data = {};
            }
            if(!isEmptyObject(data)){
                J.Template.render("#orderDetailRelate_div", "orderDetailRelate_template", data, "replace");
            }else{
                $('#orderDetailRelate_div').empty();
            }

        });
    }else if (par.place == 1){
        service.get(url, par, function (data) {
            if(data) {
                data.map(function (item) {
                    if (!isNullString(item.picture)) item.picture = picNetworkPrefix(item.picture);
                    if(item.serviceEventMarkPic){
                        item.serviceEventMarkPic = picNetworkPrefix(item.serviceEventMarkPic);
                    }
                    item.priceInUse = '¥'+item.priceInUse.split('¥')[1];
                });
                if (data.length != 0) {
                    J.Template.render("#productGrouponRelate_div","productGrouponRelate_template", data, "replace");
                }
            }
        });
    }else if (par.place == 2){
        service.get(url, par, function (data) {
            if(data) {
                data.map(function (item) {
                    if (!isNullString(item.picture)) item.picture = picNetworkPrefix(item.picture);
                    if(item.serviceEventMarkPic){
                        item.serviceEventMarkPic = picNetworkPrefix(item.serviceEventMarkPic);
                    }
                    item.priceInUse = '¥'+item.priceInUse.split('¥')[1];
                    if(item.priceNotInUse) item.priceNotInUse = '¥'+item.priceNotInUse.split('¥')[1];
                });
                if (data.length != 0) {
                    var gos = (mock.type == 1) ? 'serviceDetail' : 'productDetail';
                    J.Template.render("#" + gos + "Relate_div", gos + "Relate_template", data, "replace");
                    floorCreateFly('productDetail_section');//监听推荐商品加购
                }
            }
        });
    }else if (par.place == 3) {
        service.get(url, par, function (data) {
            if(data && data.length != 0) {
                data.map(function (item) {
                    if (!isNullString(item.picture)) item.picture = picNetworkPrefix(item.picture);
                    if(item.serviceEventMarkPic){
                        item.serviceEventMarkPic = picNetworkPrefix(item.serviceEventMarkPic);
                    }
                    item.priceInUse = '¥'+item.priceInUse.split('¥')[1];
                    if(item.priceNotInUse) item.priceNotInUse = '¥'+item.priceNotInUse.split('¥')[1];
                });
                J.Template.render("#shoppingCartLikesRelate_div", "shoppingCartLikes_template", data, "replace");
                floorCreateFly('shopCar');
            } else {
                $('#shoppingCartLikesRelate_div').empty();
            }
        });
    }
}
/*
*购物车没有商品 推荐获取销量Top20商品
 */
function getTop20ServiceEvent(ele) {
    var url = 'ws/serviceAction' + versionMessage.version + '!getTop20SaleNumServiceEvent.sy';
    if(!J.Cache.get('community')) {
    	J.Cache.save('community', {id: "1", name: "奥体", type: "0"});
    }
    var par = {
        communityId: J.Cache.get('community').data.id
    };
    service.get(url, par, function (data) {
        if(data && data.length != 0) {
            data.map(function (item) {
                if (!isNullString(item.picture)) item.picture = picNetworkPrefix(item.picture);
                if(item.serviceEventMarkPic){
                    item.serviceEventMarkPic = picNetworkPrefix(item.serviceEventMarkPic);
                }
                item.priceInUse = '¥'+item.priceInUse.split('¥')[1];
                if(item.priceNotInUse) item.priceNotInUse = '¥'+item.priceNotInUse.split('¥')[1];
            });

            if (ele) {
                J.Template.render("#" + ele + "", "cancelOrderComplete_template", data, "replace");
            } else {
                J.Template.render("#shoppingCartLikesRelate_div", "shoppingCartLikes_template", data, "replace");
                floorCreateFly('shopCar');
            }
        } else {
            $('#shoppingCartLikesRelate_div').empty();
        }
    });
}
//金豆订单详情内不跳转商品详情merchantId：18----金豆兑换
function toServiceEventDetails(eventId,merchantId){
    if(merchantId != 18){
        getServiceEventDetails_service(eventId, {sName: '', sIndex: 0});
    }
}
//获取评论列表，type,1,专家意见,2,用户意见
function commentList_service(eventId, type) {
    J.showMask();
    $('.com .prof').removeClass('active');
    $('.com .user').removeClass('active');
    var par = {
        serviceEventId: eventId,
        type: type
    };
    var url = 'ws/commentAction' + versionMessage.version + '!goCommentListPage.sy';
    service.get(url, par, function (data) {
        J.hideMask();
        if (type == 1) {
            $('.com .prof').addClass('active');
            $('#professor').show();
        } else {
            $('.com .user').addClass('active');
            $('#professor').hide();
        }
        if (data.length != 0) {
            var pictures = [];
            data.commentInfos.map(function (item) {
                if(item.picture) {
                    pictures = item.picture.split(',');
                    for(var i = 0; i < pictures.length; i++) {
                        pictures[i] = fileServerUrl + pictures[i];
                    }
                    item.picture = pictures;
                }
                item.photo = fileServerUrl  + item.photo;
                if(item.name.length >= 11){
                    item.name = item.name.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
                }
                for(i in item.userParentCommentBeanList){
                    if(item.userParentCommentBeanList[i].userName.length >= 11){
                        item.userParentCommentBeanList[i].userName = item.userParentCommentBeanList[i].userName.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
                    }
                }
            });
            J.Cache.save('commentInfo', data);
            J.Template.render("#commentNum_h1", "commentNum_template", data, "replace");
            J.Template.render("#score_div", "score_template", data, "replace");
            J.Template.render("#commentList_ul", "commentList_template", data, "replace");
            if(data.eventScore > 0){
                $('#score_div #over1')[0].style.width = data.eventScore * 4 + 'vw';
            }
            if(data.categoryRefScore > 0){
                $('#score_div #over2')[0].style.width = data.categoryRefScore * 4 + 'vw';
            }
            if (data.commentInfos.length == 0) {
                $('#kongPingJia').css('display', 'block');
            }
        } else {
            J.showToast('请求错误，请重试');
        }
    })
}
// 获取评论详情
function commentDetail_service(id,Type) {
    J.showMask();
    var url = 'ws/commentAction' + versionMessage.version + '!findUserComment.sy';
    var par = {
        commentId : id,
        type : Type
    };
    J.Router.goTo("#commentDetail_section");
    service.get(url, par, function (data) {
        var data1 = data[0];
        data1.userParentCommentBeanList = data[1];
        J.Cache.save('professionalComment', data1);
        if(data1.name.length >= 11){
            data1.name = data1.name.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
        }
        if(data1.picture) {
            var pictures = data1.picture.split(',');
            for(var i = 0; i < pictures.length; i++) {
                pictures[i] = fileServerUrl + pictures[i];
            }
        }
        data1.picture = pictures;
        data1.photo = fileServerUrl  + data1.photo;
        if (data1.userParentCommentBeanList.length != 0) {
            data1.userParentCommentBeanList.map(function(item){
                if(item.userName.length >= 11){
                    item.userName = item.userName.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
                    item.userAvator = picNetworkPrefix(item.userAvator);
                }
            });
        }
        J.Template.render("#commentDetail_article", "commentDetail_template", data1, "replace");
        $('#secondPingJia').data().commenteventid = data1.commentEventId;
        if(data1.type == 2){
            $('#commentFooter').css('display','none');
        }else if(data1.type == 1){
            $('#commentFooter').css('display','block');
        }
        J.hideMask();
    });
    //J.Cache.save('commentItem', item);
}
//评论详情展开全部/收起
function showAll(type){
    if(type){
        $('#desc').css('height','auto');
        $('#commentDetail_article .showAll').css('display','none');
        $('#commentDetail_article .hideAll').css('display','inline-block');
    }else{
        $('#desc').css('height','15vw');
        $('#commentDetail_article .showAll').css('display','inline-block');
        $('#commentDetail_article .hideAll').css('display','none');
    }
}

//提交评价
/**commentId  评价的id
 * commentText  评价内容
 * typeId  专家评价1 用户评价2
 * userId  用户id
 * */
function submitEvaluate_service(id){
    J.showMask();
    if($.trim($('#secondPingJia textarea').val())){
        var par = {
            commentId : id,
            commentText : $.trim($('#secondPingJia textarea').val()),
            typeId : 1,
            userId : J.Cache.get('login').data.id
        };
        var url = 'ws/commentAction' + versionMessage.version + '!saveUserComment.sy';
        service.get(url, par, function (data) {
            $('#secondPingJia textarea').val('');
            commentDetail_service(id,1);
            J.showToast('提交成功啦');
            J.hideMask();
        })
    }else{
        J.showToast('不能为空哦');
    }
}
//点赞
function thumbsUp_service(id,type,ele){
    var par = {
        commentId : id,
        typeId : type,
        userId : J.Cache.get('login').data.id
    };
    var url = 'ws/commentAction' + versionMessage.version + '!saveUserThumbup.sy';
    service.get(url, par, function (data) {
        J.showToast('点赞成功啦');
        $(ele).addClass('active');
        $(ele.parentElement).find('span')[0].innerText = parseInt($.trim($(ele.parentElement).find('span')[0].innerText)) + 1;
        var productDetail = J.Cache.get('productDetail').data;
        if(productDetail.commentInfo.userBetterComment.commentEventId == id){
            productDetail.commentInfo.userBetterComment.thumbup = true;
            productDetail.commentInfo.userBetterComment.thumbupCount += 1;
        }else{
            productDetail.commentInfo.expertBetterComment.thumbup = true;
            productDetail.commentInfo.expertBetterComment.thumbupCount += 1;
        }
        J.Cache.save('productDetail',productDetail);
    });

}
//列表页添加购物车 ,type判断是哪个列表页 0.三级列表 1.品牌列表 2.会员专享 3.商户列表 4.搜索结果页面
function addCart_service(type,sec,id){
        J.Cache.empty('listIndex');
        var ul = document.getElementById(id);
        var ul_child = ul.getElementsByTagName('li');
        var j;
        for (var i = 0; i < ul_child.length; i++) {
            ul_child[i].index = i;
            ul_child[i].onclick = function () {
                j = this.index;
                J.Cache.save('listIndex',j);
            };
        }
        var data;
        setTimeout(function () {
            // a序列数 c取十位 b取个位
            var a = J.Cache.get('listIndex').data;
            var b,c;
            if(a > 9){
                b = a%10;
                c = Math.floor(a/10);
            }else{
                b = a;
                c = 0;
            }
            if(type == 0){
                if(J.Cache.get('productList').data.length <=1){
                    data = J.Cache.get('productList').data[0][a];
                }else{
                    data = J.Cache.get('productList').data[c][b];
                }
            }else if(type == 1){
                if(J.Cache.get('getProductList').data.length <=1){
                    data = J.Cache.get('getProductList').data[0][a];
                }else{
                    data = J.Cache.get('getProductList').data[c][b];
                }
            }else if(type == 2){
                if(J.Cache.get('baiMingDanList').data.length <=1){
                    data = J.Cache.get('baiMingDanList').data[0][a];
                }else{
                    data = J.Cache.get('baiMingDanList').data[c][b];
                }
            }else if(type == 3){
                if(J.Cache.get('merchantList').data.length <=1){
                    data = J.Cache.get('merchantList').data[0][a];
                }else{
                    data = J.Cache.get('merchantList').data[c][b];
                }
            }else if(type == 4){
                if(J.Cache.get('searchResultList').data.length <=1){
                    data = J.Cache.get('searchResultList').data[0][a];
                }else{
                    data = J.Cache.get('searchResultList').data[c][b];
                }
            }
            var specification = [];
            var colorName = $.trim(data.colorName);
            var color = $.trim(data.color);
            var sizeName = $.trim(data.sizeName);
            var size = $.trim(data.size);
            if (colorName && colorName.length > 0) {
                var obj = {
                    name: colorName,
                    val: [""],
                    key: 'colorName'
                };
                if(color && color.length > 0){
                    obj.val = color.split(",");
                }
                specification.push(obj);
            }
            if (sizeName && sizeName.length > 0) {
                var obj = {
                    name: sizeName,
                    val: [""],
                    key: 'sizeName'
                };
                if(size && size.length > 0){
                    obj.val = size.split(",");
                }
                specification.push(obj);
            }
            data.specification = specification;
            isHaveSpecification_control(data,sec);
        },10);
}
//常购清单----添加购物车
function fly_service(eventId,price, source,sec){
    var oftenBuy = J.Cache.get('oftenBuy').data;
    var mock = {};
    oftenBuy.map(function(item){
        if(item.id == eventId){
            if(item.canBuyNumber != 0){
                if(item.color || item.size){
                    mock.type = 0;
                    mock.color = item.color;
                    mock.size = item.size;
                }else{
                    mock.type = 0;
                    mock.color = '';
                    mock.size = '';
                }
            }else{
                J.showToast('超出可购买数量了哦');
            }
        }
    });
    if(!isEmptyObject(mock)){
        addShoppingCar_service(mock, 0, 1, eventId, price, source, sec);
    }
}
//购物车动画起始位置 列表  sec是index_section 则为分类
function createFly(sec){
    $('#' + sec + ' .cartGreen').click(function(event){
        var start,endPoint;
        var html = '<div class="flyCart" style="width : 5%"><img src="./img/cart_orange.png" style="width: 100%;" alt=""/></div>';
        var e = event;
        console.log(e);
        start = { top: e.clientY - 10, left: e.clientX - 10 };
        endPoint = $('#' + sec +' .footer_cart')[0].getBoundingClientRect();
        if(sec == 'index_section'){
            endPoint = $('#' + sec +' .footer_shopping_cart')[0].getBoundingClientRect();
        }
        var end = { top: endPoint.top, left: endPoint.left + endPoint.width / 2, width: 20, height: 20 };
        var par = {
            start : start,
            end : end,
            sec : sec,
            el : html
        };
        J.Cache.save('fly',par);
    });
}
//首页 活动页 购物车推荐 商品详情 商品添加购物车飞入动画起始位置
function floorCreateFly(sec){
    var html = '<div class="flyCart" style="width : 5%"><img src="./img/cart_orange.png" style="width: 100%;" alt=""/></div>';
    var start;
    var end;
    var endPoint;
    if(sec == 'shopCar') {
        $('#shoppingCart_article .commodity_content i').click(function(event){
            var e = event;
            start = { top: e.clientY - 10, left: e.clientX - 10 };
            endPoint = $('#index_footer .footer_shopping_cart')[0].getBoundingClientRect();
            end = { top: endPoint.top, left: endPoint.left + endPoint.width / 2, width: 20, height: 20 };
            var par = {
                start : start,
                end : end,
                sec : sec,
                el : html
            };
            J.Cache.save('fly',par);
        });
    }else{
        if(sec == 'productDetail_section'){
            $('#jingle_popup .bottomBtn').unbind("click").click(function(event){
                var e = event;
                start = { top: e.clientY - 10, left: e.clientX - 10 };
                endPoint = $('#' + sec + ' .ssssssss')[0].getBoundingClientRect();
                end = { top: endPoint.top, left: endPoint.left + endPoint.width / 2, width: 20, height: 20 };
                var par = {
                    start : start,
                    end : end,
                    sec : sec,
                    el : html
                };
                J.Cache.save('fly',par);
            });
            $('#productDetail_section .commodity_content i').unbind("click").click(function(event){
                var e = event;
                start = { top: e.clientY - 10, left: e.clientX - 10 };
                endPoint = $('#' + sec + ' .ssssssss')[0].getBoundingClientRect();
                end = { top: endPoint.top, left: endPoint.left + endPoint.width / 2, width: 20, height: 20 };
                var par = {
                    start : start,
                    end : end,
                    sec : sec,
                    el : html
                };
                J.Cache.save('fly',par);
            });
        }else{
            $('#' + sec + ' .mes i').unbind("click").click(function(event){
                var e = event;
                start = { top: e.clientY - 10, left: e.clientX - 10 };
                if(sec == 'index_section'){
                    endPoint = $('#index_footer .footer_shopping_cart')[0].getBoundingClientRect();
                }else{
                    endPoint = $('#' + sec +' .ssssssss')[0].getBoundingClientRect();
                }
                end = { top: endPoint.top, left: endPoint.left + endPoint.width / 2, width: 20, height: 20 };
                var par = {
                    start : start,
                    end : end,
                    sec : sec,
                    el : html
                };
                J.Cache.save('fly',par);
            });
        }
    }
}

//开始动画----购物车飞出
function fly(html,start,end,callback){
    ele =  $(html);
    ele.css('z-index','100');
    ele.fly({
        start: start, 
        end: end,
        onEnd: function () {
            this.destroy();
            callback();
        }
    });
}
/**
 * [addShoppingCar_service 加入购物车]
 * @param {Number} hanleType [directBuy操作类型 0.加入购物车 1.立即购买]
 * @param {Number} num       [购买数量]
 * @param {Number} eventId   [shangpinid]
 * @param {Object} source    [统计来源]
 */
function addShoppingCar_service(mock, hanleType, num, eventId, price, source, sec,ele) {
    var url = 'ws/shoppingAction' + versionMessage.version + '!addShoppingCar.sy';
    var par = {
        serviceEventId: eventId,
        num: num*1,
        directBuy: hanleType,
        realPrice:price,
        sourceName: source.sName,
        seqNumber: source.sIndex,
        subsetsSeq: source.subsetsSeq || 0,
        currencyId: page.currencyId,
        communityId: J.Cache.get('community') ? J.Cache.get('community').data.id : 1
    };
    if (J.Cache.get('homeSharePar') && J.Cache.get('homeSharePar').data) {
        par.specialStr = J.Cache.get('homeSharePar').data.specialStr;
        par.shareType = J.Cache.get('homeSharePar').data.type;
    }
    // mock.type  0.商品 1.服务预约
    if (mock.type == 0) {
        par.color = mock.color;
        par.size = mock.size;
    }
//  if(!J.Cache.get('login')) {
////  	offlineShopCar_control(par);
//  	J.showToast('您尚未登录');
//  	J.Router.goTo('#login_section');
//  	return;
//  }
//  //level 0:普通用户 1：白名单用户 2：黑名单A级 3：黑名单B级 4：黑名单C级 5：黑名单D级 6：黑名单E级
//  if (J.Cache.get('login').data.level == 2) {
//      J.showToast('此商品无法添加');
//      return;
//  }
    //白名单商品购买权限
    // if (goodsScope == 1) {
    //     if (J.Cache.get('login')) {
    //         if (J.Cache.get('login').data.level != 1) {
    //             J.showToast('此商品为会员专享商品');
    //             J.Router.goTo('#help_section');
    //             return;
    //         }
    //     }
    // }
	if(!J.Cache.get('login')) {
		// if(hanleType == 1) {
		// 	J.showToast('您还没有登录');
		// 	return;
		// }
        par.unloginId = getUnloginId();
        // J.showToast('请先登录哟~');
        // return;
    }
    service.get(url, par, function (data) {
        getGoodEvent(eventId, 15, source);
        switch (hanleType) {
            case 0:
                if(sec) {
                    if(sec == 'couponDetail_section'){
                        J.showToast('添加成功');
                        cartNum_service();
                        return;
                    }
                    if(sec == 'turnPlate_section'){
                        J.showToast('添加成功');
                        cartNum_service();
                        return;
                    }
                    if(sec == 'orderDetail_section'){
                        J.showToast('添加成功');
                        cartNum_service();
                        return;
                    }
                    if(sec == 'checkoutSuccess_section'){
                        J.showToast('添加成功');
                        cartNum_service();
                        return;
                    }
                    if(sec == 'cancelOrderComplete_section'){
                        J.showToast('添加成功');
                        cartNum_service();
                        return;
                    }
                    if(sec == 'memberCenter_section'){
                        J.showToast('添加成功');
                        cartNum_service();
                        return;
                    }
                    if(sec == 'meMemberCenter_section'){
                        J.showToast('添加成功');
                        cartNum_service();
                        return;
                    }
                    
                    if(sec == 'newGoods'){
                        if(!$(ele).hasClass('active')){
                            $('.newGoods .sp li .mes i.active').removeClass('active').html('<span>选它</span>');
                            $(ele).addClass('active').html('');
                            cartNum_service();
                        }else{
                            J.showToast('新人商品，只能购买一件');
                        }
                        return;
                    }
                    setTimeout(function(){
                        var start = J.Cache.get('fly').data.start;
                        var end = J.Cache.get('fly').data.end;
                        var html = J.Cache.get('fly').data.el;
                        if(sec == 'shopCar'){
                            fly(html,start,end,function(){
                                if(!J.Cache.get('login')) {
                                    getOfflineShoppingCar_service();
                                } else {
                                    getShoppingCar_service();
                                }
                            });
                        }else{
                            if(data.isMutex == 1){
                                $('.newGoods .sp li .mes i.active').removeClass('active').html('<span>选它</span>');
                                $('.newGoods .sp li').each(function(){
                                    var id = $(this).data().id;
                                    if (id == data.serviceEventId) {
                                        $(this).find('i').addClass('active').html('');
                                    }
                                });
                            }
                            fly(html,start,end,function(){
                                cartNum_service(J.Cache.get('fly').data.sec);
                            });
                        }
                    },10);
                }else{
                    cartNum_service();
                    J.showToast('添加成功');
                }
                if(!J.Cache.get('login')) {
                    saveOfflineShopCar(data.shoppingCarId);
                }
                break;
            case 1:
                var shoppingCarIds = [];
                shoppingCarIds.push(data.shoppingCarId);
                pay.par.shoppingCarIds = JSON.stringify(shoppingCarIds);
                pay.par.deliveryTId = '';
                pay.par.deliveryTime = '';
                pay.par.disType = '1';
                pay.param.useVipFreeFreight = 0;
                var merchantid = $("#detailLimitNum").data().merchantid;
                console.log(merchantid, 'merchantid')

                // 商品数据
                var productDetail = J.Cache.get('productDetail').data;
                pay.supDeliveryType = data.supDeliveryType;
                // 判断商户
                if (merchantid == 2) {
                    var weight = productDetail.specificationWeight * num;
                    if (weight > data.basicWeight*1) {
                        pay.par.disType = '2'
                    }
                }
                pay.clearAccount(1, merchantid, data.type);
                break;
        }
        if (mock.type == 1) J.Cache.empty('reservation');
    },function(data){
        if(data){
            if(data.code == 1){
                $(ele).addClass('bg_gray').html('<span>已抢光</span>').trigger(J.showToast('该商品已抢光'));
            }else{
                J.showToast(data.message);
            }
        }
    });
}
// //首页添加购物车图标变大
// function addShoppingCart(ele){
//     $($(ele)[0]).css('width','6vw');
//     $($(ele)[0]).css('height','6vw');
//     setTimeout(function(){
//         $($(ele)[0]).css('width','4.5vw');
//         $($(ele)[0]).css('height','4.5vw');
//     },200);
// }
// //活动页/购物车推荐商品
// function actAddShoppingCart(ele){
//     $($(ele)[0]).css('width','7vw');
//     $($(ele)[0]).css('height','7vw');
//     setTimeout(function(){
//         $($(ele)[0]).css('width','6vw');
//         $($(ele)[0]).css('height','6vw');
//     },200);
// }

// 获取服务预约
function getReservation_service(eventId, times, continueTime, years) {
    var url = 'ws/serviceAction' + versionMessage.version + '!getReservation.sy';
    var par = {
        serviceEventId: eventId,
        time: times
    };
    service.get(url, par, function (data) {
        var mock = {
            date: getFiveDate(),
            time: [],
            id: eventId,
            continueTime: continueTime
        }
        // 将数字转换成时间
        for (var k in data) {
            var h = k.length < 3 ? k.slice(0, 1) : k.slice(0, 2);
            var m = (k.length < 3 ? (k.slice(1) == 1 ? '00' : 30) : (k.slice(2) == 1 ? '00' : 30));
            var timeData = {
                time: h + ':' + m,
                num: data[k],
                timeId: par.time.split('-').join('') + k,
                dateTime: par.time + ' ' + h + ':' + m
            }

            mock.time.push(timeData);
        }
        getReservation_tpl_control(mock, years);
    })
}

// 判断是否能预约
function isAbleReserve_service(eventId, reservationTime, num) {
    var url = 'ws/shoppingAction' + versionMessage.version + '!isAbleReserve.sy';
    var par = {
        serviceEventId: eventId,
        reservationTime: reservationTime
    }
    service.get(url, par, function (data) {
        var mock = {
            type: 1,
            reservationTime: reservationTime
        }
        if(num < 0) {
			num = num * -1;
		}
        addShoppingCar_service(mock, 1, num, eventId, price);
    })
}

// 分享后成功回调
function shareContent_service() {
    var url = 'ws/othersAction' + versionMessage.version + '!shareContent.sy';
    var par = {};
    service.get(url, par, function (data) {

    })
}

// 新的分享功能分享成功后分享人获得积分 
// type： 分享类型 1领券分享   2抽奖分享  3商品分享   4支付完成分享    5评价订单分享
function shareBenefit_service(type) {
    var url = 'ws/shareRuleAction' + versionMessage.version + '!shareBenefit.sy';
    var par = {
        shareType: type
    };
    service.get(url, par, function (data) {
        if (type == 2) {
            getPrize_service()
        }
    })
}
//验证码
function getCodeForQuickLogin(elements){
    var url =  serverUrl + 'ws/userAction' + versionMessage.version + '!doNotNeedSessionAndSecurity_sendCaptchaForQuickLogin.sy';
    var phone = $(elements).parent().find('input[name=phone]').val();
    if (verifyPhone(phone)) {
        var par = {
            phone: phone
        };
        $.getJSON(url, par, function(data) {
            if (data.success) {
                $(elements).removeAttr('onclick');
                quickLoginCount(elements);
            } else {
                J.showToast(data.message);
                $(elements).parent().find('input[name=phone]').val('');
            }
        });
    }
}
//快捷登录
function quickLogin_service(mock){
    var url = 'ws/userAction' + versionMessage.version + '!doNotNeedSessionAndSecurity_quickLogin.sy';
    if(J.Cache.get('inviteParam') && J.Cache.get('inviteParam').data){
        mock.inviter = J.Cache.get('inviteParam').data;
    }
    service.get(url,mock,function(data){
        if(data.isSuccess == 1) {
            $('#jingle_popup_mask').hide();
            $('#jingle_popup').hide();
            $('#quickLoginDiv input[type=text]').val('');
            var loginForm = {
                phone : data.userInfo.phone,
                userPwd : data.userInfo.password
            };
            // 统计绑定手机号
            _dataStatistics.phone = data.userInfo.phone;
            J.Cache.save('login', data.userInfo);
            J.Cache.save('loginForm', loginForm);
            J.showToast('登录成功');
            setTimeout(function () {
                // 绑定用户设备信息
                // getVersionMessage_service();
                // 注册成功后绑定离线购物车
                bindShoppingCarWithUserId_service();
            },500);
            if(!isWechatClient()) bindJpushAcInfo();
        } else {
            J.showToast(data.msg);
        }
    });
}

// 取消订单的banner图
function getExtensionAdvert() {
    var url = 'ws/extensionAdvertAction' + versionMessage.version + '!getExtensionAdvert.sy';
    var par = {
        communityId: J.Cache.get('community').data.id
    };
    service.get(url, par, function(data){
        if(data && data.extensionAdvertList && data.extensionAdvertList.length > 0){
            $('#cancelOrderSlide').css('display','block');
            data.extensionAdvertList.map(function(item){
                item.pics = picNetworkPrefix(item.pics);
            })
            J.Template.render("#cancelOrderSlide", "slideDiv_template", data.extensionAdvertList, "replace");
            switch (data.extensionSize) {
                case 1:
                    $('#cancelOrderSlide').addClass('size_small');
                    $('#cancelOrderSlide .slide_advert').addClass('size_small');
                    break;
                case 2:
                    $('#cancelOrderSlide').addClass('size_middle');
                    $('#cancelOrderSlide .slide_advert').addClass('size_middle');
                    break;
                case 3:
                    $('#cancelOrderSlide').addClass('size_big');
                    $('#cancelOrderSlide .slide_advert').addClass('size_big');
                    break;
                default:
                    break;
            }

            if(data.extensionAdvertList.length > 1){
                // if(scrollAdvert && scrollAdvert.scroll) delete scrollAdvert.scroll.box;
                scrollAdvert = Viwepager('#cancelOrderSlide ul', {
                    loop: true, //循环切换
                    auto: true, //自动切换
                    callback: function(ind) { //这里传过来的是索引值
                        $('#cancelOrderSlide ol li').eq(ind).addClass('active').siblings().removeClass('active');
                    }
                });
            }else{
                $('#cancelOrderSlide div.page').css('display','none');
            }
        }else{
            $('#cancelOrderSlide').css('display','none');
        }
    },function(){
        $('#cancelOrderSlide').css('display','none');
    });
}

// 我的页面banner图
function myExtensionAdvert() {
    var url = 'ws/extensionAdvertAction' + versionMessage.version + '!getExtensionAdvert.sy';
    var par = {
        communityId: J.Cache.get('community').data.id
    };
    service.get(url, par, function(data){
        if(data && data.extensionAdvertList && data.extensionAdvertList.length > 0){
            $('#slideDiv').css('display','block');
            data.extensionAdvertList.map(function(item){
                item.pics = picNetworkPrefix(item.pics);
            })
            data.extensionAdvertList[0].hasActive = true;
            J.Template.render("#slideDiv", "slideDiv_template", data.extensionAdvertList, "replace");
            switch (data.extensionSize) {
                case 1:
                    $('#slideDiv').addClass('size_small');
                    $('#slideDiv .slide_advert').addClass('size_small');
                    break;
                case 2:
                    $('#slideDiv').addClass('size_middle');
                    $('#slideDiv .slide_advert').addClass('size_middle');
                    break;
                case 3:
                    $('#slideDiv').addClass('size_big');
                    $('#slideDiv .slide_advert').addClass('size_big');
                    break;
                default:
                    break;
            }
            if(data.extensionAdvertList.length > 1){
                if(scrollAdvert && scrollAdvert.scroll) delete scrollAdvert.scroll.box;
                scrollAdvert = Viwepager('#slideDiv ul', {
                    loop: true, //循环切换
                    auto: true, //自动切换
                    callback: function(ind) { //这里传过来的是索引值
                        $('#slideDiv ol li').eq(ind).addClass('active').siblings().removeClass('active');
                    }
                });
            }else{
                $('#slideDiv div.page').css('display','none');
            }
        }else{
            $('#slideDiv').css('display','none');
        }
    },function(){
        $('#slideDiv').css('display','none');
    });
}