var service = (function() {

    // HTTP常见请求状态
    var statusCode = {
        '400': 'Bad Request',
        '401': 'Unauthorized',
        '403': 'Forbidden',
        '404': 'Not Found',
        '405': 'Method Not Allowed',
        '500': 'Not Implemented',
        '501': 'Not Implemented',
        '502': 'Bad Gateway',
        '503': 'Service Unavailable',
        '504': 'Gateway Timeout',
        '505': 'HTTP Version Not Supported '
    }

    /**
     * [getAjax ajax请求]
     * @param  {String}   action   [http请求action地址]
     * @param  {Object}   param    [接口请求参数]
     * @param  {Function} successCall [成功的回调函数]
     * @param  {Function} errorCall [失败的回调函数]
     * @param  {Number}   time     [请求超时时间设定]
     */
    function getAjax(action, param, successCall, errorCall, time) {
        $.ajax({
            url: serverUrl + action,
            data: param,
            dataType: "json",
            timeout: time || 55000,
            success: function(data, status, xhr) {
            	showErrorPage = false; // 显示错误页面
                if (data.success) {
                    successCall(data.data, data.message);
                } else {
                    if (errorCall) {
                        errorCall(data, xhr);
                    } else {
                        error(xhr, data, action, param);
                    }
                }
            },
            error: function(xhr) {
                error(xhr, '', action);
            },
        })
    }

    /**
     * [error 接口请求错误]
     * @param  {Object} xhr     [xhr对象]
     * @param  {String} message [报错信息]
     */
    function error(xhr, data, action, param) {
    	showErrorPage = true;
        J.hideMask();
        var msg = '';
        if(!J.Cache.get('login')){
        	try{
        		if(param.communityId){
	                return;
        		}
        	}catch(e){
//      		console.log(e);
        	}
        }
        if (data) {
        	showErrorPage = false;
            msg = (isNullString(data.message)) ? (xhr.status != 200 ? statusCode[xhr.status] : '连接出错') : data.message;
            if (data.code == -1) {
                if(J.Cache.get('loginForm')){
                    // 这边还是有点问题
                    userAutoLogin_control();
                }else{
                    J.Router.goTo('#login_section');
                    J.Cache.empty('loginForm');
                    J.Cache.empty('login');
                    setTimeout(function(){
                        $('#loginBack_button').attr('data-back',true);
                    },300)
                    J.showToast(msg);
                }
//              if(location.hash == '#index_section') {
//		        	J.Router.goTo("#error_section");
//		        } else {
		        	J.showToast(msg)
//		        }
            } else {
            	J.showToast(msg);
            }
        } else {
            console.log(xhr.status)
            msg = statusCode[xhr.status];
            // J.showToast(msg);
            if(xhr.status == 0){
                // 跳转去下载
                console.log(isAndroidIosApp())
                if (isAndroidIosApp()) {
                    $.get("https://wei.vipxiaoqu.com/ws/othersAction20170807!getAppVersion.sy?", function(data) {
                        var data = JSON.parse(data).data;
                        var version;
                        if (isIOS()) {
                            version = data.iosVersion;
                        } else {
                            version = data.androidVersion;
                        }
                        if (checkVersion(version, AppVersion.version)) {
                            J.Router.goTo("#updatePage_section");
                        } else {
                            J.Router.goTo("#error_section"); 
                        }
                    })
                }else{
                    if(location.hash == '#index_section' && showErrorPage) {
                        if (action.indexOf('getHome.sy') >= 0) {
                            J.Router.goTo("#error_section");
                        }
                    }
                }
            }else{
                if(location.hash == '#index_section' && showErrorPage) {
                    if (action.indexOf('getHome.sy') >= 0) {
                        J.Router.goTo("#error_section");
                    }
                }
            }
        }

    }
    return {
        get: getAjax,
        error: error,
    }
})(J.$)
