/***
 * getShoppingCar_service   获取购物车商品
 * @param param 编辑购物车商品后的请求 不请求推荐商品
 */
function getShoppingCar_service(param) {
	$("#classification_article").children('header').attr('value',true); //分类是否刷新显示
	var url = 'ws/shoppingAction' + versionMessage.version + '!getShoppingCar.sy';
    var par = {};
    if(J.Cache.get('address') && J.Cache.get('address').data){
        par.communityId = J.Cache.get('address').data.communityId;
    }else{
        par.communityId = 1;
    }
    if(J.Cache.get('openId')) par.openId = J.Cache.get('openId').data;
    cartNum_service();
	service.get(url, par, function(res) {
        var data = res.scInfo;
        // 品类满减
        pay.cateInfo = res.cateInfo;
        // 支持的配送方式
        pay.supDeliveryType = res.supDeliveryType;
        // 支持多少个商户同时支付
        pay.limit = res.limit;

        pay.transfer = res.transfer;
        if(data == null || data.length == 0){
            $('#shoppingCar_article').css('display','none');
            // $('#shoppingCart_article header').css('height','64px');
            $('#shoppingCarPic').css('display','block');
            $('#shoppingCartLikesRelate_div').empty();
            $('#payMoney').addClass('notClick');
            getTop20ServiceEvent();//购物车没有商品时候推荐销量top20商品
        }else{
            $('#shoppingCar_article').css('display','block');
            // $('#shoppingCart_article header').css('height','50vw');
            $('#shoppingCarPic').css('display','none');
            $('#payMoney').removeClass('notClick');
            data.map(function(e) {
                e.value.map(function(item) {
                    if (!isNullString(item.serviceEvent.picture)) item.serviceEvent.picture = picNetworkPrefix(item.serviceEvent.picture);
                    var specification = [];
                    var colorName = $.trim(item.serviceEvent.colorName);
                    var color = $.trim(item.serviceEvent.color);
                    var sizeName = $.trim(item.serviceEvent.sizeName);
                    var size = $.trim(item.serviceEvent.size);
                    if (colorName && colorName.length > 0) {
                        var obj = {
                            name: colorName,
                            val: [""],
                            key: 'colorName'
                        };
                        if(color && color.length > 0){
                            obj.val = color.split(",");
                        }
                        specification.push(obj);
                    }
                    if (sizeName && sizeName.length > 0) {
                        var obj = {
                            name: sizeName,
                            val: [""],
                            key: 'sizeName'
                        };
                        if(size && size.length > 0){
                            obj.val = size.split(",");
                        }
                        specification.push(obj);
                    }
                    if(item.serviceEvent.priceInUse && item.serviceEvent.priceInUse.indexOf('线上特惠') > -1){
                        item.serviceEvent.discountsPrice = true;
                    }else{
                        item.serviceEvent.discountsPrice = false;
                    }
                    if(item.serviceEvent.priceNotInUse && item.serviceEvent.priceNotInUse != null){
                        item.serviceEvent.priceNotInUse = '¥' + item.serviceEvent.priceNotInUse.split('¥')[1];
                    }
                    item.serviceEvent.specification = specification;
                    if(item.serviceEvent.serviceEventMarkPic){
                        item.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item.serviceEvent.serviceEventMarkPic);
                    }
                });
            });
            acquireCarriage();
            getShoppingCar_control(data);
            if(data && data.length > 0 ){
                var id = data[0].value[0].serviceEvent.id;
                if(!param){
                    getRelateServiceEvent_service(id,data,3);
                }
            }else{
                $('#shoppingCartLikesRelate_div').empty();
            }
		}
	},function(data){
	    if(isNullString(data.message)){
            J.showToast('请求出错啦');
        }else {
            $('#userInfo_div').attr('data-refresh','true');
            J.showToast(data.message);
        }
    });
}
//购物车获取运费
function acquireCarriage(){
    var url = 'ws/shoppingAction' + versionMessage.version + '!getFreightFreeLimit.sy';
    var par = {};
    service.get(url,par,function(data){
        J.Cache.save('disTypeRule',data.selfTakingThresholdPrice);//自提门槛
        if(data.minimumDeliveryAmount >= 0){
            if (data.freightRuleShowSwitch == 1) {
                // $('#addOnTip').css('display','block');
                // $('#orderAmount').text(data.minimumDeliveryAmount);
            }
            // J.Cache.save('deliveryFreight',data.minimumDeliveryAmount);
            var deliveryFreight = [];
            data.suguoFreightRules.map(function(val){
                var datas = {};
                datas.freight = val.freight - val.wtySubsidyPrice;
                datas.price = val.price2;
                deliveryFreight.push(datas);
            });
            J.Cache.save('deliveryFreight',deliveryFreight);
            J.Cache.save('freightText',data.freightRuleTest);
            if(window.location.href.indexOf('#index_section') >= 0){
                countTotal_control();
            }
        }
    });
}

// 编辑购物车
function editShoppingCar_service(mock, handle) {
	var url = 'ws/shoppingAction' + versionMessage.version + '!editShoppingCar.sy';
	var par = {
		editShoppingCarParams: JSON.stringify(mock)
	};
	service.get(url, par, handle['success'], handle['error']);
}

/**
 * deleteShoppingCar_service  删除购物车商品
 * mock   购物车id
 */
function deleteShoppingCar_service(mock,callback) {
	var url = 'ws/shoppingAction' + versionMessage.version + '!deleteShoppingCar.sy';
	var par = {
		shoppingCarIds: JSON.stringify(mock)
	};
	service.get(url, par, function() {
        cartNum_service();
        callback();
	});
}
/**
 * deleteShoppingCar_service  删除失效商品
 * mock   商品id: id，商品数量：num
 */
function deleteInvalidEvents_service(mock){
    var url = 'ws/shoppingAction' + versionMessage.version + '!rvFailureGoods.sy';
    var par = {
        invaliShopping: JSON.stringify(mock)
    };
    service.get(url,par,function(){
        $("#shoppingCar_article ul.invalidList").remove();
        cartNum_service();
    })
}

/***
 * getOfflineShoppingCar_service   获取离线购物车商品
 * @param param 编辑购物车商品后的请求 不请求推荐商品
 */
function getOfflineShoppingCar_service(param) {
	console.log('离线购物车');
//	$("#classification_article").children('header').attr('value',true); //分类是否刷新显示
	var url = 'ws/shoppingAction' + versionMessage.version + '!getShoppingCarWithoutLogin.sy';
	if(!J.Cache.get('offlineShopCar')) {
//		J.showToast('购物车里没有商品');
//		return;
		J.Cache.save('offlineShopCar', []);
	}
	var par = {
		shoppingCarIds: J.Cache.get('offlineShopCar').data.toString(),
		communityId: 1
    };
    if(J.Cache.get('community') && J.Cache.get('community').data){
        par.communityId = J.Cache.get('community').data.id;
    }
    cartNum_service();
	service.get(url, par, function(data) {
        if(data == null || data.length == 0){
            $('#shoppingCar_article').css('display','none');
            // $('#shoppingCart_article header').css('height','64px');
            $('#shoppingCarPic').css('display','block');
            $('#shoppingCartLikesRelate_div').empty();
            getTop20ServiceEvent();//购物车没有商品时候推荐销量top20商品
        }else{
            $('#shoppingCar_article').css('display','block');
            // $('#shoppingCart_article header').css('height','50vw');
            $('#shoppingCarPic').css('display','none');
            if(!data) data = [];
            data.map(function(e) {
                e.value.map(function(item) {
                    if (!isNullString(item.serviceEvent.picture)) item.serviceEvent.picture = picNetworkPrefix(item.serviceEvent.picture);
                    var specification = [];
                    var colorName = $.trim(item.serviceEvent.colorName);
                    var color = $.trim(item.serviceEvent.color);
                    var sizeName = $.trim(item.serviceEvent.sizeName);
                    var size = $.trim(item.serviceEvent.size);
                    if (colorName && colorName.length > 0) {
                        var obj = {
                            name: colorName,
                            val: [""],
                            key: 'colorName'
                        };
                        if(color && color.length > 0){
                            obj.val = color.split(",");
                        }
                        specification.push(obj);
                    }
                    if (sizeName && sizeName.length > 0) {
                        var obj = {
                            name: sizeName,
                            val: [""],
                            key: 'sizeName'
                        };
                        if(size && size.length > 0){
                            obj.val = size.split(",");
                        }
                        specification.push(obj);
                    }
                    if(item.serviceEvent.priceNotInUse && item.serviceEvent.priceNotInUse != null){
                        if(item.serviceEvent.priceNotInUse.indexOf('原价:') >= 0){
                            item.serviceEvent.priceNotInUse = item.serviceEvent.priceNotInUse.split('原价:')[1];
                        }
                    }
                    item.serviceEvent.specification = specification;
                    if(item.serviceEvent.serviceEventMarkPic){
                        item.serviceEvent.serviceEventMarkPic = picNetworkPrefix(item.serviceEvent.serviceEventMarkPic);
                    }
                });
            });
            acquireCarriage();
            getShoppingCar_control(data);
            if(data && data.length > 0){
                var id = data[0].value[0].serviceEvent.id;
                if(!param){
                    getRelateServiceEvent_service(id,data,3);
                }
            }else{
                $('#shoppingCartLikesRelate_div').empty();
            }
		}
	},function(data){
        if(isNullString(data.message)){
            J.showToast('请求出错啦');
        }else {
            J.showToast(data.message);
        }
    });
}

// 登录成功之后将离线购物车绑定用户
function bindShoppingCarWithUserId_service() {
	if(!J.Cache.get('offlineShopCar')) {
		return;
	}
	var par = {
		shoppingCarIds: J.Cache.get('offlineShopCar').data.toString()
	};
	var url = 'ws/shoppingAction' + versionMessage.version + '!bindShoppingCarWithUserId.sy';
	service.get(url, par, function(data) {
        getShoppingCar_service();
		J.Cache.empty('offlineShopCar');
	})
}
