document.addEventListener("deviceready", onDeviceReady, false);

function onDeviceReady() {
    // 输入框问题
    document.addEventListener("touchend", function(el) {
        console.log(el.target.tagName)
        if(el.target.tagName != 'INPUT' && el.target.tagName != 'TEXTAREA') {
            document.activeElement.blur();
        }
    }, false);
    document.addEventListener("resume", onResume, false);
    navigator.splashscreen.hide();
}

function onResume() {
    try {
        //android更新插件
        if (device.platform == "Android") {
            window.plugins.jPushPlugin.setBadge(0);
        } else {
            window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
        }
    } catch (e) {}
}

// 更新的东西（热更新和更新提醒）
function onResumeUpdate() {
    
}

var App = (function() {
    var pages = {};
    var run = function() {
        console.log(location.href)
        if(location.href.indexOf("from") >= 0) {
            location.href = location.href.slice(0, location.href.indexOf("?from")) + location.href.slice(location.href.indexOf("#"))
        }
        // app运行时,获取设备信息
        try {
            deviceAndCache();
        } catch (error) {

        }
        $.each(pages, function(k, v) {
            var sectionId = '#' + k + '_section';
            $('body').delegate(sectionId, 'pageinit', function() {
                v.init && v.init.call(v);
            });
            $('body').delegate(sectionId, 'pageshow', function(e, isBack) {
                //页面加载的时候都会执行
                v.show && v.show.call(v);
                //后退时不执行
                if (!isBack && v.load) {
                    v.load.call(v);
                }
            });
        });
        J.Transition.add('flip', 'slideLeftOut', 'flipOut', 'slideRightOut', 'flipIn');
        
        Jingle.launch({
            showWelcome: true,
            welcomeSlideChange: function(i) {
                switch (i) {
                    case 0:
                        $('.slideWrapper').children().removeClass('active');
                        //                      J.anim('#welcome_jingle', 'welcome_jinlge', 1000);
                        break;
                    case 1:
                        $('.slideWrapper').children().removeClass('active');
                        $('.slideWrapper').children().eq(i).addClass('active');
                        break;
                    case 2:
                        $('.slideWrapper').children().removeClass('active');
                        $('.slideWrapper').children().eq(i).addClass('active');
                        break;
                    case 3:
                        $('.slideWrapper').children().removeClass('active');
                        $('.slideWrapper').children().eq(i).addClass('active');
                        break;
                }
            },
            showPageLoading: false,
            remotePage: {
                '#about_section': 'remote/about_section.html'
            }
        });
    };
    var page = function(id, factory) {
        return ((id && factory) ? _addPage : _getPage).call(this, id, factory);
    }
    var _addPage = function(id, factory) {
        pages[id] = new factory();
    };
    var _getPage = function(id) {
            return pages[id];
        }
        //动态计算chart canvas的高度，宽度，以适配终端界面
    var calcChartOffset = function() {
        return {
            height: $(document).height() - 44 - 30 - 60,
            width: $(document).width()
        }

    }
    return {
        run: run,
        page: page,
        calcChartOffset: calcChartOffset
    }
}());



$(function() {
    App.run();
})
